function Alert(params){
    this.alert = null;
    this.templates = {
        alert: '<div class="alert">{content}<a href="#" class="alert_close"></a></div>',
        text: '<div class="alert_text">{content}</div>'
    };
    this.init = function(params){
        /* append */
        var text = this.templates.text.format({content: params && params.text ? params.text : ''}),
            html = this.templates.alert.format({content: text});
        $(document.body).append(html);
        this.alert = $(document.body).find('.alert');

        /* set settings */
        if (params) {
            this.alert.css({
                height: params.height ? params.height : '',
                width: params.width ? params.width : '',
                transitionDuration: params.transitionDuration ? params.transitionDuration : ''
            });
        }
        /* hide */
        var height = this.alert.outerHeight();
        this.alert.css('bottom', -height);
    };
    this.toggleShow = function(text){
        var o = this;
        if (!this.alert) {
            this.init();
        }

        if (text) {
            this.alert.find('.alert_text').text(text);
        }

        if (!this.alert.hasClass('shown')) {
            this.alert.addClass('transition shown');
            setTimeout(function(){
                o.alert.fadeOut(2000, function(){
                    $(this).removeClass('shown').fadeIn(1);
                });
            }, 5000);
        }
    };
}