var ERPScanAPI = {
    templates: {
        error: "<div class='error-connection'>{text}</div>"
    },
    server: {
        url: "https://erpscan-test.corp.erpscan.com",
        login: "erpscan",
        password: "erpscan1"
    },
    query: function(url, callback, data, callback_error, async) {
        var postParams = {
            sc_login: this.server.login,
            sc_password: this.server.password
        };
        data = data || {};
        async = typeof async != "undefined" ? async : true;
        for (var field in data) {
            postParams[field] = data[field];
        }
        var ts = new Date().getTime();
        var o = this;
        $.ajax({
            url: this.server.url + url + "?rnd=" + ts,
            method: "POST",
            data: postParams,
            dataType: "XML",
            async: async,
            success: callback,
            error: function(d) {
                if (d.responseText == "result not found") {
                    return false;
                }
                if (d["callback_error"]) {
                    callback_error();
                }
                var errorText = Locale.ui.common["error_connection"].format({ url: o.server.url });
                $("section.content").html(o.templates.error.format({ text: errorText }));
            }
        })
    }
};

ERPScan.API = {
    protocol: "http",
    url: localStorage.getItem("erpscan-url") || window.location.host,
    dictionaries: {},
    loadDictionaries: function(dictionaries, options) {
        var dictionariesEntities = [];
        for (var entity in dictionaries) {
            for (var i = 0; i < dictionaries[entity].length; i++) {
                dictionariesEntities.push(entity + "." + dictionaries[entity][i]);
            }
        }
        dictionariesEntities = dictionariesEntities.join(",");
        ERPScan.API.query("dictionaries", "get", {
            params: {
                fields: dictionariesEntities
            },
            callback: function(result) {
                result = result["data"]["result"];
                var dictionaries = {};
                for (var i = 0; i < result.length; i++) {
                    var entity_params = result[i].type.split(".");
                    if (typeof dictionaries[entity_params[0]] == "undefined") {
                        dictionaries[entity_params[0]] = {};
                    }
                    dictionaries[entity_params[0]][entity_params[1]] = result[i].values;
                }
                ERPScan.API.dictionaries = dictionaries;
                options.callback(dictionaries);
            }
        });
    },
    query: function(entity, method, option) {
        option = option || {};
        option.prefix = option.prefix || "api";
        option.type = option.type || "GET";
        option.callback = option.callback || function() {};
        option.url = option.url || ERPScan.API.url;
        option.headers = option.headers || {};
        option.headers["Accept-Language"] = "en-us";
        $.ajax({
            url: ERPScan.API.protocol + "://" + option.url + "/" + option.prefix + "/" + entity + "/" + method,
            method: option.type,
            data: option.params || null,
            dataType: "JSON",
            headers: option.headers || null,
            success: option.callback,
            error: function(d) {
                if (option.url != location.host) {
                    option.url = location.host;
                    ERPScan.API.query(entity, method, option);
                }
            }
        })
    }
};