function Elasticsearch(params) {
    params = params || {};
    this.host = params.host || "172.16.2.43:9200";
    this.index = params.index || "logstash-*";
    this.type = params.type || "logs";
    this.searchType = params.searchType || "query_then_fetch";
    this.query = function(queryObj, callbackSuccess, callbackError) {
        Elasticsearch.connections[this.host].search({
            index: this.index,
            search_type: this.searchType,
            type: this.type,
            body: {
                query: queryObj
            }
        }).then(function(response) {
            callbackSuccess(response.hits.hits);
        }, callbackError || null);
    };
    this.multipleQuery = function(queriesArr, callbackSuccess, callbackError) {
        Elasticsearch.connections[this.host].msearch({
            index: this.index,
            search_type: this.searchType,
            type: this.type,
            body: queriesArr
        }).then(function(response) {
            callbackSuccess(response);
        }, callbackError || null);
    };
    this.connect = function(o) {
        if (Elasticsearch.connections[o.host] == null) {
            Elasticsearch.connections[o.host] = new elasticsearch.Client({
                host: o.host
            })
        }
    }(this)
}

Elasticsearch.connections = {};