function Popup(params) {
    Popup.counter++;
    this.params = params;
    this.popupSelector = '.popup #popup-' + Popup.counter;
    this.popupShadowSelector = '#popupShadow-' + Popup.counter;
    this.templates = {
        wrap: '<div class="wrap" id="popup-{id}"><a href="#" class="close"></a><div class="content">{content}</div></div>',
        shadow: '<div id="popupShadow-{id}" class="popup-shadow {class}"></div>',
        confirmMessage: '<span class="exit-popup_text">{message}</span>',
        actions: '<div class="actions-bar"><button class="no default">No</button><button class="yes">Yes</button></div>'
    };
    this.showPopup = function(){
        var block = new Block({
            title: this.params.title,
            class: this.params.class + ' popup' || "popup",
            content: this.templates.wrap.format({
                content: this.params.content,
                id: Popup.counter
            })
        }).getHTML();
        $(document.body).append(this.templates.shadow.format({id: Popup.counter, class: this.params.shadowClass ? this.params.shadowClass : ''}) + block);
        this.handlers();
    };
    this.close = function(){
        $(this.popupSelector).closest('.block').remove();
        $(this.popupShadowSelector).remove();
        this.clearEvents();
    };
    this.showConfirmPopup = function(){
        var o = this,
            confirmClosePopup = new Popup({
            width: 300,
            height: 100,
            class: 'confirmClosePopup',
            shadowClass: 'confirmClosePopupShadow',
            title: Locale.ui.common.confirmationClosePopup.title,
            content: this.templates.confirmMessage.format({
                message: this.params.confirmation ? this.params.confirmation : Locale.ui.common.confirmationClosePopup.defaultMessage
            }) + this.templates.actions
        });
        confirmClosePopup.showPopup();
        $(document.body).on('click', confirmClosePopup.popupSelector + " .yes", function(){
            confirmClosePopup.close();
            o.close();
        });
        $(document.body).on('click', confirmClosePopup.popupSelector + " .no", function(){
            confirmClosePopup.close();
        });
    };
    this.clearEvents = function(){
        $(document.body).off("click", this.popupSelector + " .close, " + this.popupShadowSelector);
        $(document.body).off('click', this.popupSelector + " .no");
        $(document.body).off('click', this.popupSelector + " .yes");
    };
    this.handlers = function(){
        var o = this;
        $(document.body).on("click", this.popupSelector + " .close, " + this.popupShadowSelector, function(e){
            if (o.params.confirmation) {
                o.showConfirmPopup();
            } else {
                o.close();
            }
        });
    };
}

Popup.counter = 0;
