function SimpleTable(params) {
    this.params = params;
    this.data = params.data;
    this.actions = params.actions;
    this.fields = params.option.fields;
    this.templates = {
        actions: "<div class='simple_action-events'>{actions}</div>",
        action: "<div class='action' ><a href='#' class='link disabled' data-action='{dataAction}'>{action}</a></div>",
        wrap: "<div class='simple-table'>{actions}{header}{body}</div>",
        header: "<div class='simple-table-header'>{row}</div>",
        body: "<div class='simple-table-body'>{rows}</div>",
        row: "<div class='simple-table-row'>{cells}</div>",
        cell: "<div class='simple-table-cell {class}'{data_attr}>{content}</div>",
        data_attr: " data-{name}={value}"
    };
    this.generateFields = function() {
        var namespace = this.params.option.namespace,
            type = this.params.option.type,
            ticks = { },
            sorting = {},
            filters = {},
            counter = 0;

        //TODO подумать, как лучше реализовать
        // if (this.params.option.expandable === true) {
        if (this.params.ticks && this.params.ticks["__check"]) {
            sorting[counter] = false;
            filters[counter] = false;
            ticks["__check"] = counter++;
        }
        if (this.params.ticks && this.params.ticks["__addition"]) {
            sorting[counter] = false;
            filters[counter] = false;
            ticks["__addition"] = counter++;
        }
        if (this.params.ticks && this.params.ticks["__tree"]) {
            sorting[counter] = false;
            filters[counter] = false;
            ticks["__tree"] = counter++;
        }
        // }

        for (var field in Page.fields[namespace][type]) {
            var fieldDescription = Page.fields[namespace][type][field];
            var format = fieldDescription.format;
            ticks[field] = fieldDescription.visible ? counter++ : -1;
            filters[field] = Page.tableFormat[format];
            if (typeof fieldDescription.sorting != "undefined") {
                if (fieldDescription.sorting === false) {
                    sorting[counter - 1] = false;
                } else {
                    sorting[counter - 1] = "data-" + fieldDescription.sorting;
                }
            }
            if (format == "date") {
                sorting[counter - 1] = "data-ts";
            }
        }
        return {
            ticks: ticks,
            sorting: sorting,
            filters: filters
        }
    };
    this.handlers = function() {

    };
    this.init = function() {
        if (this.ticks === null) {
            this.ticks = [];
            for (var field in this.data[0]) {
                this.ticks.push(field);
            }
        }
        return this;
    };
    this.generateRow = function(i) {
        var cells = "";
        for (var field in this.fields.ticks) {
            if (this.fields.ticks.hasOwnProperty(field)) {
                var cssClass = null;
                var field_is_obj = typeof this.data[i][field] == "object" && this.data[i][field] != null;
                switch (field) {
                    case '__check':
                        cssClass = 'selPreset';
                        break;
                }
                cells += this.templates.cell.format({
                    class: cssClass ? cssClass : '',
                    data_attr: field_is_obj ? this.templates.data_attr.format({
                        name: this.data[i][field].attr.name,
                        value: this.data[i][field].attr.value
                    }) : "",
                    content: field_is_obj ? this.data[i][field].value : this.data[i][field]
                });
            }
        }
        return this.templates.row.format({ cells: cells });
    };
    this.getHTML = function() {
        var cells = "";
        this.fields = this.generateFields();
        for (var field in this.fields.ticks) {
            if (this.fields.ticks.hasOwnProperty(field)) {
                cssClass = null;
                switch (field) {
                    case 'statistic':
                        cssClass = 'statistic';
                        break;
                    case '__check':
                        var preset_field_content = '';
                        break;
                }
                var isPreset = Table.isPresetField(field);
                var is_localized_field = Locale.fields[this.params.option.namespace][this.params.option.type] && typeof Locale.fields[this.params.option.namespace][this.params.option.type][field] != "undefined" && Locale.fields[this.params.option.namespace][this.params.option.type][field] != "undefined";
                var field_title = is_localized_field ? Locale.fields[this.params.option.namespace][this.params.option.type][field] : field;
                cells += this.templates.cell.format({class: cssClass ? cssClass : '', content: isPreset ? preset_field_content : field_title });
            }
        }

        var header = this.templates.header.format({
                row: this.templates.row.format({ cells: cells })
            }),
            rows = "";
        for (var i = 0; i < this.data.length; i++) {
            rows += this.generateRow(i);
        }
        var actions = '';
        if (typeof this.actions != 'undefined') {
            for (var action in this.actions) {
                var item = this.templates.action.format({action: action, dataAction: action.toLowerCase()});
                actions += item;
            }
        }
        actions = this.templates.actions.format({actions: actions});
        return this.templates.wrap.format({
            actions: actions,
            header: header,
            body: this.templates.body.format({ rows: rows })
        });
    }
}

function Table(params) {
    this.obj = null;
    this.params = params;
    this.params.option = this.params.option || {};
    this.options = { };
    this.parserCounter = 1;
    this.fields = null;
    this.filter_types = {
        "input": "filter-input",
        // "select": "filter-select", /* escape of double appending of options in select, if have dictionnaries. */
        "datetime": "filter-datetime",
        "none": "filter-none"
    };
    this.selector = null;
    this.rowsCount = 0;
    this.table_sorter_obj = {};
    this.number = Table.number++;
    this.generateFields = function() {
        var ticks = { },
            sorting = {},
            filters = {},
            counter = 0;
        if (typeof this.params.option.namespace != "undefined") {
            var namespace = this.params.option.namespace,
                type = this.params.option.type;
            //TODO подумать, как лучше реализовать
            // if (this.params.option.expandable === true) {
            if (this.params.ticks && this.params.ticks["__check"]) {
                sorting[counter] = false;
                filters[counter] = false;
                ticks["__check"] = counter++;
            }
            if (this.params.ticks && this.params.ticks["__addition"]) {
                sorting[counter] = false;
                filters[counter] = false;
                ticks["__addition"] = counter++;
            }
            if (this.params.ticks && this.params.ticks["__tree"]) {
                sorting[counter] = false;
                filters[counter] = false;
                ticks["__tree"] = counter++;
            }
            // }
            for (var field in ERPScan.data.fields[type]) {
                var fieldDescription = ERPScan.data.fields[type][field];
                var format = fieldDescription.format;
                ticks[field] = fieldDescription.visible ? counter++ : -1;
                filters[field] = Page.tableFormat[format];
                if (typeof fieldDescription.sorting != "undefined") {
                    if (fieldDescription.sorting === false) {
                        sorting[counter - 1] = false;
                    } else {
                        sorting[counter - 1] = "data-" + fieldDescription.sorting;
                    }
                }
                if (format == "date") {
                    sorting[counter - 1] = "data-ts";
                }
            }
        } else {
            if (this.params.data[0]["__addition"] != null) {
                sorting[counter] = false;
                filters[counter] = false;
                ticks["__addition"] = counter++;
            }
            for (var field in this.params.data[0]) {
                ticks[field] = counter++;
                filters[field] = "input";
            }
        }
        return {
            ticks: ticks,
            sorting: sorting,
            filters: filters
        }
    };
    this.getHTML = function() {
        this.fields = this.generateFields();
        this.params.option.ticks_count = 0;
        this.params.option.filters = this.fields.filters;
        var preset_field_class,
            preset_field_content,
            head = "";
        for (var field in this.fields.ticks) {
            if(typeof this.params.option.deleteFields != "undefined" && this.params.option.deleteFields.indexOf(field) > -1) {
                continue;
            }
            if (this.fields.ticks.hasOwnProperty(field)) {
                if (this.fields.ticks[field] == -1) {
                    continue;
                }
                this.params.option.ticks_count++;
                switch (field) {
                    case '__addition':
                        preset_field_class = 'actions';
                        preset_field_content = '';
                        break;
                    case '__mark':
                        preset_field_class = 'mark';
                        preset_field_content = '<input type="checkbox" />';
                        break;
                    case '__check':
                        preset_field_content = '';
                        break;
                    case '__tree':
                        preset_field_content = '';
                        break;
                }
                var is_preset = Table.isPresetField(field),
                    filter_type = "filter-none";

                if (typeof this.fields.filters[field] != "undefined") {
                    filter_type = this.filter_types[this.fields.filters[field]];
                }
                var is_localized_field = typeof this.params.option.namespace != "undefined" && Locale.fields[this.params.option.namespace][this.params.option.type] && typeof Locale.fields[this.params.option.namespace][this.params.option.type][field] != "undefined" && Locale.fields[this.params.option.namespace][this.params.option.type][field] != "undefined";
                var field_title = is_localized_field ? Locale.fields[this.params.option.namespace][this.params.option.type][field] : field;
                head += Table.templates.head.sprintf(filter_type, field, field_title, is_preset ? (typeof preset_field_content != "undefined" ? preset_field_content : field_title) : field_title);
            }
        }
        head = Table.templates.row.sprintf(0, "", head);
        var table_rows = '';
        for (var i = 0; i < this.params.data.length; i++) {
            table_rows += Table.generateRow.call(this, i);
            this.rowsCount = i;
        }
        var pager = "";
        if (this.params.option.tree !== true && this.params.option.pager !== false) {
            pager = Table.templates.pager.sprintf('table-' + this.number);
        }
        var actions = "";
        if (typeof this.params.actions != "undefined") {
            for (var action in this.params.actions) {
                var items = '';
                for (var i = 0; i < this.params.actions[action].length; i++) {
                    items += Table.templates.actions.subitem.sprintf(this.params.actions[action][i]);
                }
                actions += Table.templates.actions.item.format({action: action, dataAction: action.toLowerCase()});
            }
            actions = Table.templates.actions.wrap.sprintf(actions);
        }
        return Table.templates.wrap.sprintf(this.number, this.params.option.fixed ? ' enable' : '', this.params.title ? this.params.title : '', actions, pager, head, table_rows);
    };
    this.getColumnNumber = function(name) {
        return this.selector.find("thead th[data-name=\"" + name + "\"]").index();
    };
    this.addParser = function(sorting) {
        $.tablesorter.addParser({
            id: 'parser_' + this.parserCounter,
            format: function(s, table, cell, cellIndex) {
                var $cell = $(cell);
                for (var rule in sorting) {
                    if (rule == cellIndex && sorting[rule]) {
                        return $cell.attr(sorting[rule]) || s;
                    }
                }
                return s;
            },
            parsed: false,
            type: 'text'
        });
        this.parserCounter++;
    };
    this.getHeaders = function(sorting, filters) {
        var headers = { };
        for (var rule in sorting) {
            headers[rule] = { };
            headers[rule].sorter = sorting[rule] === false ? false : 'parser_' + (this.parserCounter - 1);
            headers[rule].filter = filters[rule] === false ? false : null;
        }
        return headers;
    };
    this.filterFormatter = function(fields) {
        var rules = { };
        for (var field in fields.filters) {
            switch(fields.filters[field]) {
                case "datetime":
                    var index = fields.ticks[field];
                    rules[index] = function($cell, indx) {
                        return $.tablesorter.filterFormatter.uiDatepicker( $cell, indx, { })
                    };
                    break;
            }
        }
        return rules;
    };
    this.generateDictionariesFilters = function(fields) {
        var rules = { };
        for (var field in fields.filters) {
            switch(fields.filters[field]) {
                case "select":
                    var index = fields.ticks[field];
                    rules[index] = { };
                    var dictionary = ERPScan.data.dictionaries[this.params.option.type];
                    for (var i = 0; i < dictionary[field].length; i++) {
                        var option = typeof Locale.ui.page["fields"] != "undefined" && typeof Locale.ui.page["fields"][field] != "undefined" ? (Locale.ui.page["fields"][field][dictionary[field][i]] ? Locale.ui.page["fields"][field][dictionary[field][i]] : dictionary[field][i]) : dictionary[field][i];
                        rules[index][option] = function(e, n, f, i, $r, c, data) { return e === f; };
                    }
                    break;
            }
        }
        return rules;
    };
    this.appendExpandButtons = function(table){
        var buttons = "";
        buttons += Table.templates.button.format({class: "default", action: "expandAll", text: Locale["ui"]["common"]["blocks"]["expandAll"]});
        buttons += Table.templates.button.format({class: "default", action: "collapseAll", text: Locale["ui"]["common"]["blocks"]["collapseAll"]});
        table.prepend(Table.templates.wrapper.format({class: "expandButtons", content: buttons}));
    };
    this.build = function() {
        this.selector = $("#table-" + this.number);
        if (this.fields.sorting) {
            this.addParser(this.fields.sorting);
        }
        var widgets = [];
        if (this.fields.filtering !== false) {
            widgets.push('filter');
        }
        this.table_sorter_obj = {
            theme: Page.theme.name,
            headers: this.getHeaders(this.fields.sorting, this.fields.filters),
            widgets: widgets,
            widgetOptions: {
                filter_formatter: this.filterFormatter(this.fields),
                filter_functions: this.generateDictionariesFilters(this.fields),
                filter_placeholder : { search: '', from: 'Date from', to: 'Date to' }
            },
            emptyTo: 'none'
        };

        if (this.params.option.sort_default) {
            this.table_sorter_obj.sortList = [[ this.params.option.sort_default.column, this.params.option.sort_default.order == "desc" ? 1 : 0 ]];
        }
        this.obj = this.selector.find("table").tablesorter(this.table_sorter_obj);

        if (this.params.option.tree) {
            tablesorter.treetable({ expandable: true, column: this.params.option.treeColumn ? this.params.option.treeColumn : 0 });
            this.appendExpandButtons(this.selector);
        }

        if (this.params.option.tree !== true && this.params.option.pager !== false) {
            this.obj.tablesorterPager({
                container: $(".pager[data-table=\"#table-" + this.number + "\"]"),
                output : '{startRow} to <input type="text" class="pager-input" value="{endRow}"> of {filteredRows} entries',
                size: this.params.option.count_one_page
            });
        }
        var $table_block = this.selector.parents(".table");
        if ($.cookie('events_fixed'))
            this.fixed($table_block);
        if ($.cookie('events_linked'))
            this.link($table_block);
        this.handlers();

        $(document.body).on("keyup", ".pager .pager-input", function(e) {
            var target = $(e.target),
                val = target.val() ? target.val() : 0;
            localStorage.setItem('tablesorter-pager', '{"/assess/jobs":{"0":{"page":0,"size":'+val+'}}}');
            tablesorter.tablesorterPager({
                size: val
            });
        });
    };
    this.additionFieldFlag = true;
    this.showAllFields = function($row, option) {
        var o = this;
        if(this.additionFieldFlag) {
            this.additionFieldFlag = false;
            setTimeout(function(){
                o.additionFieldFlag = true;
            }, 400);
            option = option || { };
            $row.addClass("active");
            var row_number = $row.data("number"),
                $toggle_info = $row.find('td').first(),
                $table = this.selector.find(".tablesorter"),
                field_list = '';
            for (var field in this.fields.ticks) {
                if (!Table.isPresetField(field)) {
                    var value = this.params.data[row_number][field] != null && typeof this.params.data[row_number][field] == 'object' ? this.params.data[row_number][field].value : this.params.data[row_number][field];
                    field_list += Table.templates.addition_fields_item.sprintf(typeof this.params.option.namespace != "undefined" && Locale.fields[this.params.option.namespace][this.params.option.type][field] ? Locale.fields[this.params.option.namespace][this.params.option.type][field] : field, value);
                }
            }
            var title = option.title ? option.title : Locale.ui.common.events_table.all_fields;
            var content = option.content ? option.content : field_list;
            field_list = Table.templates.addition_fields.sprintf($row.width() + 'px', 0 + 'px', title, content);
            var width = $toggle_info.width();
            $table.find("tr.tablesorter-headerRow th").each(function() {
                var $this = $(this);
                if (!Table.isPresetField($this.data("name"))) {
                    width += $this.outerWidth();
                }
            });
            var toggleInfoHeight = $toggle_info.outerHeight();
            $toggle_info.append(field_list)
                .animate({paddingBottom: (toggleInfoHeight + $toggle_info.find(".addition-field").height()) + "px"})
                .find(".addition-field").css('top', toggleInfoHeight + 10 + 'px')
                .slideToggle(function(){
                    $toggle_info.css({paddingBottom: ($toggle_info.find(".addition-field").height() + toggleInfoHeight + 5) + "px"});
                });
            $row.find('td.cell-button').addClass('active');
        }
    };
    this.hideAllFields = function($row) {
        if(this.additionFieldFlag) {
            var o = this;
            this.additionFieldFlag = false;
            setTimeout(function(){
                o.additionFieldFlag = true;
            }, 400);
            $row.removeClass("active").find('td').first().animate({paddingBottom: 0}).find(".addition-field").slideToggle(function() {
                $(this).remove();
                $row.find('td.cell-button').removeClass('active');
            });
        }
    };
    this.showSettings = function($th) {
        $th.find(".tablesorter-header-inner").addClass("active");
        var selected_fields = '', other_fields = '';
        for (var field in this.fields.ticks) {
            if (Table.isPresetField(field) || field == 'rt')
                continue;
            if (this.fields.ticks[field] == -1) {
                other_fields += Table.templates.settings_field_other.sprintf(field, Locale.fields[this.params.option.namespace][this.params.option.type][field] ? Locale.fields[this.params.option.namespace][this.params.option.type][field] : field);
            } else {
                selected_fields += Table.templates.settings_field_selected.sprintf(field, typeof this.params.option.namespace != "undefined" && Locale.fields[this.params.option.namespace][this.params.option.type][field] ? Locale.fields[this.params.option.namespace][this.params.option.type][field] : field);
            }
        }
        var fields = Table.templates.settings.sprintf(selected_fields, other_fields);
        $th.append(fields);
        var $table_settings = $th.find(".table-settings .field-list");
        var o = this;
        $table_settings.find(".selected").sortable({axis: 'y', opacity: .5, scrollSpeed: 5, stop: function( event ) {
            var $el = $(event.toElement);
            if (!$el.hasClass('title')) {
                return false;
            }
            var field = $el.data("field");
            o.removeColumn(field, { for: 'move' });
            var index = $el.parent('.field').index();
            o.addColumn(field, index);
        }})

    };
    this.hideSettings = function() {
        this.selector.find(".table-settings").remove();
        this.selector.find("th[data-name=\"__addition\"] .tablesorter-header-inner").removeClass("active");
    };
    this.checkCanOpen = function() {
        for(var key in this.params.actions) {
            if (!params.actions[key].length > 0) {
                return false;
            }
        }
        return true;
    };
    this.addColumn = function(name, position) {
        var notPresetTh = this.selector.find("thead tr.tablesorter-headerRow th").not("[data-name^=\"__\"]");
        var column_number = notPresetTh.length;
        if (position != -1 && position != column_number) {
            notPresetTh.filter(':eq(' + position + ')').before(Table.templates.head.sprintf(this.options.filters && this.options.filters[name] != 'datetime' ? 'filter-select' : '', name, name, Locale.fields[this.params.option.namespace][this.params.option.type][name]));
        } else if (position === column_number) {
            notPresetTh.filter(':eq(' + (position - 1) + ')').after(Table.templates.head.sprintf(this.options.filters && this.options.filters[name] != 'datetime' ? 'filter-select' : '', name, name, Locale.fields[this.params.option.namespace][this.params.option.type][name]));
        } else {
            notPresetTh.filter(':last-child').after(Table.templates.head.sprintf(this.options.filters && this.options.filters[name] != 'datetime' ? 'filter-select' : '', name, name, Locale.fields[this.params.option.namespace][this.params.option.type][name]));
        }
        var i = 0,
            o = this;
        this.selector.find("tbody tr").each(function() {
            var value,
                attr;
            if (typeof o.params.data[i][name] === 'object') {
                value = o.params.data[i][name].value ? o.params.data[i][name].value : '';
                attr = Table.templates.cell_data.format({name: o.params.data[i][name].attr.name, value: o.params.data[i][name].attr.value});
            } else {
                value = o.params.data[i][name] ? o.params.data[i][name] : '';
                attr = "";
            }
            if (position != -1 && position != column_number) {
                $(this).find('td').not(".preset").filter(':eq(' + position + ')').before(Table.templates.cell.format({class: '', data: attr, content: value}));
            } else if (position === column_number) {
                $(this).find('td').not(".preset").filter(':eq(' + (position - 1) + ')').after(Table.templates.cell.format({class: '', data: attr, content: value}));
            } else {
                $(this).find('td').not(".preset").filter(':last-child').after(Table.templates.cell.format({class: '', data: attr, content: value}));
            }
            i++;
        });
        this.selector.find("table.tablesorter").trigger("updateAll");

        /*save position*/
        var notSelected = [];
        $.each(o.fields.ticks, function(key) {
            if (!o.selector.find("thead tr.tablesorter-headerRow th").is('[data-name="' + key + '"]')) {
                notSelected.push(key);
            }
        });
        o.fields.ticks = {};
        for (var i = 0; i < notSelected.length; i++) {
            o.fields.ticks[notSelected[i]] = -1;
        }
        $.each(this.selector.find("thead tr.tablesorter-headerRow th"), function() {
            o.fields.ticks[$(this).attr('data-name')] = $(this).index();
        });
    };
    this.removeColumn = function(name, option) {
        option = option || { };
        var o = this;
        var $th = this.selector.find("thead th[data-name=\"" + name + "\"]");
        var number = $th.index();
        this.selector.find("tbody tr").each(function() {
            $(this).find("td").eq(number).remove();
        });
        $th.remove();
        if (option.for != 'move') {
            this.selector.find("table.tablesorter").trigger("updateAll");
        }
        /*save position*/
        var notSelected = [];
        $.each(o.fields.ticks, function(key, val) {
            if (!o.selector.find("thead tr.tablesorter-headerRow th").is('[data-name="' + key + '"]')) {
                notSelected.push(key);
            }
        });
        o.fields.ticks = {};
        for (var i = 0; i < notSelected.length; i++) {
            o.fields.ticks[notSelected[i]] = -1;
        }
        $.each(this.selector.find("thead tr.tablesorter-headerRow th"), function() {
            o.fields.ticks[$(this).attr('data-name')] = $(this).index();
        });
    };
    this.addField = function($field) {
        var field = $field.data("field");
        var $field_list = $field.parents(".field-list");
        $field_list.find(".selected").append(Table.templates.settings_field_selected.sprintf(field, Locale.fields[this.params.option.namespace][this.params.option.type][field]));
        $field.remove();
        this.addColumn(field, -1);
    };
    this.removeField = function($field) {
        if ($field.parents('.selected').find('.field').length <= 1) {
            return false;
        }
        var field = $field.find(".title").data("field");
        var $field_list = $field.parents(".field-list");
        $field_list.find(".other").prepend(Table.templates.settings_field_other.sprintf(field, Locale.fields[this.params.option.namespace][this.params.option.type][field]));
        $field.remove();
        this.removeColumn(field, -1);
    };
    this.link = function($table_block) {
        $table_block.find(".link.enable").addClass("on");
        $.cookie('events_linked', true);
    };
    this.unLink = function($table_block) {
        $table_block.find(".link.enable").removeClass("on");
        $.cookie('events_linked', null, { expires: -1 });
    };
    this.filterApply = function(field, value) {
        var column_number = this.selector.find(".tablesorter-headerRow th[data-name=\"" + field + "\"]").index();
        var $filter = this.selector.find("select.tablesorter-filter[data-column=\"" + column_number + "\"]");
        $filter.find("option:contains(" + value + ")")[0].selected = true;
        $filter.change();
    };
    this.filterClear = function(field) {
        var column_number = this.selector.find(".tablesorter-headerRow th[data-name=\"" + field + "\"]").index();
        var $filter = this.selector.find("select.tablesorter-filter[data-column=\"" + column_number + "\"]");
        $filter.find("option:first-child")[0].selected = true;
        $filter.change();
    };
    this.showVariants = function($item) {
        $item.parents(".action-events").find(".action a.link").addClass("off");
        $item.removeClass("off").addClass("active");
        var $variants = $item.next(".action-item-variants");
        var min_width = $item.outerWidth();
        var width = $variants.outerWidth();
        if (min_width > width)
            $variants.width($item.outerWidth() - 1);
        $variants.show();
        this.selector.find("table.tablesorter").addClass("off");
    };
    this.hideVariants = function($item) {
        $item.parents(".action-events").find(".action a.link").removeClass("off");
        $item.removeClass("active");
        var $variants = $item.next(".action-item-variants");
        $variants.hide();
        this.selector.find("table.tablesorter").removeClass("off");
    };
    this.clickEventOff = function() {
        $(document.body).off("click", "#" + this.selector.attr("id") + " tr");
    };
    this.handlers = function() {
        var o = this;
        var selector_by_id = this.selector.attr("id");
        if (o.params.option.expandable !== false) {
            $(document.body).on("click", "#" + selector_by_id + " tr", function(event) {
                var $target = $(event.target);
                if ($target.hasClass("abortRowOpening") || $target.parents(".abortRowOpening").length > 0) {
                    return false;
                }
                if ($target.hasClass("addition-field") || $target.parents(".addition-field").length != 0) {
                    return false;
                }
                if ($target.is("input[type=\"checkbox\"]") || $target.parents(".select-row").length != 0) {
                    return true;
                }
                var $this = $(this);
                if ($this.hasClass("tablesorter-filter-row")) {
                    return false;
                }
                var $tr_active = o.selector.find("tr.active");
                if ($tr_active.length != 0 && !$this.hasClass("active")) {
                    o.hideAllFields($tr_active);
                }
                $this.hasClass("active") ? o.hideAllFields($this) : o.showAllFields($this);
                return false;
            });
        } else if (o.params.option.select) {
            $(document.body).on("click", "#" + selector_by_id + " tr:not('.branch')", function(event) {
                var targetRow = $(event.target).closest('tr'),
                    rows = o.selector.find("tr.active"),
                    activeRows = rows.filter(".active");
                if (targetRow.is(':not(.tablesorter-filter-row)')) {
                    if (targetRow.hasClass('active')) {
                        targetRow.removeClass('active');
                        return false;
                    }
                    activeRows.length > 0 ? rows.removeClass('active') : false;
                    targetRow.addClass('active');
                }
            });
        }
        $(document.body).on("click", "#" + selector_by_id + " th[data-name=\"__addition\"] .tablesorter-header-inner", function() {
            var $this = $(this);
            var $th = $this.parents("th");
            if ($this.hasClass("active"))  {
                o.hideSettings();
            } else {
                o.showSettings($th);
            }
            return false;
        });
        $(document.body).on("click", "#" + selector_by_id + " th[data-name=\"__addition\"] .table-settings .field-list .other a.field", function() {
            var $this = $(this);
            o.addField($this);
            return false;
        });
        $(document.body).on("click", "#" + selector_by_id + " th[data-name=\"__addition\"] .table-settings .field-list .selected a.remove", function() {
            var $field = $(this).parent(".field");
            o.removeField($field);
            return false;
        });
        $(document.body).on("click", "#" + selector_by_id + " th[data-name=\"__mark\"] input[type=\"checkbox\"]", function() {
            var marks = o.selector.find('td.select-row input[type=\"checkbox\"]');
            var checked = $(this).is(":checked");
            for (var i = 0; i < marks.length; i++) {
                marks[i].checked = checked;
            }
            var has_selected = o.selector.find(".select-row input[type=\"checkbox\"]:checked").length > 0;
            o.selector.find(".action-events")[has_selected ? "show" : "hide"]();
        });
        $(document.body).on("click", "#" + selector_by_id + " .action-events .action a.link", function() {
            if(o.checkCanOpen()) {
                var $this = $(this);
                if ($this.hasClass("active")) {
                    o.hideVariants($this);
                } else {
                    var $link_active = o.selector.find(".action-events .action a.link.active");
                    if ($link_active.length > 0) {
                        o.hideVariants($link_active);
                    }
                    o.showVariants($this);
                }
                return false;
            }
        });
        $(document.body).on("click", "#" + selector_by_id + " .select-row input[type=\"checkbox\"].table-mark", function() {
            var has_selected = o.selector.find(".select-row input[type=\"checkbox\"].table-mark:checked").length > 0;
            if (has_selected) {
                o.selector.find(".action-events").show();
                o.selector.find("h3").hide();
            } else {
                o.selector.find(".action-events").hide();
                o.selector.find("h3").show();
            }
        });
        $(document.body).on("click", "section.content.tab-all .table .action-events a.disabled", function (e) {
            e.preventDefault();
            e.stopPropagation();
        });
        $(document.body).on("click", ".table .expandButtons button", function (e) {
            var $button = $(e.target);
            if($button.data("action") == "expandAll") {
                $button.closest(".table").find(".tablesorter").treetable("expandAll");
            } else if($button.data("action") == "collapseAll") {
                $button.closest(".table").find(".tablesorter").treetable("collapseAll");
            }
        });
    };
    this.updatePager = function() {
        tablesorter.tablesorterPager({
            container: $(".pager[data-table=\"#table-" + this.number + "\"]"),
            output : '{startRow} to <input type="text" class="pager-input" value="{endRow}"> of {filteredRows} entries',
            size: this.params.option.count_one_page
        });
    };
}

Table.generateRow = function (i) {
    var preset_field_class,
        preset_field_content,
        table_row = "";
    for (var field in this.fields.ticks) {
        if(typeof this.params.option.deleteFields != "undefined" && this.params.option.deleteFields.indexOf(field) > -1) {
            continue;
        }
        if (this.fields.ticks.hasOwnProperty(field)) {
            if (this.fields.ticks[field] == -1)
                continue;
            var value = this.params.data[i][field] ? this.params.data[i][field] : '',
                attr = "",
                cellClass = "";
            if (typeof this.params.data[i][field] == "object" && this.params.data[i][field] != null) {
                value = this.params.data[i][field].value ? this.params.data[i][field].value : "";
                if(typeof this.params.data[i][field].attr != "undefined") {
                    attr = Table.templates.cell_data.format({name: this.params.data[i][field].attr.name, value: this.params.data[i][field].attr.value});
                }
                if(typeof this.params.data[i][field].cellClass != "undefined") {
                    cellClass = this.params.data[i][field].cellClass;
                }
            }
            switch (field) {
                case '__addition':
                    preset_field_class = 'toggle-info preset';
                    preset_field_content = this.params.option.tree ? '' : '<a href="#"></a>';
                    break;
                case '__mark':
                    preset_field_class = 'select-row preset selPreset';
                    break;
                case '__check':
                    preset_field_class = 'select-row preset selPreset';
                    break;
                case '__tree':
                    preset_field_class = 'tree-icon';
                    break;
            }
            table_row += Table.templates.cell.format({class: Table.isPresetField(field) ? preset_field_class : cellClass, data: attr, content: Table.isPresetField(field) ? (preset_field_content ? preset_field_content : value): value});
        }
    }
    var hierarchy = "";
    if (this.params.option.tree === true) {
        hierarchy = Table.templates.row_hierarchy.sprintf(this.params.data[i]._id) + (this.params.data[i]._parent ? " data-tt-parent-id=\"" + this.params.data[i]._parent + "\"" : "");
    }
    return Table.templates.row.sprintf(i, hierarchy, table_row);
};

Table.isPresetField = function(field) {
    return field.substr(0,2) == '__' || field === '';
};
Table.number = 1;
Table.templates = {
    actions: {
        wrap: '<div class="action-events">%s</div>',
        item: '<div class="action" ><a href="#" class="link" data-action="{dataAction}">{action}</a></div>',
        subwrap: '<div class="action-item-variants">%s</div>',
        subitem: '<a href="#" class="action-item-variant">%s</a>'
    },
    pager: '<div class="pager" data-table="#%s">' +
    '<a href="#" class="prev"></a>' +
    '<span class="pagedisplay"></span>' +
    '<a href="#" class="next"></a>' +
    '</div>',
    wrap: '<div class="table table-wrapper" id="table-%d">'+
    '<iframe class="blockResize"></iframe>' +
    '<div class="chart-actions"><a href="#" class="link%s"></a><a href="#" class="add"></a></div>' +
    '<h3>%s</h3><div class="actions-bar">%s%s</div>' +
    '<table class="tablesorter"><thead><tr>%s</tr></thead><tbody>%s</tbody></table>' +
    '</div>',
    head: '<th class="%s" data-name="%s" data-placeholder=" -- Filter by %s -- ">%s</th>',
    row: '<tr data-number="%d"%s>%s</tr>',
    row_hierarchy: ' data-tt-id="%s"',
    cell: '<td class="{class}" {data}>{content}</td>',
    cell_data: ' data-{name}="{value}"',
    shadow: '<div class="shadow" style="width: %s; height: %s;"></div>',
    addition_fields: '<div class="addition-field" style="width: %s; margin-left: -%s;"><div class="arrow"></div><div class="title">%s</div>%s</div>',
    addition_fields_item: '<div class="addition-field-item"><div class="addition-field-name">%s</div><div class="addition-field-value">%s</div></div>',
    settings: '<div class="table-settings"><div class="field-list"><div class="selected">%s</div><div class="other">%s</div></div></div>',
    settings_field_selected: '<div class="field"><a href="#" class="remove"></a><span class="title" data-field="%s">%s</span></div>',
    settings_field_other: '<a href="#" class="field" data-field="%s">%s</a>',
    wrapper: "<div class='{class}'>{content}</div>",
    button: "<button class='{class}' data-action='{action}'>{text}</button>"
};