function Tabs(params){
    this.number = ++Tabs.counter;
    this.params = params;
    this.locale = params.locale;
    this.container = params.container;
    this.templates = {
        wrap: '<div class="tabsWrapper" id="tabsWrapper-{id}">{content}</div>',
        tabsBlock: '<div class="block-tabs">{tabs}</div>',
        contentBlock: '<div class="block-content-wrapper"><div class="block-content">{contents}</div></div>',
        tab: '<a href="#" data-name="{dataName}" class="block-tab {class}">{tabName}</a>',
        content: '<div data-name="{dataName}" class="block-content-tab {class}">{content}</div>'
    };
    this.getHTML = function(){
        var o = this,
            tabs = '',
            contents = '',
            html = '',
            first = true;
        $.each(this.params.tabs, function(tabName, content){
            tabs += o.templates.tab.format({class: first ? 'active' : '', dataName: tabName, tabName: typeof o.locale[tabName] == 'object' ? (o.locale[tabName].name ? o.locale[tabName].name : tabName) : (typeof o.locale[tabName] == 'undefined' ? tabName : o.locale[tabName])});
            contents += o.templates.content.format({class: first ? 'active' : '', dataName: tabName, content: content});
            first = false;
        });
        html += this.templates.tabsBlock.format({tabs: tabs});
        html += this.templates.contentBlock.format({contents: contents});
        html = this.templates.wrap.format({id: Tabs.counter, content: html});
        return html;
    };
    this.clearEvents = function(){
        $(document.body).off('click','#tabsWrapper-' + Tabs.counter + ' .block-tabs a');
    };
    this.build = function() {
        var $wrapper = $('#tabsWrapper-' + this.number),
            $tabs = $wrapper.find(".block-content-tab");
        $wrapper.width(Math.round($wrapper.width()));
        $tabs.css("width", "calc(100% / {tabsNumber})".format({
            tabsNumber: $tabs.length
        }));
        $wrapper.find(".block-content").css("width", "calc(100% * {tabsNumber})".format({
            tabsNumber: $tabs.length
        }));
    };
    this.handlers = function() {
        var o = this,
            number = Tabs.counter;
        $(document.body).on('click','#tabsWrapper-' + Tabs.counter + ' .block-tabs a', function() {
            var $this = $(this),
                $wrapper = $('#tabsWrapper-' + number),
                $targetTab = $wrapper.find(".block-content-tab[data-name=\"" + $this.data("name") + "\"]"),
                tabIndex = $targetTab.index();
            $('#tabsWrapper-{number} .block-tabs a, #tabsWrapper-{number} .block-content .block-content-tab'.format({
                number: number
            })).removeClass("active");
            $this.addClass("active");
            $targetTab.addClass("active");
            $wrapper.find(".block-content-wrapper").animate({scrollLeft: tabIndex * $targetTab.width()}, 500);
            return false;
        });
    }();
}

Tabs.counter = 0;