function FuturesTree() {
    this.init = function() {
        $("section.content").html('<div id="mynetwork" style="height: 600px"></div>');
        var nodes = null;
        var edges = null;
        var network = null;

        function destroy() {
            if (network !== null) {
                network.destroy();
                network = null;
            }
        }

        function draw() {
            destroy();
            nodes = [];
            edges = [];
            var connectionCount = [];

            // randomly create some nodes and edges
            nodes.push({id: 0, label: "Assess"});
            nodes.push({id: 1, label: "Monitor"});
            nodes.push({id: 2, label: "Detect"});
            nodes.push({id: 3, label: "Respond"});
            nodes.push({id: 4, label: "Remediate"});
            nodes.push({id: 5, label: "Administration"});
            nodes.push({id: 6, label: "Assets"});
            nodes.push({id: 7, label: "Projects"});
            nodes.push({id: 8, label: "Results"});
            nodes.push({id: 9, label: "Policies"});
            nodes.push({id: 10, label: "Main"});
            nodes.push({id: 11, label: "Issues"});
            nodes.push({id: 12, label: "Compliance"});
            nodes.push({id: 13, label: "Threat map"});
            nodes.push({id: 14, label: "Search"});
            nodes.push({id: 15, label: "User behaviour"});
            nodes.push({id: 16, label: "Events"});
            nodes.push({id: 16, label: "Asset manager"});
            nodes.push({id: 16, label: "Landscape manager"});
            edges.push({from: 0, to: 6});
            edges.push({from: 0, to: 7});
            edges.push({from: 0, to: 8});
            edges.push({from: 0, to: 9});
            edges.push({from: 1, to: 10});
            edges.push({from: 1, to: 11});
            edges.push({from: 1, to: 12});
            edges.push({from: 1, to: 13});
            edges.push({from: 1, to: 14});
            edges.push({from: 1, to: 15});
            edges.push({from: 1, to: 16});
            nodes[0]["level"] = 0;
            nodes[1]["level"] = 0;
            nodes[2]["level"] = 0;
            nodes[3]["level"] = 0;
            nodes[4]["level"] = 0;
            nodes[5]["level"] = 0;
            nodes[6]["level"] = 1;
            nodes[7]["level"] = 1;
            nodes[8]["level"] = 1;
            nodes[9]["level"] = 1;
            nodes[10]["level"] = 1;
            nodes[11]["level"] = 1;
            nodes[12]["level"] = 1;
            nodes[13]["level"] = 1;
            nodes[14]["level"] = 1;
            nodes[15]["level"] = 1;
            nodes[16]["level"] = 1;


            // create a network
            var container = document.getElementById('mynetwork');
            var data = {
                nodes: nodes,
                edges: edges
            };

            var options = {
                edges: {
                    smooth: {
                        type: 'cubicBezier',
                        roundness: 0.4
                    }
                },
                layout: {
                    hierarchical: {
                        direction: "UD"
                    }
                },
                physics: true
            };
            network = new vis.Network(container, data, options);
        }
        draw();
    };
}

Page.Render = {
    init: function() {
        var page = ['administration', 'futures'],
            fields = ["policies"];
        Locale.set("en", { fields: fields });
        Page.loadFieldsConfig(fields);
        Locale.loadPage(page);
        Header.load(page, { tabs: false, type: "policies" });
        new FuturesTree().init();
    }
};