function SoD()  {
    this.data = [];
    this.locale = null;
    this.data = [];
    this.templates = {
        block: "<div class='block'>{content}</div>",
        select: "<select name='risk'>{select}</select>",
        option: "<option value='{val}'>{option}</option>",
        no_entry: '<div class="no_entry">' + Locale.ui.page["no_entry"] + '</div>',
        policy_title: '<h3>{headling}</h3>',
        actions: '<button class="save">' + Locale.ui.page["save"] + '</button>'
    };
    this.risks = ["-- Select risk --", "High", "Medium", "Low", "No"];
    this.policies = ["-- Select policy --", "Policy 1", "Policy 2", "Policy 3", "Policy 4" ,"Policy 5", "Policy 6"];

    this.loadPoliciesList = function() {
        var options_policies = "";
        for (var i = 0; i < this.policies.length; i++) {
            options_policies += this.templates.option.format({val: i, option: this.policies[i]});
        }
        options_policies = this.templates.select.format({select: options_policies});
        $("header .title h2").after(options_policies);
    };
    this.init = function() {
        $("section.content").html(this.templates.no_entry).addClass("sod_2_way");
        this.loadPoliciesList();
        this.handlers();
    };
    this.loadMatrix = function(policy) {
        $("section.content").html(Header.templates.tabs.loading);
        var o = this;
        $.ajax({
            url: "/data/sod_policies.json",
            method: "GET",
            dataType: "JSON",
            success: function(result) {
                o.buildMatrix.call(o, result, policy);
            }
        });
    };
    this.buildMatrix = function(data, policy) {
        var options = "",
            params = {
            colNames: data,
            rowNames: data,
            data: this.data,
            tableClass: "sod-matrix",
            headling: policy + this.templates.actions,
        };

        /* select */
        for (var i = 0; i < this.risks.length; i++) {
            options += this.templates.option.format({val: i, option: this.risks[i]});
        }
        options = this.templates.select.format({select: options});

        /* data */
        for (var i = 0; i < data.length + 1; i++) {
            params.data[i] = [];
            for (var j = 0; j < data.length; j++) {
                if (i != j) {
                    params.data[i][j] = {
                        cell: i < j + 1 ? options : $(options).attr("disabled", "disabled").wrap('<p>').parent().html()
                    }
                } else {
                    params.data[i][j] = {
                        cell: ""
                    };
                }
            }
        }

        /* matrix */
        var matrix = new Matrix(params),
            html = matrix.getHTML(),
            section = $('section.content');
        $("section.content.sod_2_way").html(html);
        Helpers.setBlockHeight(section);
    };
    this.handlers = function() {
        var o = this;
        $(document.body).on("change", "header .title select", function() {
            var $this = $(this);
            var policy_number = $this.val();
            if (policy_number == 0) {
                $("section.content").html(o.templates.no_entry);
                return false;
            }
            o.loadMatrix($this.find("option").eq(policy_number).text());
            return false;
        });
        $(document.body).on("change", "section.content .sod-matrix select", function() {
            var $this = $(this);
            var risk_number = $this.val();
            var i = $this.parents("td").index();
            var j = $this.parents("tr").index();
            $("section.content .sod-matrix tr:eq(" + i + ") td:eq(" + j + ")").find("select option").eq(risk_number)[0].selected = true;
            return false;
        })
    };
}
Page.Render = {
    init: function(tab) {
        var page = ['assess', 'policies', "2_way_sod_matrix"];
        Locale.set("en", { fields: ["policies"] });
        Locale.loadPage(page);
        Header.load(page, { tabs: true, type: "landscape" });
        new SoD().init();
    }
};