function Policies(tab) {
    this.tab = tab;
    this.checkCats = [];
    this.checkCatsAuxiliary = {};
    this.checkCatsSelected = {};
    this.checks = {};
    this.policies = [];
    this.users = [];
    this.templates = {
        blocks: '<div class="blocks"><div class="block col-2">%s</div></div>',
        block: '<h3>' + Locale.ui.page.check_list_block + '</h3><div class="check-list"><p class="no-entry">' + Locale.ui.page.no_entry + '</p></div>',
        create: "<div class='create-button'><button>" + Locale.ui.page.buttons.new + "</button></div>",
        actions: '<div class="actions"><button class="default expand-all">' + Locale.ui.page["buttons"]["expand_all"] + '</button><button class="save">' + Locale.ui.page["buttons"]["save"] + '</button></div>',
        template_risk: '<a href="#" class="template-risk"></a>',
        add_entity: '<div class="tree-item level-%d shown" data-info="add-entity-%s"><div class="tree-item-content"><span class="text">%s</span></div></div>',
        template_risk_popup: {
            wrap: '<div class="check-name">%s</div><div class="field"><div class="name">%s:</div><div class="input"><select>%s</select></div></div><div class="buttons"><button class="save">%s</button></div>',
            risk: '<option value="%s">%s</option>'
        },
        new_policy_popup: {
            wrap: '<div class="field"><div class="name">%s:</div><div class="input"><input type="text" name="policy_name"></div></div><div class="buttons"><button class="save">%s</button></div>'
        },
        policy_rename: "<a href='#' class='policy_rename'></a>",
        policy_remove: "<a href='#' class='policy_remove'></a>",
        nodes: "<div class='nodes'>%s</div>",
        item: "<div class='tree-item level-%d shown expanded' data-info='%s'><div class='tree-item-content'><div class='text'>%s</div></div></div>",
        policy_rename_popup: {
            wrap: '<div class="field"><div class="name">%s:</div><div class="input"><input type="text" name="policy_name"></div></div><div class="buttons"><button class="save">%s</button></div>'
        }
    };
    this.controls = {
        "class": {
            "count": 1,
            "enter": '<div class="enter"><input type="text" class="field" placeholder="' + Locale.ui.page["fields"]["class"] + '" /><button class="entity-add-submit">OK</button></div>',
            "view": "<div class='view'><div class='value'>%s</div><a href='#' class='icon-edit'></a><a href='#' class='icon-remove'></a></div>"
        },
        "type": {
            "count": 2,
            "enter": '<div class="enter"><input type="text" class="field" placeholder="' + Locale.ui.page["fields"]["type"] + '" /><button class="entity-add-submit">OK</button></div>',
            "view": "<div class='view'><div class='value'>%s</div><a href='#' class='icon-edit'></a><a href='#' class='icon-remove'></a></div>"
        },
        "subtype": {
            "count": 3,
            "enter": '<div class="enter"><input type="text" class="field action-name" placeholder="' + Locale.ui.page["fields"]["subtype"] + '" /><button class="entity-add-submit">OK</button></div>',
            "view": "<div class='view'><div class='value'>%s</div><a href='#' class='icon-edit'></a><a href='#' class='icon-remove'></a></div>",
            "type": "<option value='%d'%s>%s</option>"
        },
        "check": {
            "count": 2,
            "enter": '<div class="enter"><input type="text" class="field" placeholder="' + Locale.ui.page["fields"]["check"] + '" /><button class="entity-add-submit">OK</button></div>',
            "view": "<div class='view'><div class='value'>%s</div><a href='#' class='icon-edit'></a><a href='#' class='icon-remove'></a></div>"
        }
    };
    this.levels = [
        "class",
        "type",
        "subtype",
        "check"
    ];
    this.projectTypes = {
        "audit": {
            name: "AUD",
            cats: [1, 2]
        },
        "pentest": {
            name: "AUD",
            cats: [1, 2],
            addition: {
                run_anonym: true
            }
        },
        "compliance": {
            name: "CMP",
            cats: [3]
        },
        "code_scanning": {
            name: "CHC",
            cats: [4]
        }
    };
    this.template_risks = {
        "TEMPLATE_LOW": "low",
        "TEMPLATE_MEDIUM": "medium",
        "TEMPLATE_HIGH": "high",
        "TEMPLATE_CRITICAL": "critical"
    };
    this.setCheckRisks = function(cats, id) {
        for (var i = 0; i < cats.length; i++) {
            if (typeof this.checks[cats[i]["check_id"]].templates == "undefined") {
                this.checks[cats[i]["check_id"]].templates = {};
            }
            this.checks[cats[i]["check_id"]].templates[id] = cats[i]["TEMPLATE_RISK"];
        }
    };
    this.conversionPoliciesList = function(result) {
        var data = [];
        var o = this;
        $("listscantemplates > scantemplate", result).each(function() {
            var $this = $(this);
            var projectType = $this.find("projecttype").text();
            if (projectType == o.projectTypes[o.tab].name) {
                var id = $this.find("id").text();
                var author = o.users[$this.find("authorid").text()].login;
                var update = new Date($this.find("lastupdated").text() * 1).toDateString();
                var create_date = new Date($this.find("created").text() * 1).toDateString();
                var catsInfo = $.parseJSON($this.find("data").text());
                if (catsInfo["cats"]) {
                    o.checkCatsSelected[id] = catsInfo["cats"].split(",");
                }
                data.push({
                    __addition: '<a href="#"></a>',
                    'id': id,
                    'name': '<span class="name">' + $this.find("name").text().encodeHTML() + '</span>' + o.templates.policy_remove + o.templates.policy_rename,
                    'author': author,
                    'updated': update,
                    'created': create_date,
                    'number_checks': o.checkCatsSelected[id] ? o.checkCatsSelected[id].length : 0,
                    'number_projects': 0
                });
                if (catsInfo["checks_changes"]) {
                    o.setCheckRisks.call(o, catsInfo["checks_changes"], id);
                }
            }
        });
        return data;
    };
    this.buildPoliciesTable = function() {
        var o = this;
        var params = {
            title: Locale.ui.page["table_policies_block"],
            data: o.policies,
            option: {
                ticks: {
                    __addition: 0,
                    'name': 1,
                    'author': 2,
                    'id': -1,
                    'updated': -1,
                    'created': -1,
                    'number_checks': -1,
                    'number_projects': -1
                },
                sorting: {
                    0: false
                },
                filters: {
                    id: "input",
                    number_checks: "input",
                    number_projects: "input",
                    name: "input",
                    update: "datetime",
                    create: "datetime"
                },
                sort_default: { column: 1, order: "asc" },
                count_one_page: 50
            }
        };
        var table_obj = new Table(params),
            html = table_obj.getHTML(),
            section = $('section.content');
        section.find(".blocks").append(html);
        section.find(".blocks .table .actions-bar").append(this.templates.create);
        table_obj.build();
        Helpers.setBlockHeight(section);
    };
    this.removeEmptyCats = function() {
        for (var i = 0; i < this.checkCats.length; i++) {
            var for_hidden_j = true;
            for (var j = 0; j < this.checkCats[i].nodes.length; j++) {
                var for_hidden_k = true;
                for (var k = 0; k < this.checkCats[i].nodes[j].nodes.length; k++) {
                    if (this.checkCats[i].nodes[j].nodes[k].hidden === false) {
                        for_hidden_k = false;
                    }
                }
                if (for_hidden_k) {
                    this.checkCats[i].nodes[j].hidden = true;
                } else {
                    for_hidden_j = false;
                }
            }
            if (for_hidden_j) {
                this.checkCats[i].hidden = true;
            }
        }
    };
    this.loadPolicies = function() {
        var o = this;
        ERPScanAPI.query("/engine/scantemplates/list", function(result) {
            $("section.content").html(o.templates.blocks.sprintf(o.templates.block));
            o.policies = o.conversionPoliciesList.call(o, result);
            o.buildPoliciesTable();
        });
    };
    this.buildCheckList = function(id) {
        new Tree($(".check-list"), [{
            checkbox: false,
            expanded: true,
            data: {
                info: "add-entity-class",
            },
            text: Locale.ui.page["add_entities"]["class"]
        }], {}).init();
    };
    this.selectPolicy = function($this) {
        if ($this.hasClass("tablesorter-headerRow") || $this.hasClass("tablesorter-filter-row")) {
            return false;
        }
        if ($this.hasClass("active")) {
            var number = $this.data("number");
            var id = this.policies[number].id;
            var name = this.policies[number].name;
            this.buildCheckList(id);
            if ($(".blocks .block .save-button").length == 0) {
                $(".blocks .block h3").before(this.templates.actions);
            }
            $(".blocks .block h3").html(name);
            $(".blocks .block").data("id", id);
        } else {
            $(".blocks .block").html(this.templates.block);
        }
    };
    this.creatingPolicy = function($button) {
        if ($button.hasClass("saving")) {
            return false;
        }
        $button.html(Locale.ui.page["new_policy"]["saving"]).addClass("saving");
        var name = $(".popup-new-policy input[name=\"policy_name\"]").val();
        if (!name) {
            return false;
        }
        var o = this;
        this.createPolicy(name, this.projectTypes["audit"].name, function(result) {
            var $info = $("createscantemplate scantemplate", result);
            var name = '<span class="name">' + $info.find("name").text().encodeHTML() + '</span>' + o.templates.policy_remove + o.templates.policy_rename;
            var author = o.users[$info.find("authorid").text()].login;
            var id = $info.find("id").text();
            var update = new Date($info.find("lastupdated").text() * 1).toDateString();
            var create_date = new Date($info.find("created").text() * 1).toDateString();
            var new_number = o.policies.length;
            var row = '<tr data-number="' + new_number + '"><td data-order="1" class="toggle-info"><a href="#"></a></td><td>' + name + '</td><td>' + author + '</td></tr>';
            o.policies.push({
                __addition: '<a href="#"></a>',
                'id': id,
                'name': name,
                'author': author,
                'updated': update,
                'created': create_date,
                'number_checks': 0,
                'number_projects': 0
            });
            $(".blocks .table table tbody").append(row);
            $('.blocks .table table').trigger('update');
            $(".blocks .table table tr[data-number=\"" + new_number + "\"]").click();
            Popup.close();
        });
    };
    this.renamePolicy = function(id, new_name, callback) {
        ERPScanAPI.query("/engine/scantemplates/update/" + id, function(result) {
            if (callback) {
                callback(result);
            }
        }, {
            name: new_name
        });
    };
    this.handlers = function() {
        var o = this;
        $(document.body).on("click", ".check-list .tree-item[data-info^=\"add-entity\"] span", function() {
            var $this = $(this).parent(".tree-item-content").parent(".tree-item");
            if ($this.hasClass("disable")) {
                return false;
            }
            $this.addClass("disable");
            var entity = $this.data("info").split("-");
            entity = entity[2];
            var content = o.controls[entity].enter;
            if (entity == "action") {
                var types = "";
                var types_locale = Locale.ui.page["fields"]["type"];
                for (var i = 0; i < types_locale.length; i++) {
                    types += o.controls.action.type.sprintf(i, types_locale[i]["selected"] ? ' selected="selected"' : "", types_locale[i]["title"]);
                }
                content = content.sprintf(types);
            }
            var controls = o.templates.item.sprintf(o.levels.indexOf(entity) + 1, entity, content, "");
            $this.before(controls);
            $this.next(".tree-item").find("input").focus();
            return false;
        });
        $(document.body).on("click", ".check-list .tree-item .entity-add-submit", function() {
            var $this = $(this);
            var $field = $this.parent(".enter").parent(".text").parent(".tree-item-content").parent(".tree-item");
            var entity = $field.data("info");
            var not_submit = false;
            $field.find("input, textarea, select").each(function() {
                var $this = $(this);
                if (!$(this).val() || ($this.is("select") && $this.val() == 0)) {
                    not_submit = true;
                    return false;
                }
            });
            if (not_submit) {
                return false;
            }
            var view = o.controls[entity].view;
            $this.parent(".enter").find("input, textarea, select").each(function() {
                var $this = $(this);
                var value = $this.is("select") ? $this.find("option:selected").html() : $this.val();
                view = view.sprintf(value);
            });
            $(".check-list .tree-item[data-info=\"add-entity-" + entity + "\"]").removeClass("disable");
            $(this).parent(".enter").parent(".text").append(view);
            var index = o.levels.indexOf(entity);
            if (o.levels.length > index + 1 && $field.find(".view").length == 1 && $field.find(".nodes .tree-item[data-info^=add-entity]").length == 0) {
                var add_link = o.templates.add_entity.sprintf(index + 2, o.levels[index + 1], Locale.ui.page["add_entities"][o.levels[index + 1]]);
                $(this).parent(".enter").parent(".text").after(o.templates.nodes.sprintf(add_link));
            }
            $(this).parent(".enter").remove();
            return false;
        });
        $(document.body).on("click", ".check-list .tree-item .icon-edit", function() {
            var $this = $(this).parent(".view").parent(".text").parent(".tree-item-content").parent(".tree-item");
            if ($this.hasClass("disable")) {
                return false;
            }
            var entity = $this.data("info");
            $(".check-list .tree-item[data-info=\"add-entity-" + entity + "\"]").addClass("disable");
            var content = o.controls[entity].enter;
            if (entity == "action") {
                var types = "";
                var types_locale = Locale.ui.page["tree_view"]["action"]["fields"]["type"];
                for (var i = 0; i < types_locale.length; i++) {
                    types += o.controls.action.type.sprintf(i, types_locale[i]["selected"] ? ' selected="selected"' : "", types_locale[i]["title"]);
                }
                content = content.sprintf(types);
            }
            var i = 0;
            var $text = $(this).parent(".view").parent(".text");
            $text.append(content);
            $text.find("input, select, textarea").each(function() {
                var $input = $(this);
                var value = $this.find("div.value:eq(" + (i++) + ")").text();
                if ($input.is("select")) {
                    if ($input.find("option:contains('" + value + "')").length > 0) {
                        $input.find("option:contains('" + value + "')")[0].selected = true;
                    }
                } else {
                    $input.val(value);
                }
            });
            $text.find(".view").remove();
            $this.next(".tree-item").find("input").focus();
            return false;
        });
        $(document.body).on("click", ".check-list .tree-item .icon-remove", function() {
            var $this = $(this).parent(".view").parent(".text").parent(".tree-item-content").parent(".tree-item");
            $this.remove();
            return false;
        });
        $(document.body).on("click", ".check-list .tree .tree-item .tree-item-content .text .template-risk", function() {
            var check_name = $(this).parent(".text").text();
            var check_id = $(this).parents(".tree-item").data("info");
            var policy_id = $(".blocks .block").data("id");
            var risks = "";
            for (var item in Locale.ui.page["check_settings"]["risks"]) {
                risks += o.templates.template_risk_popup.risk.sprintf(item, Locale.ui.page["check_settings"]["risks"][item]);
            }
            Popup.new({
                class: "popup-template-risk",
                title: Locale.ui.page["check_settings"]["title"],
                content: o.templates.template_risk_popup.wrap.sprintf(check_name, Locale.ui.page["check_settings"]["risk"], risks, Locale.ui.page["check_settings"]["save"]),
                width: 350,
                open: function() {
                    if (o.checks[check_id].templates && o.checks[check_id].templates[policy_id]) {
                        var risk = o.template_risks[o.checks[check_id].templates[policy_id]];
                        $(".popup-template-risk .input select option[value=\"" + risk + "\"]")[0].selected = true;
                    }
                },
                close: function() {

                }
            });
            return false;
        });
        $(document.body).on("click", ".blocks .table .create-button", function() {
            Popup.new({
                class: "popup-new-policy",
                title: Locale.ui.page["new_policy"]["title"],
                content: o.templates.new_policy_popup.wrap.sprintf(Locale.ui.page["new_policy"]["name"], Locale.ui.page["new_policy"]["save"]),
                width: 350,
                height: 100,
                open: function() {
                    $(".popup-new-policy input[name=\"policy_name\"]").focus();
                },
                close: function() {

                }
            });
            return false;
        });
        $(document.body).on("click", ".blocks .table .policy_rename", function() {
            var $td = $(this).parents("td");
            var $tr = $(this).parents("tr");
            var index = $tr.data("number");
            var id = o.policies[index].id;
            var name = o.policies[index].name;
            Popup.new({
                class: "popup-policy-rename",
                title: Locale.ui.page["policy_rename"]["title"],
                content: o.templates.policy_rename_popup.wrap.sprintf(Locale.ui.page["policy_rename"]["name"], Locale.ui.page["policy_rename"]["save"]),
                width: 350,
                height: 100,
                open: function() {
                    $(".popup-policy-rename input[name=\"policy_name\"]").data("id", id).data("td", $td).val($("<div />").html(name).text()).focus();
                },
                close: function() {

                }
            });
            return false;
        });
        $(document.body).on("click", ".popup-new-policy .save", function() {
            var $this = $(this);
            o.creatingPolicy.call(o, $this);
            return false;
        });
        $(document.body).on("click", ".popup-policy-rename .save", function() {
            var $this = $(this);
            if ($this.hasClass("saving")) {
                return false;
            }
            var $input = $(".popup-policy-rename input[name=\"policy_name\"]");
            var new_name = $input.val();
            if (!new_name) {
                return false;
            }
            $this.html(Locale.ui.page["policy_rename"]["saving"]).addClass("saving");
            var id = $input.data("id");
            var $td = $input.data("td");
            var number = $td.parent("tr").data("number");
            o.renamePolicy(id, new_name, function() {
                $td.find(".name").html(new_name.encodeHTML());
                $('.blocks .table table').trigger('update');
                Popup.close();
                o.policies[number].name = new_name.encodeHTML();
            });
            return false;
        });
        $(document.body).on("keyup", ".popup-new-policy input[name=\"policy_name\"]", function(event) {
            if (event.keyCode != 13) {
                return false;
            }
            o.creatingPolicy.call(o, $(".popup-new-policy .save"));
            return false;
        });
        $(document.body).on("click", "section.content .block .expand-all", function() {
            var $this = $(this);
            $this.addClass("collapse-all").removeClass("expand-all").html(Locale.ui.page["buttons"]["collapse_all"]);
            o.tree.expandAll();
            return false;
        });
        $(document.body).on("click", "section.content .block .collapse-all", function() {
            var $this = $(this);
            $this.addClass("expand-all").removeClass("collapse-all").html(Locale.ui.page["buttons"]["expand_all"]);
            o.tree.collapseAll();
            return false;
        });
        $(document.body).on("click", ".blocks .table .policy_remove", function(event) {
            var $this = $(this);
            if ($this.hasClass("removing")) {
                return false;
            }
            if (confirm(Locale.ui.page["remove_policy"])) {
                $this.addClass("removing");
                var $tr = $this.parents("tr");
                var index = $tr.data("number");
                o.removePolicy(o.policies[index].id, function() {
                    $tr.remove();
                    $(".blocks .table table").trigger('update');
                    $(".blocks .block").html(o.templates.block);
                    Popup.close();
                });
            }
            event.preventDefault();
            return false;
        });
    };
    this.removePolicy = function(id, callback) {
        ERPScanAPI.query("/engine/scantemplates/remove/" + id, function(result) {
            if (callback) {
                callback(result);
            }
        });
    };
    this.createPolicy = function(name, projectType, callback) {
        ERPScanAPI.query("/engine/scantemplates/create", function(result) {
            if (callback) {
                callback(result);
            }
        }, {
            "data": '{"cats":""}',
            projectType: projectType,
            name: name
        });
    };
    this.preLoad = function(callback) {
        var o = this,
            counter = 0,
            total_queries = 3;
        ERPScanAPI.query("/engine/dictionary/users", function(result) {
            $("listusers user", result).each(function() {
                var $this = $(this),
                    userID = $this.find("id").text(),
                    user = {
                        login: $this.find("login").text()
                    };
                o.users[userID] = user;
            });
            counter++;
            if (counter == total_queries) {
                callback.call(o);
            }
        });
        ERPScanAPI.query("/engine/dictionary/checkobjects", function(result) {
            $("listobjects prototypecheck", result).each(function() {
                var $this = $(this),
                    id = $this.find("id").text();
                o.checks[id] = {
                    prototype: $this.find("prototypename").text(),
                    data: JSON.parse($this.find("data").text())
                };
            });
            counter++;
            if (counter == total_queries) {
                callback.call(o);
            }
        });
        $.ajax({
            url: "/data/checkCats.xml",
            method: "GET",
            dataType: "XML",
            success: function(result) {
                o.checkCats = result;
                counter++;
                if (counter == total_queries) {
                    callback.call(o);
                }
            }
        });
    };
    this.init = function() {
        $("section.content").html(Header.templates.tabs.loading);
        this.preLoad(this.loadPolicies);
        this.handlers();
    }
}

Page.Render = {
    init: function() {
        var page = ['assess', 'policies', "compliance"];
        Locale.set("en", { fields: ["policies"] });
        Locale.loadPage(page);
        Header.load(page, { tabs: true, type: "landscape" });
        new Policies("compliance").init();
    }
};