function CriticalAccess() {
    this.objects = {};
    this.templates = {
        wrap: '<div class="blocks">{policiesList}</div><div class="blocks">{policyEditor}</div>',
        managementsControls: {
            createButton: '<div class="new-policy-container"><button class="new-policy default">New policy</button></div>',
            save: '<button class="save">Save</button>',
            delete: '<button class="delete default">Delete</button>',
            confirmationRemove: '<span class="confirmation-remove"><a href="#" class="confirm-remove">Confirm</a><a href="#" class="cancel-remove">Cancel</a></span>'
        },
        editorForm: {
            fields: "<div class='field'><div class='name'>Policy name:</div><div class='value'><input type='text' name='policyName' /></div>"
        },
        editorTreeElements: {
            businessProcess: {
                item: '<span class="BPNameContainer"><input type="text" value="{BPName}" placeholder="Business process name" name="BPName" /></span><a href="#" class="remove"></a>'
            },
            businessFunction: {
                item: '<span class="BFIDContainer"><input type="text" name="BFName" value="{BFName}" placeholder="Business function name" /></span><a href="#" class="remove"></a>'
            },
            businessAction: {
                item: '<span class="BATypeContainer"><select name="BAType"><option value="0">-- Select action type --</option><option value="TRANSACTION">Transaction code</option><option value="URL">URL</option><option value="RFC_FUNCTION">RFC function</option><option value="AUTH_OBJECTS">Auth objects</option></select></span><span class="BANameContainer"><input type="text" placeholder="Action name" value="{BAName}" name="BAName" /></span><a href="#" class="remove"></a><span class="BADescriptionContainer multiLineBlock"><textarea name="BADescription" placeholder="Action description">{BADescription}</textarea><span class="BARootGroupTypeContainer"><select name="BARootGroupType"><option value="0">-- Root group type --</option><option value="OR" selected="selected">OR</option><option value="AND">AND</option></select></span></span>'
            },
            authObjectsGroup: {
                item: '<span class="AOGroupTypeContainer">Grouping by <b><select name="groupingType"><option value="OR">OR</option><option value="AND">AND</option></select></b></span><a href="#" class="remove"></a>'
            },
            authObject: {
                item: '<span class="AONameContainer"><input type="text" placeholder="Auth object name" name="AOName" /></span><a href="#" class="remove"></a>'
            },
            attribute: {
                item: '<span class="AOAttributeNameContainer"><input type="text" placeholder="Attribute name" name="AOAttributeName" /></span><span class="AOAttributeValueContainer"><input type="text" placeholder="Attribute value" name="AOAttributeValue" /></span><a href="#" class="remove"></a>'
            }
        }
    };
    this.conversionFields = function(result, rules) {
        var data = [];
        for (var i = 0; i < result.length; i++) {
            var index = data.push({}) - 1;
            for (var field in rules) {
                if (typeof result[i][field] == "undefined") {
                    data[index][field] = rules[field].call(this, result[i], field, i);
                }
            }
            for (var field in result[i]) {
                var isset = typeof rules[field] != "undefined",
                    skip = isset && rules[field] == null;
                if (skip) {
                    continue;
                }
                data[index][field] = isset ? rules[field].call(this, result[i], field, i) : result[i][field];
            }
        }
        return data;
    };
    this.conversionFieldRules = {
        "list": {
            "__addition": function(fields, name) {
                return "<a href=''></a>";
            },
            "author": function() {
                return "[Deleted user]";
            },
            "name": function(fields, name) {
                return {
                    value: fields[name],
                    attr: {
                        name: "id",
                        value: fields["id"]
                    }
                }
            },
            "id": null,
            "type": null,
            "subtype": null,
            "projectTypes": null,
            "isDefault": null,
            "basedOn": null,
            "structure": null
        }
    };
    this.BPStructureElements = ["businessProcesses", "businessRoles", "actions"];
    this.BPEditorTreeElements = {
        "businessProcess": {
            level: 1,
            hasChildren: true,
            child: "businessFunction",
            addingText: {
                "DEFAULT": {
                    text: "Add business process"
                }
            },
            fields: {
                "BPName": {
                    type: "text",
                    source: ["name", "{locale}"]
                }
            },
            structureChild: "businessRoles",
            structure: {
                "type": "SOD",
                "name" : {
                    "{locale}": "{BPName}"
                },
                "businessRoles": []
            }
        },
        "businessFunction": {
            level: 2,
            hasChildren: true,
            child: "businessAction",
            addingText: {
                "DEFAULT": {
                    text: "Add business function"
                }
            },
            fields: {
                "BFName": {
                    type: "text",
                    source: ["name", "{locale}"]
                }
            },
            structureChild: "actions",
            structure: {
                "name" : {
                    "{locale}": "{BFName}"
                },
                "actions": []
            }
        },
        "businessAction": {
            level: 3,
            hasChildren: true,
            child: "authObjectsGroup",
            addingText: {
                "DEFAULT": {
                    text: "Add business action"
                }
            },
            fields: {
                "BAType": {
                    type: "select",
                    callback: function() {
                        var $context = $(this);
                        $context.parent(".BATypeContainer").next(".BANameContainer")[$context.val() == 4 ? "hide" : "show"]();
                    },
                    source: ["type"]
                },
                "BAName": {
                    type: "text",
                    source: ["name"]
                },
                "BADescription": {
                    type: "textarea",
                    source: ["description", "{locale}"]
                },
                "BARootGroup": {
                    type: "select"
                }
            },
            structure: {
                "type": "{BAType}",
                "name" : "{BAName}",
                "description" : {
                    "{locale}": "{BADescription}"
                },
                "authObjects": function($context) {
                    return this.generateCortege($context);
                }
            }
        },
        "authObjectsGroup": {
            level: 4,
            hasChildren: true,
            child: "authObject",
            addingText: {
                "DEFAULT": {
                    text: "Add object",
                    type: "authObject"
                },
                "OR": {
                    text: "Add group auth objects (OR operator)",
                    callback: function($item) {
                        $item.find("> .tree-item-content .text select[name=\"groupingType\"]").find("option").eq(2).attr("selected", "selected");
                    }
                },
                "AND": {
                    text: "Add group auth objects (AND operator)",
                    callback: function($item) {
                        $item.find("> .tree-item-content .text select[name=\"groupingType\"]").find("option").eq(1).attr("selected", "selected");
                    }
                }
            },
            "groupType": {
                type: "text"
            }
        },
        "authObject": {
            level: 5,
            hasChildren: true,
            child: "attribute",
            addingText: {
                "DEFAULT": {
                    text: "Add object"
                },
                "OR": {
                    text: "Add group auth objects (OR operator)",
                    type: "authObjectsGroup"
                },
                "AND": {
                    text: "Add group auth objects (AND operator)",
                    type: "authObjectsGroup"
                }
            },
            fields: {
                "AOName": {
                    type: "text"
                }
            }
        },
        "attribute": {
            level: 6,
            hasChildren: false,
            addingText: {
                "DEFAULT": {
                    text: "Add attribute"
                }
            },
            fields: {
                "AOAttributeName": {
                    type: "text"
                },
                "AOAttributeValue": {
                    type: "text"
                }
            }
        }
    };
    this.rulesGroupObjects = {
        "AND": "&",
        "OR": "|"
    };
    this.showPolicies = function(result) {
        var tableObj = new Table({
                data: result,
                option: {
                    namespace: "policies",
                    type: "SODList",
                    sort_default: { column: 0, order: "asc" }
                }
            }),
            tableHTML = tableObj.getHTML(),
            $table = $(tableHTML),
            policiesListBlock = new Block({
                title: "Policies list",
                content: $(tableHTML).find(".tablesorter").changeSelector(function() {}),
                class: "policies-list"
            }).getHTML(),
            editorBlock = new Block({
                title: "Editor",
                content: "Select policy for editing business roles.",
                class: "policies-editor"
            }).getHTML();
        $("section.content").html(this.templates.wrap.format({
            policiesList: policiesListBlock,
            policyEditor: editorBlock
        })).find(".block.policies-list").attr("id", $table.attr("id"));
        $("section.content .block.policies-list h3").after(this.templates.managementsControls.createButton);
        tableObj.build();
        tableObj.clickEventOff();
    };
    this.loadPolicies = function() {
        var o = this;
        ERPScan.API.query("policyStructures", "list", {
            callback: function(response) {
                o.objects.policies = response["data"]["result"];
                var policies = o.conversionFields.call(o, o.objects.policies, o.conversionFieldRules.list);
                o.showPolicies.call(o, policies);
            }
        }, {
            type: "SOD"
        });
    };
    this.newPolicy = function() {
        this.showEditor();
    };
    this.showEditor = function($policy) {
        $(".blocks table.tablesorter tbody tr").removeClass("active");
        var policyObj = null;
        if (typeof $policy != "undefined") {
            $policy.addClass("active");
            policyObj = this.objects.policies[$policy.data("number")];
        }
        var tabsObj = new Tabs({
            container: $(".block.policies-editor .block-content"),
            locale: {
                treeView: "Tree view",
                tableView: "Table view"
            },
            tabs: {
                treeView: "",
                tableView: "Under construction..."
            }
        });
        $(".block.policies-editor .block-content").html(tabsObj.getHTML());
        this.objects.tree = new Tree($(".block.policies-editor .block-content div[data-name=\"treeView\"]"), this.BTTreeGet(policyObj == null ? [] : policyObj.structure), {
            expandWhenClick: false
        });
        this.objects.tree.init();
        $(".block.policies-editor .block-content > div[data-name=\"treeView\"]").prepend(this.templates.editorForm.fields);
        $(".block.policies-editor .block-content .block-tabs").before(this.templates.managementsControls.save);
        $(".block.policies-editor").data("mode", policyObj != null ? "edit" : "add");
        if (policyObj != null) {
            $(".block.policies-editor .block-content input[name=\"policyName\"]").val(policyObj["name"]);
            $(".block.policies-editor").data("id", policyObj.id);
            $(".block.policies-editor .block-content .save").before(this.templates.managementsControls.delete);
        }
    };
    this.preLoad = function(callback) {
        callback.call(this);
    };
    this.BTTreeGetItemNameByLevel = function(level) {
        for (var item in this.BPEditorTreeElements) {
            if (this.BPEditorTreeElements[item].level == level) {
                return item;
            }
        }
        return -1;
    };
    this.BPTreeGetRoot = function() {
        return [{
            checkbox: false,
            expanded: true,
            text: "Business processes tree",
            nodes: [
                {
                    checkbox: false,
                    expanded: true,
                    data: {
                        type: "add-entity",
                        elements: "businessProcess"
                    },
                    text: this.BPEditorTreeElements["businessProcess"].addingText["DEFAULT"].text
                }
            ]
        }];
    };
    this.BTTreeWalkStructure = function(structure, parent, level) {
        var itemType = this.BTTreeGetItemNameByLevel(level),
            params = this.BPEditorTreeElements[itemType];
        for (var i = structure.length - 1; i >= 0 ; i--) {
            var nodes = [];
            if (params.hasChildren) {
                var childElementType = params.child,
                    childParams = this.BPEditorTreeElements[childElementType];
                for (var item in childParams.addingText) {
                    nodes.push({
                        text: childParams.addingText[item].text,
                        checkbox: false,
                        data: {
                            elements: childParams.addingText[item].type ? childParams.addingText[item].type : childElementType,
                            subelements: item,
                            type: "add-entity"
                        },
                        expandable: false,
                        level: childParams.level + 1
                    });
                }
            }
            var text = this.templates.editorTreeElements[itemType].item;
            var templater = {};
            for (var field in params["fields"]) {
                var fieldObj = params["fields"][field],
                    fieldTarget = structure[i];
                if (typeof fieldObj["source"] == "undefined") {
                    continue;
                }
                for (var j = 0; j < fieldObj["source"].length; j++) {
                    var fieldName = fieldObj["source"][j];
                    if (fieldObj["source"][j].formatCheckVariable("locale")) {
                        fieldName = fieldObj["source"][j].format({
                            locale: "en_US"
                        });
                    }
                    fieldTarget = fieldTarget[fieldName];
                }
                templater[field] = fieldTarget;
            }
            text = text.format(templater);
            parent.unshift({
                checkbox: false,
                expanded: true,
                text: text,
                nodes: nodes
            });
            if (typeof structure[i][this.BPStructureElements[level]] != "undefined") {
                parent[0].nodes = this.BTTreeWalkStructure(structure[i][this.BPStructureElements[level]], parent[0].nodes, level + 1);
            }
        }
        return parent;
    };
    this.BTTreeGet = function(structure) {
        var root = this.BPTreeGetRoot();
        var nodes = this.BTTreeWalkStructure(structure, root[0].nodes, 1);
        return root;
    };
    this.BPTreeAddElement = function($context, option) {
        option = option || {};
        option.type = option.type || "businessProcess";
        var params = this.BPEditorTreeElements[option.type],
            text = this.templates.editorTreeElements[option.type].item;
        if (option.itemFormat != null) {
            text = text.format(option.itemFormat);
        }
        if (option.orderEndAddingElement == null) {
            option.orderEndAddingElement = 1;
        }
        var $newElement = this.objects.tree.addItemBefore($context.find("> .nodes").find("> .tree-item:nth-last-child(" + option.orderEndAddingElement + ")").find(".tree-item-content"), {
            text: text,
            checkbox: false,
            expandable: params.hasChildren,
            level: params.level + 1
        });
        if (typeof option.itemFormat != "undefined" && typeof option.itemFormat.groupType != "undefined" && typeof params.addingText[option.itemFormat.groupType].callback == "function") {
            params.addingText[option.itemFormat.groupType].callback($newElement);
        }
        for (var item in params.fields) {
            if (params.fields[item].callback) {
                $newElement.find("*[name=\"" + item + "\"]").on("change", params.fields[item].callback);
            }
        }
        if (params.hasChildren) {
            var childElementType = this.BPEditorTreeElements[option.type].child,
                childParams = this.BPEditorTreeElements[childElementType];
            for (var item in childParams.addingText) {
                this.objects.tree.addItemAppend($newElement.find(".tree-item-content"), {
                    text: childParams.addingText[item].text,
                    checkbox: false,
                    data: {
                        elements: childParams.addingText[item].type ? childParams.addingText[item].type : childElementType,
                        subelements: item,
                        type: "add-entity"
                    },
                    expandable: false,
                    level: childParams.level + 1
                });
            }
        }
    };
    this.BPTreeRemoveElement = function($item) {
        $item.remove();
    };
    this.formatStructure = function(structure, structureFormatted, variables, $context) {
        for (var structureElement in structure) {
            if (typeof structure[structureElement] == "object") {
                this.formatStructure(structure[structureElement], structureFormatted[structureElement], variables, $context);
            } else {
                var key = structureElement, value = "";
                if (typeof structure[structureElement] != "function") {
                    value = structure[structureElement].format(variables);
                } else {
                    value = structure[structureElement].call(this, $context);
                }
                if (key.formatCheckVariable("locale")) {
                    key = key.format({
                        "locale": "en_US"
                    });
                    delete structureFormatted["{locale}"];
                }
                structureFormatted[key] = value.toString();
            }
        }
        return structureFormatted;
    };
    this.collectValues = function(element, structure, $context) {
        var paramsElement = this.BPEditorTreeElements[element],
            o = this;
        if (typeof paramsElement.structure != "undefined") {
            $context.find(".tree-item.level-{level}[data-type!=\"add-entity\"]".format({level: paramsElement.level + 1})).each(function() {
                var $this = $(this),
                    variables = {};
                for (var field in paramsElement.fields) {
                    var $item = $this.find("> .tree-item-content > .text *[name=\"{field}\"]".format({field: field}));
                    if (paramsElement.fields[field].type == "select") {
                        variables[field] = $item.find("option:selected").val();
                    } else {
                        variables[field] = $item.val();
                    }
                }
                var formattedStructure = o.formatStructure(paramsElement.structure, $.extend(true, {}, paramsElement.structure), variables, $this);
                var structureIndex = structure.push(formattedStructure) - 1;
                if (paramsElement.structureChild) {
                    structure[structureIndex][paramsElement.structureChild] = o.collectValues.call(o, paramsElement.child, structure[structureIndex][paramsElement.structureChild], $this);
                }
            });
        }
        return structure;
    };
    this.getObjectAttrs = function($attrs) {
        var attrs = [];
        $attrs.each(function() {
            var $this = $(this),
                name = $this.find("*[name=\"AOAttributeName\"]").val(),
                value = $this.find("*[name=\"AOAttributeValue\"]").val();
            attrs.push({
                name: name,
                value: value
            });
        });
        return attrs;
    };
    this.objectAttrsToCortege = function(attrs) {
        for (var i = 0; i < attrs.length; i++) {
            attrs[i] = "{name}({value})".format({
                name: attrs[i].name,
                value: attrs[i].value
            });
        }
        attrs = attrs.join(",");
        return attrs;
    };
    this.getRootGroupObjectsType = function($nodes) {
        var $item = $($nodes.context);
        return $item.find("> .tree-item-content > .text .BARootGroupTypeContainer select").val();
    };
    this.collectObjects = function($root, cortege, level) {
        var o = this;
        $root.filter(".level-{level}".format({ level: this.BPEditorTreeElements["authObjectsGroup"].level + 1 })).each(function() {
            var $this = $(this),
                selector = "> .nodes > .tree-item.level-{levelGroup}[data-type!=\"add-entity\"], > .nodes > .tree-item.level-{levelObject}[data-type!=\"add-entity\"]",
                $childElements = $this.find(selector.format({
                    levelGroup: o.BPEditorTreeElements["authObjectsGroup"].level + 1,
                    levelObject: o.BPEditorTreeElements["authObject"].level + 1
                }));
            var groupType = $this.find("> .tree-item-content .text .AOGroupTypeContainer select").val(),
                objects = o.collectObjects($childElements, cortege, level + 1);
            cortege = [];
            cortege.push("({group})".format({ group: objects.join(o.rulesGroupObjects[groupType]) }));
        });
        $root.filter(".level-{level}".format({ level: this.BPEditorTreeElements["authObject"].level + 1 })).each(function() {
            var $this = $(this);
            var selectorAttributes = "> .nodes > .tree-item.level-{levelAttr}[data-type!=\"add-entity\"]",
                $objectAttributes = $this.find(selectorAttributes.format({
                    levelAttr: o.BPEditorTreeElements["attribute"].level + 1
                })),
                attributes = [];
            if ($objectAttributes.length > 0) {
                attributes = o.getObjectAttrs($objectAttributes);
            }
            attributes = o.objectAttrsToCortege(attributes);
            cortege.push("{objectName}({attributes})".format({
                objectName: $this.find("> .tree-item-content input[name=\"AOName\"]").val(),
                attributes: attributes
            }));
        });
        return level == 1 ? cortege.join(o.rulesGroupObjects[o.getRootGroupObjectsType($root)]) : cortege;
    };
    this.generateCortege = function($context) {
        var selector = "> .nodes > .tree-item.level-{levelGroup}[data-type!=\"add-entity\"], > .nodes > .tree-item.level-{levelObject}[data-type!=\"add-entity\"]",
            $objects = $context.find(selector.format({
                levelGroup: this.BPEditorTreeElements["authObjectsGroup"].level + 1,
                levelObject: this.BPEditorTreeElements["authObject"].level + 1
            })),
            cortege = this.collectObjects($objects, [], 1);
        return cortege;
    };
    this.save = function($button) {
        $button.attr("disabled", "disabled").html("Saving...");
        var structure = this.collectValues("businessProcess", [], $(".block.policies-editor .tree-item.level-1[data-type!=\"add-entity\"]")),
            mode = $(".block.policies-editor").data("mode");
        ERPScan.API.query("policyStructures", mode, {
            callback: function(result) {
                $button.removeAttr("disabled").html("Save");
            },
            error: function() {
                $button.removeAttr("disabled").html("Save");
            },
            type: "POST",
            params: {
                data: JSON.stringify({
                    name: {
                        "en_US": $(".policies-editor input[name=\"policyName\"]").val()
                    },
                    author: null,
                    type: "SOD",
                    subtype: null,
                    projectTypes: ["SOD"],
                    systemType: "mutable",
                    isDefault: false,
                    basedOn: null,
                    structure: structure
                })
            }
        });
    };
    this.delete = function($button) {
        var callback = function () {
            $(".block.policies-editor .block-content").html("Select policy for editing business roles.");
            $(".block.policies-editor .block-content").html("Select policy for editing business roles.");
        };
        new PopupConfirm({
            text: "Are you sure?",
            callback: function () {
                $button.attr("disabled", "disabled").html("Deleting...");
                ERPScan.API.query("policyStructures", "delete", {
                    callback: function(result) {
                        $(".block.policies-editor .block-content").html("Select policy for editing business roles.");
                    },
                    error: function() {
                        $button.removeAttr("disabled").html("Save");
                    },
                    type: "GET",
                    params: {
                        id: $(".block.policies-editor").data("id")
                    }
                });
            }
        }).show()
    };
    this.BPTreeRemoveElementConfirmation = function($item) {
        $item.find("> .tree-item-content > .text > .remove").hide().after(this.templates.managementsControls.confirmationRemove);
    };
    this.BPTreeRemoveElementCancel = function($item) {
        $item.find("> .tree-item-content > .text > .confirmation-remove").remove();
        $item.find("> .tree-item-content > .text > .remove").show();
    };
    this.handlers = function() {
        var o = this;
        $(document.body).on("click", ".blocks table.tablesorter tbody tr", function() {
            var $this = $(this);
            o.showEditor($this);
        });
        $(document.body).on("click", ".blocks .block.policies-list > .new-policy-container button.new-policy", function() {
            var $this = $(this);
            o.newPolicy($this);
        });
        $(document.body).on("click", ".policies-editor .tree-item .tree-item-content .text .remove", function() {
            var $this = $(this),
                $item = $this.parent(".text").parent(".tree-item-content").parent(".tree-item");
            o.BPTreeRemoveElementConfirmation.call(o, $item);
            return false;
        });
        $(document.body).on("click", ".policies-editor .tree-item .tree-item-content .text .confirmation-remove .confirm-remove", function() {
            var $this = $(this),
                $item = $this.parent(".confirmation-remove").parent(".text").parent(".tree-item-content").parent(".tree-item");
            o.BPTreeRemoveElement.call(o, $item);
            return false;
        });
        $(document.body).on("click", ".policies-editor .tree-item .tree-item-content .text .confirmation-remove .cancel-remove", function() {
            var $this = $(this),
                $item = $this.parent(".confirmation-remove").parent(".text").parent(".tree-item-content").parent(".tree-item");
            o.BPTreeRemoveElementCancel.call(o, $item);
            return false;
        });
        $(document.body).on("click", ".policies-editor .save", function() {
            var $this = $(this);
            o.save.call(o, $this);
        });
        $(document.body).on("click", ".policies-editor .delete", function() {
            var $this = $(this);
            $(".blocks table.tablesorter tbody tr").fadeOut(500, function () {
                $(this).remove();
            });
            o.delete.call(o, $this);
        });
        $(document.body).on("click", ".policies-editor .tree-item[data-type=\"add-entity\"] .tree-item-content .text", function() {
            var $this = $(this),
                $item = $this.parent(".tree-item-content").parent(".tree-item"),
                type = $item.attr("data-elements"),
                params = {
                    type: $item.attr("data-elements")
                };
            if (type == "authObjectsGroup") {
                var subelements = $item.attr("data-subelements");
                params.itemFormat = {
                    groupType: $item.attr("data-subelements")
                };
            }
            params.orderEndAddingElement = $item.parent(".nodes").find("> .tree-item[data-type=\"add-entity\"]").length;
            o.BPTreeAddElement($item.parent(".nodes").parent(".tree-item"), params);
        });
    };
    this.init = function() {
        $("section.content").html(Header.templates.tabs.loading);
        this.preLoad(this.loadPolicies);
        this.handlers();
    }
}

Page.Render = {
    init: function() {
        var page = ['assess', 'policies', "critical_access"],
            fields = ["policies"];
        Locale.set("en", { fields: fields });
        Page.loadFieldsConfig(fields);
        Locale.loadPage(page);
        Header.load(page, { tabs: true, type: "policies" });
        new CriticalAccess().init();
    }
};