function CriticalAccess() {
    this.objects = {};
    this.templates = {
        wrap: '<div class="blocks">{policiesList}</div><div class="blocks">{policyEditor}</div>',
        loading: '<div class="loading"></div>',
        defaultEditorContent: 'Select policy for editing business roles.',
        managementsControls: {
            createButton: '<div class="new-policy-container"><button class="new-policy default">New policy</button></div>',
            save: '<button class="save">Save</button>',
            delete: '<button class="delete default">Delete</button>',
            confirmationRemove: '<span class="confirmation-remove"><a href="#" class="confirm-remove">Confirm</a><a href="#" class="cancel-remove">Cancel</a></span>'
        },
        editorForm: {
            rules: {
                fields: "<div class='field'><div class='name'>Policy structure:</div><div class='value'><select name='policyStructure'><option value='0'>-- Select structure policy --</option>{policiesStructure}</select></div></div>",
                option: "<option value='{name}'>{text}</option>",
                name: "<div class='field policyName'><div class='name'>Policy name:</div><div class='value'><input type='text' value='{value}' name='policyName' /></div></div>",
                risk: "<div data-colname='{colname}' data-rowname='{rowname}' class='risk-container'><select name='risk'><option value=''>No risk</option><option value='LOW'>Low</option><option value='MEDIUM'>Medium</option><option value='HIGH'>High</option><option value='CRITICAL'>Critical</option></select><div class='risk-description'><a href='#'>Risk description</a><div class='risk-description-text'></div></div>",
                riskDescription: '<div class="risk-description"><textarea name="risk-description"></textarea></div><div class="risk-description-submit"><button>Set</button></div>'
            },
            fields: "<div class='field'><div class='name'>Policy name:</div><div class='value'><input type='text' name='policyName' /></div>"
        },
        editorTreeElements: {
            businessProcess: {
                item: '<span class="BPNameContainer"><input type="text" value="{BPName}" placeholder="Business process name" name="BPName" /></span><a href="#" class="remove"></a>'
            },
            businessFunction: {
                item: '<span class="BFIDContainer"><input type="text" name="BFName" value="{BFName}" placeholder="Business function name" /></span><a href="#" class="remove"></a>'
            },
            businessAction: {
                item: '<span class="BATypeContainer"><select name="BAType" data-value="{BAType}"><option value="0">-- Select action type --</option><option value="TRANSACTION">Transaction code</option><option value="URL">URL</option><option value="RFC_FUNCTION">RFC function</option><option value="AUTH_OBJECTS">Auth objects</option></select></span><span class="BANameContainer"><input type="text" placeholder="Action name" value="{BAName}" name="BAName" /></span><a href="#" class="remove"></a><span class="BADescriptionContainer multiLineBlock"><textarea name="BADescription" placeholder="Action description">{BADescription}</textarea><span class="BARootGroupTypeContainer"><select name="BARootGroupType" data-value="{BARootGroupType}"><option value="0">-- Root group type --</option><option value="OR" selected="selected">OR</option><option value="AND">AND</option></select></span></span>'
            },
            authObjectsGroup: {
                item: '<span class="AOGroupTypeContainer">Grouping by <b><select name="groupingType" data-value="{AOGroupType}"><option value="OR">OR</option><option value="AND">AND</option></select></b></span><a href="#" class="remove"></a>'
            },
            authObject: {
                item: '<span class="AONameContainer"><input type="text" placeholder="Auth object name" value="{AOName}" name="AOName" /></span><a href="#" class="remove"></a>'
            },
            attribute: {
                item: '<span class="AOAttributeNameContainer"><input type="text" placeholder="Attribute name" value="{AOAttributeName}" name="AOAttributeName" /></span><span class="AOAttributeValueContainer"><input type="text" placeholder="Attribute value" value="{AOAttributeValue}" name="AOAttributeValue" /></span><a href="#" class="remove"></a>'
            }
        }
    };
    this.conversionFields = function(result, rules) {
        var data = [];
        for (var i = 0; i < result.length; i++) {
            var index = data.push({}) - 1;
            for (var field in rules) {
                if (typeof result[i][field] == "undefined") {
                    data[index][field] = rules[field].call(this, result[i], field, i);
                }
            }
            for (var field in result[i]) {
                var isset = typeof rules[field] != "undefined",
                    skip = isset && rules[field] == null;
                if (skip) {
                    continue;
                }
                data[index][field] = isset ? rules[field].call(this, result[i], field, i) : result[i][field];
            }
        }
        return data;
    };
    this.conversionFieldRules = {
        "listStructures": {
            "__addition": function(fields, name) {
                return "<a href=''></a>";
            },
            "author": function() {
                return "[Deleted user]";
            },
            "name": function(fields, name) {
                return {
                    value: fields[name]["en_US"],
                    attr: {
                        name: "id",
                        value: fields["id"]
                    }
                }
            },
            "id": null,
            "type": null,
            "subtype": null,
            "projectTypes": null,
            "isDefault": null,
            "basedOn": null,
            "structure": null
        },
        "listPolicyRules": {
            "__addition": function(fields, name) {
                return "<a href=''></a>";
            },
            "author": function() {
                return "[Deleted user]";
            },
            "name": function(fields, name) {
                return {
                    value: fields[name]["en_US"],
                    attr: {
                        name: "id",
                        value: fields["id"]
                    }
                }
            },
            "id": null,
            "type": null,
            "subtype": null,
            "projectTypes": null,
            "isDefault": null,
            "basedOn": null,
            "linkedTo": null,
            "rules": null
        },
        "listRules": {
            "__addition": function(fields, name) {
                return "<a href=''></a>";
            },
            "function1Name": function(fields, name) {
                var criterion = fields["criterion"];
                return criterion[0];
            },
            "function2Name": function(fields, name) {
                var criterion = fields["criterion"];
                return criterion[1];
            },
            "function3Name": function(fields, name) {
                var criterion = fields["criterion"];
                return criterion.length > 2 ? criterion[2] : "";
            },
            "function4Name": function(fields, name) {
                var criterion = fields["criterion"];
                return criterion.length > 3 ? criterion[3] : "";
            },
            "function5Name": function(fields, name) {
                var criterion = fields["criterion"];
                return criterion.length > 4 ? criterion[4] : "";
            },
            "criterion": null,
            "type": null
        }
    };
    this.BPStructureElements = ["businessProcesses", "businessRoles", "actions"];
    this.BPEditorTreeElements = {
        "businessProcess": {
            level: 1,
            hasChildren: true,
            child: "businessFunction",
            addingText: {
                "DEFAULT": {
                    text: "Add business process"
                }
            },
            fields: {
                "BPName": {
                    type: "text",
                    source: ["name", "{locale}"]
                }
            },
            structureChild: "businessRoles",
            structure: {
                "type": "SOD",
                "name" : {
                    "{locale}": "{BPName}"
                },
                "businessRoles": []
            }
        },
        "businessFunction": {
            level: 2,
            hasChildren: true,
            child: "businessAction",
            addingText: {
                "DEFAULT": {
                    text: "Add business function"
                }
            },
            fields: {
                "BFName": {
                    type: "text",
                    source: ["name", "{locale}"]
                }
            },
            structureChild: "actions",
            structure: {
                "name" : {
                    "{locale}": "{BFName}"
                },
                "actions": []
            }
        },
        "businessAction": {
            level: 3,
            hasChildren: true,
            child: "authObjectsGroup",
            addingText: {
                "DEFAULT": {
                    text: "Add business action"
                }
            },
            fields: {
                "BAType": {
                    type: "select",
                    callback: function() {
                        var $context = $(this);
                        $context.parent(".BATypeContainer").next(".BANameContainer")[$context.val() == 4 ? "hide" : "show"]();
                    },
                    source: ["type"]
                },
                "BAName": {
                    type: "text",
                    source: ["name"]
                },
                "BADescription": {
                    type: "textarea",
                    source: ["description", "{locale}"]
                },
                "BARootGroupType": {
                    type: "select",
                    source: ["BARootGroupType"]
                }
            },
            structure: {
                "type": "{BAType}",
                "name" : "{BAName}",
                "description" : {
                    "{locale}": "{BADescription}"
                },
                "authObjects": function($context) {
                    return this.generateCortege($context);
                }
            }
        },
        "authObjectsGroup": {
            level: 4,
            hasChildren: true,
            child: "authObject",
            addingText: {
                "DEFAULT": {
                    text: "Add object",
                    type: "authObject"
                },
                "OR": {
                    text: "Add group auth objects (OR operator)",
                    callback: function($item) {
                        $item.find("> .tree-item-content .text select[name=\"groupingType\"]").find("option").eq(2).attr("selected", "selected");
                    }
                },
                "AND": {
                    text: "Add group auth objects (AND operator)",
                    callback: function($item) {
                        $item.find("> .tree-item-content .text select[name=\"groupingType\"]").find("option").eq(1).attr("selected", "selected");
                    }
                }
            },
            fields: {
                "AOGroupType": {
                    type: "select"
                }
            },
            "groupType": {
                type: "text"
            }
        },
        "authObject": {
            level: 5,
            hasChildren: true,
            child: "attribute",
            addingText: {
                "DEFAULT": {
                    text: "Add object"
                },
                "OR": {
                    text: "Add group auth objects (OR operator)",
                    type: "authObjectsGroup"
                },
                "AND": {
                    text: "Add group auth objects (AND operator)",
                    type: "authObjectsGroup"
                }
            },
            fields: {
                "AOName": {
                    type: "text"
                }
            }
        },
        "attribute": {
            level: 6,
            hasChildren: false,
            addingText: {
                "DEFAULT": {
                    text: "Add attribute"
                }
            },
            fields: {
                "AOAttributeName": {
                    type: "text"
                },
                "AOAttributeValue": {
                    type: "text"
                }
            }
        }
    };
    this.rulesGroupObjects = {
        "AND": "&",
        "OR": "|"
    };
    this.loadPolicyRules = function(type, callback) {
        var o = this,
            subtype;
        switch (type) {
            case "rulesMatrix":
                subtype = "2WAY";
                break;
            case "rulesTable":
                subtype = "NWAY";
                break;
        }
        ERPScan.API.query("policyRules", "list", {
            callback: function(response) {
                o.objects[type] = response["data"]["result"];
                var policies = o.conversionFields.call(o, o.objects[type], o.conversionFieldRules.listPolicyRules);
                callback.call(o, type, policies);
            },
            params: {
                query: decodeURIComponent("(type='SOD')and(subtype='" + subtype + "')")
            }
        });
    };
    this.showPolicyRules = function(type, result) {
        if (typeof this.objects[type] == "undefined") {
            $(".block.policies-list > .block-content > .tabsWrapper > .block-content > div[data-name=\"" + type + "\"]").html(this.templates.loading);
            this.loadPolicyRules(type, this.showPolicyRules);
            return;
        } else if (result != null) {
            var tableObj = new Table({
                    data: result,
                    option: {
                        namespace: "policies",
                        type: "SODList",
                        sort_default: { column: 0, order: "asc" }
                    }
                }),
                tableHTML = tableObj.getHTML(),
                $table = $(tableHTML);
            $(".block.policies-list > .block-content > .tabsWrapper > .block-content > div[data-name=\"" + type + "\"]").html($table.find(".tablesorter").changeSelector(function() {}));
            $("section.content").find(".block.policies-list .block-content > div[data-name=\"" + type + "\"]").attr("id", $table.attr("id"));
            tableObj.build();
            tableObj.clickEventOff();
        }
    };
    this.showPolicyStructures = function(result) {
        var tableObj = new Table({
                data: result,
                option: {
                    namespace: "policies",
                    type: "SODList",
                    sort_default: { column: 0, order: "asc" }
                }
            }),
            tableHTML = tableObj.getHTML(),
            $table = $(tableHTML),
            tabsObj = new Tabs({
                container: $(".block.policies-editor .block-content"),
                locale: {
                    structures: "Structures",
                    rulesMatrix: "Rules (2-way)",
                    rulesTables: "Rules (n-way)"
                },
                tabs: {
                    structures: $(tableHTML).find(".tablesorter").changeSelector(function() {}),
                    rulesMatrix: "",
                    rulesTables: ""
                }
            }),
            policiesListBlock = new Block({
                title: "Policies list",
                content: tabsObj.getHTML(),
                class: "policies-list"
            }).getHTML(),
            editorBlock = new Block({
                title: "Editor",
                content: this.templates.defaultEditorContent,
                class: "policies-editor"
            }).getHTML();
        $("section.content").html(this.templates.wrap.format({
            policiesList: policiesListBlock,
            policyEditor: editorBlock
        })).find(".block.policies-list .block-content > div[data-name=\"structures\"]").attr("id", $table.attr("id"));
        $("section.content .block.policies-list h3").after(this.templates.managementsControls.createButton);
        $("section.content .block.policies-list").attr("data-type", "structures");
        tableObj.build();
        tableObj.clickEventOff();
    };
    this.loadPolicyStructures = function() {
        var o = this;
        ERPScan.API.query("policyStructures", "list", {
            callback: function(response) {
                o.objects.policyStructures = response["data"]["result"];
                var policies = o.conversionFields.call(o, o.objects.policyStructures, o.conversionFieldRules.listStructures);
                o.showPolicyStructures.call(o, policies);
            },
            params: {
                query: decodeURIComponent("type='SOD'")
            }
        });
    };
    this.newStructurePolicy = function() {
        this.showStructureEditor();
    };
    this.hideEditor = function() {
        $(".block.policies-editor > .block-content").html(this.templates.defaultEditorContent);
        $(".block.policies-editor > .save, .block.policies-editor > .delete").remove();
    };
    this.getCellsMatrix = function(businessRoles, risks) {
        var risks = [];
        for (var i = 0; i < businessRoles.length; i++) {
            var businessRole1 = businessRoles[i];
            if (risks[i] == null) {
                risks[i] = []
            }
            for (var j = 0; j < businessRoles.length; j++) {
                var businessRole2 = businessRoles[j];
                risks[i][j] = {
                    cell: i == j ? "" : this.templates.editorForm.rules.risk.format({
                        colname: businessRole1.name,
                        rowname: businessRole2.name
                    })
                };
            }
        }
        return risks;
    };
    this.showStructureEditor = function($policy) {
        $(".blocks table.tablesorter tbody tr").removeClass("active");
        var policyObj = null;
        if (typeof $policy != "undefined") {
            $policy.addClass("active");
            policyObj = this.objects.policyStructures[$policy.data("number")];
        }
        var tabsObj = new Tabs({
            container: $(".block.policies-editor .block-content"),
            locale: {
                treeView: "Tree view",
                tableView: "Table view"
            },
            tabs: {
                treeView: "",
                tableView: "Under construction..."
            }
        });
        $(".block.policies-editor .block-content").html(tabsObj.getHTML());
        this.objects.tree = new Tree($(".block.policies-editor .block-content div[data-name=\"treeView\"]"), this.BTTreeGet(policyObj == null ? [] : policyObj.structure), {
            expandWhenClick: false
        });
        this.objects.tree.init();
        $(".block.policies-editor .block-content > div[data-name=\"treeView\"]").prepend(this.templates.editorForm.fields);
        $(".block.policies-editor .block-content .block-tabs").before(this.templates.managementsControls.save);
        $(".block.policies-editor").attr("data-type", "structures").data("mode", policyObj != null ? "edit" : "add");
        if (policyObj != null) {
            $(".block.policies-editor .block-content input[name=\"policyName\"]").val(policyObj["name"]["en_US"]);
            $(".block.policies-editor").data("id", policyObj.id);
            $(".block.policies-editor .block-content .save").before(this.templates.managementsControls.delete);
            this.BTTreeSettingEnumFields();
        }
    };
    this.BTTreeSettingEnumFields = function () {
        $(".block.policies-editor .block-content > div[data-name=\"treeView\"] select[data-value]").each(function () {
            var $this = $(this),
                $option = $this.find("option[value=\"" + $this.attr("data-value") + "\"]");
            if ($option.length > 0) {
                $option[0].selected = true;
            }
        })
    };
    this.buildRulesMatrix = function(businessRoles, risks) {
        var businessRolesNames = [];
        for (var i = 0; i < businessRoles.length; i++) {
            businessRolesNames.push(businessRoles[i]["name"]);
        }
        var matrixData = this.getCellsMatrix(businessRoles, risks || null),
            params = {
                headling: "",
                colNames: businessRolesNames,
                rowNames: businessRolesNames,
                data: matrixData,
                tableClass: 'sod-matrix'
            },
            matrixObj = new MatrixOld(params),
            matrixHTML = matrixObj.getHTML();
        $(".block.policies-editor .block-content").append($(matrixHTML).find("table").changeSelector(function() {}));
    };
    this.showRules2WayEditor = function($policy) {
        $(".block.policies-editor > .save, .block.policies-editor > .delete").remove();
        $(".blocks table.tablesorter tbody tr").removeClass("active");
        var policyObj = null;
        if (typeof $policy != "undefined") {
            $policy.addClass("active");
            policyObj = this.objects["rulesMatrix"][$policy.data("number")];
        }
        var policiesStructureOptions = "";
        for (var i = 0; i < this.objects.policyStructures.length; i++) {
            policiesStructureOptions += this.templates.editorForm.rules.option.format({
                name: this.objects.policyStructures[i].id,
                text: this.objects.policyStructures[i].name["en_US"]
            });
        }
        var fields = this.templates.editorForm.rules.fields.format({
            policiesStructure: policiesStructureOptions
        });
        $(".block.policies-editor .block-content").html(this.templates.editorForm.rules.name.format({
                value: policyObj == null ? "" : policyObj["name"]["en_US"]
            }) + fields);
        $(".block.policies-editor .block-content").before(this.templates.managementsControls.save);
        $(".block.policies-editor").data("mode", policyObj != null ? "edit" : "add");
        $(".block.policies-editor").attr("data-type", "2WayRules");
        if (policyObj != null) {
            $(".block.policies-editor").data("id", policyObj.id);
            $(".block.policies-editor > .save").before(this.templates.managementsControls.delete);
            var policyStructureId = policyObj["basedOn"] == null ? null : policyObj["basedOn"]["policy"],
                $policy = $(".block.policies-editor .block-content select[name=\"policyStructure\"] option[value=\"" + policyStructureId + "\"]");
            if (policyStructureId != null && $policy.length > 0) {
                $policy[0].selected = true;
                var policyStructureObj = this.findPolicyStructure(policyStructureId),
                    roles = this.getBusinessRolesByStructure(policyStructureObj["structure"]);
                this.buildRulesMatrix(roles);
                this.fillRisksMatrix(policyObj["rules"]);
            }
        }
    };
    this.showRulesNWayEditor = function($policy) {
        $(".block.policies-editor > .save, .block.policies-editor > .delete").remove();
        $(".blocks table.tablesorter tbody tr").removeClass("active");
        var policyObj = null;
        if (typeof $policy != "undefined") {
            $policy.addClass("active");
            policyObj = this.objects["rulesTables"][$policy.data("number")];
        }
        var rulesTableObj = new Table({
            data: this.conversionFields(policyObj["rules"], this.conversionFieldRules.listRules),
            option: {
                namespace: "policies",
                type: "rulesList",
                sort_default: { column: 0, order: "asc" }
            }
        }),
            rulesTableHTML = rulesTableObj.getHTML(),
            $rulesTable = $(rulesTableHTML);
        var policiesStructureOptions = "";
        for (var i = 0; i < this.objects.policyStructures.length; i++) {
            policiesStructureOptions += this.templates.editorForm.rules.option.format({
                name: this.objects.policyStructures[i].id,
                text: this.objects.policyStructures[i].name["en_US"]
            });
        }
        var fields = this.templates.editorForm.rules.fields.format({
            policiesStructure: policiesStructureOptions
        });
        $(".block.policies-editor .block-content").html(this.templates.editorForm.rules.name.format({
                value: policyObj == null ? "" : policyObj["name"]["en_US"]
            }) + fields);
        $(".block.policies-editor .block-content").before(this.templates.managementsControls.save);
        $(".block.policies-editor").data("mode", policyObj != null ? "edit" : "add");
        $(".block.policies-editor").attr("data-type", "NWayRules");
        if (policyObj != null) {
            $(".block.policies-editor").data("id", policyObj.id);
            $(".block.policies-editor > .save").before(this.templates.managementsControls.delete);
            var policyStructureId = policyObj["basedOn"] == null ? null : policyObj["basedOn"]["policy"],
                $policy = $(".block.policies-editor .block-content select[name=\"policyStructure\"] option[value=\"" + policyStructureId + "\"]");
            if (policyStructureId != null && $policy.length > 0) {
                $policy[0].selected = true;
                $(".block.policies-editor .block-content").append($rulesTable.find(".tablesorter").changeSelector(function() {}));
                $(".block.policies-editor .block-content").attr("id", $rulesTable.attr("id"));
                rulesTableObj.build();
                rulesTableObj.clickEventOff();
            }
        }
    };
    this.new2WayRulesPolicy = function() {
        this.showRules2WayEditor();
    };
    this.fillRisksMatrix = function(rules) {
        for (var i = 0; i < rules.length; i++) {
            var selector = ".block.policies-editor table.sod-matrix td > div[data-colname=\"{colname}\"][data-rowname=\"{rowname}\"], .block.policies-editor table.sod-matrix td > div[data-colname=\"{rowname}\"][data-rowname=\"{colname}\"]".format({
                    colname: rules[i]["criterion"][0],
                    rowname: rules[i]["criterion"][1]
                }),
                $cell = $(selector);
            $cell.find("select[name=\"risk\"]").addClass(rules[i]["risk"]);
            $cell.find("select[name=\"risk\"] option[value=\"" + rules[i]["risk"] + "\"]").prop("selected", true);
            $cell.find(".risk-description-text").html(rules[i]["description"]);
        }
    };
    this.preLoad = function(callback) {
        callback.call(this);
    };
    this.BTTreeGetItemNameByLevel = function(level) {
        for (var item in this.BPEditorTreeElements) {
            if (this.BPEditorTreeElements[item].level == level) {
                return item;
            }
        }
        return -1;
    };
    this.BPTreeGetRoot = function() {
        return [{
            checkbox: false,
            expanded: true,
            text: "Business processes tree",
            nodes: [
                {
                    checkbox: false,
                    expanded: true,
                    data: {
                        type: "add-entity",
                        elements: "businessProcess"
                    },
                    text: this.BPEditorTreeElements["businessProcess"].addingText["DEFAULT"].text
                }
            ]
        }];
    };
    this.BTTreeWalkStructure = function(structure, parent, level) {
        var itemType = this.BTTreeGetItemNameByLevel(level),
            params = this.BPEditorTreeElements[itemType];
        for (var i = structure.length - 1; i >= 0 ; i--) {
            var nodes = [];
            if (params.hasChildren) {
                var childElementType = params.child,
                    childParams = this.BPEditorTreeElements[childElementType];
                for (var item in childParams.addingText) {
                    nodes.push({
                        text: childParams.addingText[item].text,
                        checkbox: false,
                        data: {
                            elements: childParams.addingText[item].type ? childParams.addingText[item].type : childElementType,
                            subelements: item,
                            type: "add-entity"
                        },
                        expandable: false,
                        level: childParams.level + 1
                    });
                }
            }
            var nodesChild;
            structure[i]["BARootGroupType"] = "OR";
            if (typeof structure[i][this.BPStructureElements[level]] != "undefined") {
                nodesChild = this.BTTreeWalkStructure(structure[i][this.BPStructureElements[level]], nodes, level + 1);
            } else if (itemType == "businessAction" && structure[i]["authObjects"] != null && structure[i]["authObjects"] != "") {
                var cortegeSubTree = this.BTTreeCortegeToStructure(structure[i]["authObjects"], [], level + 1);
                nodesChild = cortegeSubTree.nodes.concat(nodes);
                structure[i]["BARootGroupType"] = cortegeSubTree.rootGroupType || "OR";
            } else {
                nodesChild = nodes;
            }
            var text = this.templates.editorTreeElements[itemType].item;
            var templater = {};
            for (var field in params["fields"]) {
                var fieldObj = params["fields"][field],
                    fieldTarget = structure[i];
                if (typeof fieldObj["source"] == "undefined") {
                    continue;
                }
                for (var j = 0; j < fieldObj["source"].length; j++) {
                    var fieldName = fieldObj["source"][j];
                    if (fieldObj["source"][j].formatCheckVariable("locale")) {
                        fieldName = fieldObj["source"][j].format({
                            locale: "en_US"
                        });
                    }
                    fieldTarget = fieldTarget[fieldName];
                }
                templater[field] = fieldTarget;
            }
            text = text.format(templater);
            parent.unshift({
                checkbox: false,
                expanded: true,
                text: text,
                nodes: nodesChild,
                level: childParams.level
            });
        }
        return parent;
    };
    this.cortegeToHierarchy = function (authObjects) {
        var ast = {
                parent: null,
                elements: []
            },
            root = {
                elements: [],
                parent: ast
            };
        ast.elements.push(root);
        var pointer = root,
            buffer = "";
        for (var i = 0; i < authObjects.length; i++) {
            switch (authObjects[i]) {
                case "(":
                    pointer.value = buffer;
                    buffer = "";
                    var item = {
                        elements: [],
                        parent: pointer
                    };
                    pointer.elements.push(item);
                    pointer = item;
                    break;
                case ")":
                    if (pointer.value == null) {
                        pointer.value = buffer;
                    }
                    pointer = pointer.parent;
                    buffer = "";
                    break;
                case ",":
                    var item = {
                        elements: [],
                        parent: pointer.parent
                    };
                    pointer.parent.type = ",";
                    pointer.parent.elements.push(item);
                    pointer = item;
                    break;
                case "|":
                    var item = {
                        elements: [],
                        parent: pointer.parent
                    };
                    pointer.parent.type = "|";
                    pointer.parent.elements.push(item);
                    pointer = item;
                    break;
                case "&":
                    var item = {
                        elements: [],
                        parent: pointer.parent
                    };
                    pointer.parent.type = "&";
                    pointer.parent.elements.push(item);
                    pointer = item;
                    break;
                default:
                    buffer += authObjects[i];
                    break;
            }
        }
        return ast;
    };
    this.BTTreeCortegeToStructureWalk = function (hierarchy, parent, level) {
        for (var i = 0; i < hierarchy.length; i++) {
            var itemType = "authObject",
                nodes = [];
            if (hierarchy[i].type == ",") {
                itemType = "authObject";
            }
            if (hierarchy[i]["AOName"] == "" || hierarchy[i]["value"] == "") {
                itemType = "authObjectsGroup";
            }
            if (typeof hierarchy[i]["elements"] == "undefined") {
                itemType = "attribute";
            }
            var params = this.BPEditorTreeElements[itemType];
            if (params.hasChildren) {
                var childElementType = params.child,
                    childParams = this.BPEditorTreeElements[childElementType];
                for (var item in childParams.addingText) {
                    nodes.push({
                        text: childParams.addingText[item].text,
                        checkbox: false,
                        data: {
                            elements: childParams.addingText[item].type ? childParams.addingText[item].type : childElementType,
                            subelements: item,
                            type: "add-entity"
                        },
                        expandable: false,
                        level: childParams.level + 1
                    })
                }
            }
            var text = this.templates.editorTreeElements[itemType].item;
            var templater = {};
            for (var field in params["fields"]) {
                templater[field] = hierarchy[i][field];
            }
            text = text.format(templater);
            parent.push({
                checkbox: false,
                expanded: true,
                text: text + "",
                level: params["level"] + 1
            });
            if (hierarchy[i].elements != null && hierarchy[i].elements.length != 0) {
                parent[parent.length - 1].nodes = this.BTTreeCortegeToStructureWalk(hierarchy[i].elements, [], level + 1).concat(nodes);
            }
        }
        return parent;
    };
    this.cortegeHierarchyNormalize = function (hierarchy) {
        var elementsNumber = hierarchy["elements"].length;
        for (var i = 0; i < elementsNumber; i++) {
            if (hierarchy["elements"][i]["elements"].length == 0) {
                hierarchy["elements"][i].parent["AOAttributeName"] = hierarchy["elements"][i].parent["AOName"];
                hierarchy["elements"][i].parent["AOAttributeValue"] = hierarchy["elements"][i].value;
                delete hierarchy["elements"][i].parent.value;
                delete hierarchy["elements"][i].parent["AOName"];
                delete hierarchy["elements"][i].parent.parent;
                delete hierarchy["elements"];
                return;
            } else {
                if (hierarchy["elements"][i].type != "&" && hierarchy["elements"][i].type != "|") {
                    hierarchy["elements"][i]["AOName"] = hierarchy["elements"][i].value;
                    delete hierarchy["elements"][i].value;
                }
                if (hierarchy["elements"][i].type == "&") {
                    hierarchy["elements"][i]["AOGroupType"] = "AND";
                }
                if (hierarchy["elements"][i].type == "|") {
                    hierarchy["elements"][i]["AOGroupType"] = "OR";
                }
                this.cortegeHierarchyNormalize(hierarchy["elements"][i]);
            }
            delete hierarchy.parent;
        }
    };
    this.correctSequenceBrackets = function(str) {
        var counter = 0;
        for (var i = 0; i < str.length; i++) {
            if (str[i] == '(') {
                counter++;
            } else if (str[i] == ')') {
                counter--;
            }
            if (counter < 0) {
                return false;
            }
        }
        return counter == 0;
    };
    this.clearUnnecessaryBrackets = function(authObjects) {
        var correctSequenceBrackets;
        while (correctSequenceBrackets = this.correctSequenceBrackets(authObjects)) {
            if (authObjects.substr(0,1) == "(" && authObjects.substr(authObjects.length - 1, 1) == ")") {
                authObjects = authObjects.substr(1, authObjects.length - 2);
            } else {
                break;
            }
        }
        if (!correctSequenceBrackets) {
            authObjects = "(" + authObjects + ")";
        }
        return authObjects;
    };
    this.BTTreeCortegeToStructure = function (authObjects, parent, level) {
        authObjects = authObjects.replace(/\[/g, "(").replace(/]/g, ")");
        authObjects = this.clearUnnecessaryBrackets(authObjects);
        var hierarchy = this.cortegeToHierarchy(authObjects);
        this.cortegeHierarchyNormalize(hierarchy);
        var nodes = this.BTTreeCortegeToStructureWalk(hierarchy["elements"], parent, level),
            rootGroupType;
        switch (hierarchy["type"]) {
            case "|":
                rootGroupType = "OR";
                break;
            case "&":
                rootGroupType = "AND";
                break;
        }
        return {
            rootGroupType: rootGroupType,
            nodes: nodes
        };
    };
    this.BTTreeGet = function(structure) {
        var root = this.BPTreeGetRoot();
        if (structure != null) {
            this.BTTreeWalkStructure(structure, root[0].nodes, 1);
        }
        return root;
    };
    this.BPTreeAddElement = function($context, option) {
        option = option || {};
        option.type = option.type || "businessProcess";
        var params = this.BPEditorTreeElements[option.type],
            text = this.templates.editorTreeElements[option.type].item;
        if (option.itemFormat != null) {
            text = text.format(option.itemFormat);
        }
        if (option.orderEndAddingElement == null) {
            option.orderEndAddingElement = 1;
        }
        var $newElement = this.objects.tree.addItemBefore($context.find("> .nodes").find("> .tree-item:nth-last-child(" + option.orderEndAddingElement + ")").find(".tree-item-content"), {
            text: text,
            checkbox: false,
            expandable: params.hasChildren,
            level: params.level + 1
        });
        if (typeof option.itemFormat != "undefined" && typeof option.itemFormat.groupType != "undefined" && typeof params.addingText[option.itemFormat.groupType].callback == "function") {
            params.addingText[option.itemFormat.groupType].callback($newElement);
        }
        for (var item in params.fields) {
            if (params.fields[item].callback) {
                $newElement.find("*[name=\"" + item + "\"]").on("change", params.fields[item].callback);
            }
        }
        if (params.hasChildren) {
            var childElementType = this.BPEditorTreeElements[option.type].child,
                childParams = this.BPEditorTreeElements[childElementType];
            for (var item in childParams.addingText) {
                this.objects.tree.addItemAppend($newElement.find(".tree-item-content"), {
                    text: childParams.addingText[item].text,
                    checkbox: false,
                    data: {
                        elements: childParams.addingText[item].type ? childParams.addingText[item].type : childElementType,
                        subelements: item,
                        type: "add-entity"
                    },
                    expandable: false,
                    level: childParams.level + 1
                });
            }
        }
    };
    this.BPTreeRemoveElement = function($item) {
        $item.remove();
    };
    this.formatStructure = function(structure, structureFormatted, variables, $context) {
        for (var structureElement in structure) {
            if (typeof structure[structureElement] == "object") {
                this.formatStructure(structure[structureElement], structureFormatted[structureElement], variables, $context);
            } else {
                var key = structureElement, value = "";
                if (typeof structure[structureElement] != "function") {
                    value = structure[structureElement].format(variables);
                } else {
                    value = structure[structureElement].call(this, $context);
                }
                if (key.formatCheckVariable("locale")) {
                    key = key.format({
                        "locale": "en_US"
                    });
                    delete structureFormatted["{locale}"];
                }
                structureFormatted[key] = value.toString();
            }
        }
        return structureFormatted;
    };
    this.collectStructureValues = function(element, structure, $context) {
        var paramsElement = this.BPEditorTreeElements[element],
            o = this;
        if (typeof paramsElement.structure != "undefined") {
            $context.find(".tree-item.level-{level}[data-type!=\"add-entity\"]".format({level: paramsElement.level + 1})).each(function() {
                var $this = $(this),
                    variables = {};
                for (var field in paramsElement.fields) {
                    var $item = $this.find("> .tree-item-content > .text *[name=\"{field}\"]".format({field: field}));
                    if (paramsElement.fields[field].type == "select") {
                        variables[field] = $item.find("option:selected").val();
                    } else {
                        variables[field] = $item.val();
                    }
                }
                var formattedStructure = o.formatStructure(paramsElement.structure, $.extend(true, {}, paramsElement.structure), variables, $this);
                var structureIndex = structure.push(formattedStructure) - 1;
                if (paramsElement.structureChild) {
                    structure[structureIndex][paramsElement.structureChild] = o.collectStructureValues.call(o, paramsElement.child, structure[structureIndex][paramsElement.structureChild], $this);
                }
            });
        }
        return structure;
    };
    this.getObjectAttrs = function($attrs) {
        var attrs = [];
        $attrs.each(function() {
            var $this = $(this),
                name = $this.find("*[name=\"AOAttributeName\"]").val(),
                value = $this.find("*[name=\"AOAttributeValue\"]").val();
            attrs.push({
                name: name,
                value: value
            });
        });
        return attrs;
    };
    this.objectAttrsToCortege = function(attrs) {
        for (var i = 0; i < attrs.length; i++) {
            attrs[i] = "{name}({value})".format({
                name: attrs[i].name,
                value: attrs[i].value
            });
        }
        attrs = attrs.join(",");
        return attrs;
    };
    this.getRootGroupObjectsType = function($nodes) {
        var $item = $($nodes.context);
        return $item.find("> .tree-item-content > .text .BARootGroupTypeContainer select").val();
    };
    this.collectObjects = function($root, cortege, level, groupTypeParent) {
        var o = this;
        $root.filter(".level-{level}".format({ level: this.BPEditorTreeElements["authObjectsGroup"].level + 1 })).each(function() {
            var $this = $(this),
                selector = "> .nodes > .tree-item.level-{levelGroup}[data-type!=\"add-entity\"], > .nodes > .tree-item.level-{levelObject}[data-type!=\"add-entity\"]",
                $childElements = $this.find(selector.format({
                    levelGroup: o.BPEditorTreeElements["authObjectsGroup"].level + 1,
                    levelObject: o.BPEditorTreeElements["authObject"].level + 1
                }));
            var groupType = $this.find("> .tree-item-content .text .AOGroupTypeContainer select").val(),
                objects = o.collectObjects($childElements, cortege, level + 1, groupType);
            var objectsForGrouping = [];
            var groups = [];
            for (var i = objects.length - 1; i >= 0; i--) {
                if (objects[i]["level"] == level) {
                    objectsForGrouping.push(objects[i]["item"]);
                } else {
                    groups.push(objects[i]["item"]);
                }
            }
            cortege = [];
            cortege.push({
                item: (objectsForGrouping.length > 0 ? ("{group}{operator}".format({ group: objectsForGrouping.join(o.rulesGroupObjects[groupType]), operator: o.rulesGroupObjects[groupTypeParent] })) : "") + "[{group}]".format({ group: groups.join(o.rulesGroupObjects[groupType]) }),
                level: level
            });
        });
        $root.filter(".level-{level}".format({ level: this.BPEditorTreeElements["authObject"].level + 1 })).each(function() {
            var $this = $(this);
            var selectorAttributes = "> .nodes > .tree-item.level-{levelAttr}[data-type!=\"add-entity\"]",
                $objectAttributes = $this.find(selectorAttributes.format({
                    levelAttr: o.BPEditorTreeElements["attribute"].level + 1
                })),
                attributes = [];
            if ($objectAttributes.length > 0) {
                attributes = o.getObjectAttrs($objectAttributes);
            }
            attributes = o.objectAttrsToCortege(attributes);
            cortege.push({
                item: "{objectName}({attributes})".format({
                    objectName: $this.find("> .tree-item-content input[name=\"AOName\"]").val(),
                    attributes: attributes
                }),
                level: level
            });
        });
        return cortege;
    };
    this.generateCortege = function($context) {
        var selector = "> .nodes > .tree-item.level-{levelGroup}[data-type!=\"add-entity\"], > .nodes > .tree-item.level-{levelObject}[data-type!=\"add-entity\"]",
            $objects = $context.find(selector.format({
                levelGroup: this.BPEditorTreeElements["authObjectsGroup"].level + 1,
                levelObject: this.BPEditorTreeElements["authObject"].level + 1
            })),
            cortege = this.collectObjects($objects, [], 1, this.getRootGroupObjectsType($objects));
        var cortegeString = [];
        for (var i = 0; i < cortege.length; i++) {
            cortegeString.push(cortege[i]["item"]);
        }
        return cortegeString.join(this.rulesGroupObjects[this.getRootGroupObjectsType($objects)]);
    };
    this.structureSave = function($button) {
        $button.attr("disabled", "disabled").html("Saving...");
        var structure = this.collectStructureValues("businessProcess", [], $(".block.policies-editor .tree-item.level-1[data-type!=\"add-entity\"]")),
            mode = $(".block.policies-editor").data("mode"),
            params = {
                name: {
                    "en_US": $(".policies-editor input[name=\"policyName\"]").val()
                },
                type: "SOD",
                subtype: "structure",
                projectTypes: ["SOD"],
                structure: structure
            };
        if (mode == "edit") {
            params["id"] = $(".block.policies-editor").data("id");
        }
        ERPScan.API.query("policyStructures", mode, {
            callback: function(result) {
                $button.removeAttr("disabled").html("Save");
            },
            error: function() {
                $button.removeAttr("disabled").html("Save");
            },
            type: "POST",
            params: {
                data: JSON.stringify(params)
            }
        });
    };
    this.structureDelete = function($button) {
        var callback = function () {
            $(".block.policies-editor .block-content").html("Select policy for editing business roles.");
        };
        new PopupConfirm({
            text: "Are you sure?",
            callback: function () {
                $button.attr("disabled", "disabled").html("Deleting...");
                ERPScan.API.query("policyStructures", "delete", {
                    callback: callback,
                    error: callback,
                    type: "GET",
                    params: {
                        id: $(".block.policies-editor").data("id")
                    }
                });
            }
        }).show()
    };
    this.collectRulesValues = function() {
        var rules = [],
            $tr = $("table.sod-matrix tr");
        $tr.filter(":gt(0)").each(function() {
            var $tr = $(this),
                trIndex = $tr.index();
            $tr.find("td").filter(":gt(0)").each(function() {
                var $td = $(this),
                    $riskContainer = $td.find(".risk-container");
                if (trIndex > $td.index()) {
                    rules.push({
                        "type"        : "RULE_SOD",
                        "name"        : "",
                        "description" : $riskContainer.find(".risk-description .risk-description-text").text(),
                        "risk"        : $riskContainer.find("select[name=\"risk\"]").val(),
                        "criterion"   : [$riskContainer.attr("data-colname"),$riskContainer.attr("data-rowname")]
                    });
                }
            })
        });
        return rules;
    };
    this.rulesSave = function($button) {
        $button.attr("disabled", "disabled").html("Saving...");
        var rules = this.collectRulesValues(),
            mode = $(".block.policies-editor").data("mode"),
            params = {
                name: {
                    "en_US": $(".policies-editor input[name=\"policyName\"]").val()
                },
                type: "SOD",
                subtype: "2WAY",
                basedOn: {
                    policy: $(".policies-editor select[name=\"policyStructure\"]").val()
                },
                projectTypes: ["SOD"],
                rules: rules
            };
        if (mode == "edit") {
            params["id"] = $(".block.policies-editor").data("id");
        }
        ERPScan.API.query("policyRules", mode, {
            callback: function(result) {
                $button.removeAttr("disabled").html("Save");
            },
            error: function() {
                $button.removeAttr("disabled").html("Save");
            },
            type: "POST",
            params: {
                data: JSON.stringify(params)
            }
        });
    };
    this.rulesDelete = function($button) {
        var callback = function () {
            $(".block.policies-editor > .save, .block.policies-editor > .delete").remove();
            $(".block.policies-editor .block-content").html("Select policy for editing business roles.");
        };
        new PopupConfirm({
            text: "Are you sure?",
            callback: function () {
                $button.attr("disabled", "disabled").html("Deleting...");
                ERPScan.API.query("policyRules", "delete", {
                    callback: callback,
                    error: callback,
                    type: "GET",
                    params: {
                        id: $(".block.policies-editor").data("id")
                    }
                });
            }
        }).show()
    };
    this.BPTreeRemoveElementConfirmation = function($item) {
        $item.find("> .tree-item-content > .text > .remove").hide().after(this.templates.managementsControls.confirmationRemove);
    };
    this.BPTreeRemoveElementCancel = function($item) {
        $item.find("> .tree-item-content > .text > .confirmation-remove").remove();
        $item.find("> .tree-item-content > .text > .remove").show();
    };
    this.findPolicyStructure = function(policyId) {
        for (var i = 0; i < this.objects.policyStructures.length; i++) {
            if (this.objects.policyStructures[i].id == policyId) {
                return this.objects.policyStructures[i];
            }
        }
        return null;
    };
    this.getBusinessRolesByStructure = function(structure) {
        var businessRolesAll = [];
        for (var i = 0; i < structure.length; i++) {
            var businessRoles = structure[i]["businessRoles"];
            for (var j = 0; j < businessRoles.length; j++) {
                if (businessRolesAll.indexOf(businessRoles[j]) == -1) {
                    businessRolesAll.push({
                        id: businessRoles[j]["id"],
                        name: businessRoles[j]["name"]["en_US"]
                    });
                }
            }
        }
        return businessRolesAll;
    };
    this.showPopupSettingRiskDescription = function($riskDescription) {
        this.objects.settingDescriptionPopup = new Popup({
            class: 'riskDescription',
            title: 'Setting risk description',
            content: this.templates.editorForm.rules.riskDescription
        });
        this.objects.settingDescriptionPopup.show();
        $(".popup.riskDescription").data("colname", $riskDescription.parent(".risk-container").attr("data-colname"))
            .data("rowname", $riskDescription.parent(".risk-container").attr("data-rowname"));
        $(".popup.riskDescription .risk-description textarea").html($riskDescription.find(".risk-description-text").html()).focus();
    };
    this.changeRisk = function($riskContainer) {
        var businessRole1 = $riskContainer.attr("data-colname"),
            businessRole2 = $riskContainer.attr("data-rowname"),
            value = $riskContainer.find("select[name=\"risk\"]").val(),
            $symmetricCell = $(".block.policies-editor table.sod-matrix td > div[data-colname=\"" + businessRole2 + "\"][data-rowname=\"" + businessRole1 + "\"]"),
            $riskSymmetricSelect = $symmetricCell.find("select[name=\"risk\"]"),
            $riskSelect = $riskContainer.find("select[name=\"risk\"]");
        $riskSymmetricSelect.find("option[value=\"" + value + "\"]")[0].selected = true;
        $riskSymmetricSelect.attr("class", $riskSelect.val());
        $riskSelect.data("riskClass", $riskSelect.val());
    };
    this.changeRiskDescription = function(colname, rowname, description) {
        var selector = ".block.policies-editor table.sod-matrix td > div[data-colname=\"{colname}\"][data-rowname=\"{rowname}\"], .block.policies-editor table.sod-matrix td > div[data-colname=\"{rowname}\"][data-rowname=\"{colname}\"]".format({
                colname: colname,
                rowname: rowname
            }),
            $cell = $(selector);
        $cell.find(".risk-description-text").html(description);
    };
    this.handlers = function() {
        var o = this;
        $(document.body).on("click", ".blocks .block-content > div[data-name=\"structures\"] table.tablesorter tbody tr", function() {
            var $this = $(this);
            o.showStructureEditor($this);
        });
        $(document.body).on("click", ".blocks .block-content > div[data-name=\"rulesMatrix\"] table.tablesorter tbody tr", function() {
            var $this = $(this);
            o.showRules2WayEditor($this);
        });
        $(document.body).on("click", ".blocks .block-content > div[data-name=\"rulesTables\"] table.tablesorter tbody tr", function() {
            var $this = $(this);
            o.showRulesNWayEditor($this);
        });
        $(document.body).on("click", ".block.policies-list .block-tabs > a[data-name=\"rulesMatrix\"], .block.policies-list .block-tabs > a[data-name=\"rulesTables\"]", function() {
            var $this = $(this),
                type = $this.attr("data-name");
            o.showPolicyRules.call(o, type);
        });
        $(document.body).on("click", ".blocks .block.policies-editor .risk-description > a", function() {
            var $this = $(this);
            o.showPopupSettingRiskDescription($this.parent(".risk-description"));
            return false;
        });
        $(document.body).on("click", ".popup.riskDescription .risk-description-submit button", function() {
            var $this = $(this),
                description = $this.parent(".risk-description-submit").prev(".risk-description").find("textarea").val(),
                $popup = $(".popup.riskDescription"),
                colname = $popup.data("colname"),
                rowname = $popup.data("rowname");
            o.changeRiskDescription(colname, rowname, description);
            o.objects.settingDescriptionPopup.close();
            return false;
        });
        $(document.body).on("change", ".blocks .block.policies-editor select[name=\"risk\"]", function() {
            var $this = $(this);
            o.changeRisk($this.parent(".risk-container"));
            return false;
        });
        $(document.body).on("focus", ".blocks .block.policies-editor select[name=\"risk\"]", function() {
            var $this = $(this);
            $this.data("riskClass", $this.attr("class"));
            $this.removeAttr("class");
            return false;
        });
        $(document.body).on("blur", ".blocks .block.policies-editor select[name=\"risk\"]", function() {
            var $this = $(this);
            $this.attr("class", $this.data("riskClass"));
            return false;
        });
        $(document.body).on("change", ".policies-editor .block-content select[name=\"policyStructure\"]", function() {
            var $this = $(this),
                policyId = $this.val();
            $(".block.policies-editor table.sod-matrix").remove();
            if (policyId == 0) {
                return false;
            }
            var policyObj = o.findPolicyStructure(policyId),
                roles = o.getBusinessRolesByStructure(policyObj["structure"]);
            o.buildRulesMatrix.call(o, roles);
            return false;
        });
        $(document.body).on("click", ".policies-editor .tree-item .tree-item-content .text .remove", function() {
            var $this = $(this),
                $item = $this.parent(".text").parent(".tree-item-content").parent(".tree-item");
            o.BPTreeRemoveElementConfirmation.call(o, $item);
            return false;
        });
        $(document.body).on("click", ".policies-editor .tree-item .tree-item-content .text .confirmation-remove .confirm-remove", function() {
            var $this = $(this),
                $item = $this.parent(".confirmation-remove").parent(".text").parent(".tree-item-content").parent(".tree-item");
            o.BPTreeRemoveElement.call(o, $item);
            return false;
        });
        $(document.body).on("click", ".policies-editor .tree-item .tree-item-content .text .confirmation-remove .cancel-remove", function() {
            var $this = $(this),
                $item = $this.parent(".confirmation-remove").parent(".text").parent(".tree-item-content").parent(".tree-item");
            o.BPTreeRemoveElementCancel.call(o, $item);
            return false;
        });
        $(document.body).on("click", ".policies-editor[data-type=\"structures\"] .save", function() {
            var $this = $(this);
            o.structureSave.call(o, $this);
        });
        $(document.body).on("click", ".policies-editor[data-type=\"structures\"] .delete", function() {
            var $this = $(this);
            $(".blocks table.tablesorter tbody tr.active").fadeOut(500, function () {
                $(this).remove();
            });
            o.structureDelete.call(o, $this);
        });
        $(document.body).on("click", ".policies-editor[data-type=\"2WayRules\"] .save", function() {
            var $this = $(this);
            o.rulesSave.call(o, $this);
        });
        $(document.body).on("click", ".policies-editor[data-type=\"2WayRules\"] .delete", function() {
            var $this = $(this);
            $(".blocks table.tablesorter tbody tr.active").fadeOut(500, function () {
                $(this).remove();
            });
            o.rulesDelete.call(o, $this);
        });
        $(document.body).on("click", ".block.policies-list[data-type=\"structures\"] > .new-policy-container button.new-policy", function() {
            var $this = $(this);
            o.newStructurePolicy.call(o, $this);
        });
        $(document.body).on("click", ".block.policies-list[data-type=\"rulesMatrix\"] > .new-policy-container button.new-policy", function() {
            var $this = $(this);
            o.new2WayRulesPolicy.call(o, $this);
        });
        $(document.body).on("click", ".policies-editor .tree-item[data-type=\"add-entity\"] .tree-item-content .text", function() {
            var $this = $(this),
                $item = $this.parent(".tree-item-content").parent(".tree-item"),
                type = $item.attr("data-elements"),
                params = {
                    type: $item.attr("data-elements")
                };
            if (type == "authObjectsGroup") {
                var subelements = $item.attr("data-subelements");
                params.itemFormat = {
                    groupType: $item.attr("data-subelements")
                };
            }
            params.orderEndAddingElement = $item.parent(".nodes").find("> .tree-item[data-type=\"add-entity\"]").length;
            o.BPTreeAddElement($item.parent(".nodes").parent(".tree-item"), params);
        });
        $(document.body).on("click", ".policies-list .block-tabs > a:not(.active)", function() {
            var $this = $(this);
            $(".block.policies-list").attr("data-type", $this.attr("data-name"));
            $(".block.policies-list > .block-content tr").removeClass("active");
            o.hideEditor.call(o);
        });
    };
    this.init = function() {
        $("section.content").html(Header.templates.tabs.loading);
        this.preLoad(this.loadPolicyStructures);
        this.handlers();
    }
}

Page.Render = {
    init: function() {
        var page = ['assess', 'policies', "sod"],
            fields = ["policies"];
        Locale.set("en", { fields: fields });
        Page.loadFieldsConfig(fields);
        Locale.loadPage(page);
        Header.load(page, { tabs: true, type: "policies" });
        new CriticalAccess().init();
    }
};