function Policies(tab) {
    this.tab = tab;
    this.checkCats = [];
    this.checkCatsAuxiliary = {};
    this.checkCatsSelected = {};
    this.checks = {};
    this.policies = [];
    this.users = [];
    this.table = null;
    this.templates = {
        blocks: '<div class="blocks"><div class="block col-2">%s</div></div>',
        block: '<h3>' + Locale.ui.page.check_list_block + '</h3><div class="check-list"><p class="no-entry">' + Locale.ui.page.no_entry + '</p></div>',
        create: "<div class='create-button'><button>" + Locale.ui.page.buttons.new + "</button></div>",
        actions: '<div class="actions"><button class="default expand-all">' + Locale.ui.page["buttons"]["expand_all"] + '</button><button class="save">' + Locale.ui.page["buttons"]["save"] + '</button></div>',
        template_risk: '<a href="#" class="template-risk"></a>',
        check_info: '<a href="#" class="check-info"></a>',
        check_info_popup: {
            wrap: '<div class="check-fields-1">%s</div><div class="check-fields-2">%s</div>',
            field: '<div class="field"><div class="field-name">%s: </div><div class="field-value">%s</div></div>'
        },
        template_risk_popup: {
            wrap: '<div class="check-name">%s</div><div class="field"><div class="name">%s:</div><div class="input"><select>%s</select></div></div><div class="buttons"><button class="save">%s</button></div>',
            risk: '<option value="%s">%s</option>'
        },
        new_policy_popup: {
            wrap: '<div class="field"><div class="name">%s:</div><div class="input"><input type="text" name="policy_name"></div></div><div class="buttons"><button class="save">%s</button></div>'
        },
        policy_rename: "<a href='#' class='policy_rename'></a>",
        policy_remove: "<a href='#' class='policy_remove'></a>",
        policy_rename_popup: {
            wrap: '<div class="field"><div class="name">%s:</div><div class="input"><input type="text" name="policy_name"></div></div><div class="buttons"><button class="save">%s</button></div>'
        },
        filters: {
            wrap: '<div class="filters"></div>',
            controls: {
                input: "<input type='text' name='%s' placeholder='%s' />",
                select: "<select name='%s'>%s</select>",
                option: "<option value='%s'>%s</option>"
            },
            list: {
                title: {
                    type: "input",
                    field: "title_" + Locale.name
                },
                prototype: {
                    type: "select",
                    field: "prototype",
                    data: function() { return this.prototypes; }
                }
            }
        }
    };
    this.projectTypes = {
        "audit": {
            name: "AUD",
            cats: [1, 2]
        },
        "pentest": {
            name: "AUD",
            cats: [1, 2],
            addition: {
                run_anonym: true
            }
        },
        "compliance": {
            name: "AUD",
            cats: [1, 2]
        },
        "code_scanning": {
            name: "CHC",
            cats: [4]
        }
    };
    this.template_risks = {
        "TEMPLATE_LOW": "low",
        "TEMPLATE_MEDIUM": "medium",
        "TEMPLATE_HIGH": "high",
        "TEMPLATE_CRITICAL": "critical"
    };
    this.catsTreeWalk = function($items, item, level, checkCatsAuxiliary) {
        var o = this;
        if (level == 1) {
            var filter = "[id=" + o.projectTypes[o.tab].cats.join("], [id=") + "]";
            $items = $items.filter(filter);
        }
        $items.each(function() {
            var $this = $(this);
            var id = $this.attr("id");
            var name = $this.find("> name").text();
            var $child = $this.find("> item");
            var obj = {
                text: name,
                checkbox: true,
                data: {
                    info: id
                }
            };
            if (level == 1) {
                obj.expanded = true;
            }
            if ($child.length > 0) {
                obj.nodes = [];
            } else {
                obj.hidden = true;
            }
            var count = item.push(obj);
            checkCatsAuxiliary[id] = {
                index: count - 1,
                nodes: {}
            };
            if ($child.length > 0) {
                o.catsTreeWalk($child, item[count - 1].nodes, level + 1, checkCatsAuxiliary[id].nodes);
            }
        });
    };
    this.setCheckRisks = function(cats, id) {
        for (var i = 0; i < cats.length; i++) {
            if (typeof this.checks[cats[i]["check_id"]].templates == "undefined") {
                this.checks[cats[i]["check_id"]].templates = {};
            }
            this.checks[cats[i]["check_id"]].templates[id] = cats[i]["TEMPLATE_RISK"];
        }
    };
    this.conversionPoliciesList = function(result) {
        var data = [];
        var o = this;
        $("listscantemplates > scantemplate", result).each(function() {
            var $this = $(this);
            var projectType = $this.find("projecttype").text();
            if (projectType == o.projectTypes[o.tab].name) {
                var id = $this.find("id").text();
                var author = o.users[$this.find("authorid").text()].login;
                var update = new Date($this.find("lastupdated").text() * 1).toDateString();
                var create_date = new Date($this.find("created").text() * 1).toDateString();
                var catsInfo = $.parseJSON($this.find("data").text());
                if (catsInfo["cats"]) {
                    o.checkCatsSelected[id] = catsInfo["cats"].split(",");
                }
                data.push({
                    __addition: '<a href="#"></a>',
                    'id': id,
                    'name': '<span class="name">' + $this.find("name").text().encodeHTML() + '</span>' + o.templates.policy_remove + o.templates.policy_rename,
                    'author': author,
                    'updated': update,
                    'created': create_date,
                    'number_checks': o.checkCatsSelected[id] ? o.checkCatsSelected[id].length : 0,
                    'number_projects': 0
                });
                if (catsInfo["checks_changes"]) {
                    o.setCheckRisks.call(o, catsInfo["checks_changes"], id);
                }
            }
        });
        return data;
    };
    this.buildPoliciesTable = function() {
        var o = this;
        var number = 1;
        var params = {
            title: Locale.ui.page["table_policies_block"],
            data: o.policies,
            option: {
                fields: "policies",
                ticks: {
                    __addition: 0,
                    'name': 1,
                    'author': 2,
                    'id': -1,
                    'updated': -1,
                    'created': -1,
                    'number_checks': -1,
                    'number_projects': -1
                },
                sorting: {
                    0: false
                },
                filters: {
                    id: "input",
                    number_checks: "input",
                    number_projects: "input",
                    name: "input",
                    update: "datetime",
                    create: "datetime"
                },
                sort_default: { column: 1, order: "asc" },
                count_one_page: 50
            }
        };
        this.table = new Table(params);
        var html = this.table.getHTML(),
            section = $('section.content');
        $(".blocks").append(html);
        $(".blocks .table .actions-bar").append(this.templates.create);
        this.table.build();
        Helpers.setBlockHeight(section);
        /*
         Table.handlers({ select_callback: function($this) {
         o.selectPolicy($this);
         } });
         */
    };
    this.catsTreeAddChecks = function() {
        for (var check in this.checks) {
            var checkInfo = this.checks[check].data;
            var projectTypeSettings = this.projectTypes[this.tab];
            if (projectTypeSettings.cats.indexOf(checkInfo.class) == -1) {
                continue;
            }
            var check_class = this.checkCatsAuxiliary[checkInfo.class];
            var check_type = check_class.nodes[checkInfo.class + "." + checkInfo.type];
            if (!check_type || !check_type.nodes[checkInfo.class + "." + checkInfo.type + "." + checkInfo.subtype]) {
                continue;
            }
            var check_subtype = check_type.nodes[checkInfo.class + "." + checkInfo.type + "." + checkInfo.subtype];
            if (projectTypeSettings.addition) {
                var is_continue = false;
                for (var constrains in projectTypeSettings.addition) {
                    if (checkInfo[constrains] !== projectTypeSettings.addition[constrains]) {
                        is_continue = true;
                    }
                }
                if (is_continue) {
                    continue;
                }
            }
            var cat = this.checkCats[check_class.index].nodes[check_type.index].nodes[check_subtype.index];
            if (typeof cat.nodes == "undefined") {
                cat.nodes = [];
                cat.hidden = false;
            }
            var template_risk = this.templates.template_risk.sprintf(this.checks[check]["TEMPLATE_RISK"] ? this.checks[check]["TEMPLATE_RISK"] : "");
            cat.nodes.push({
                text: "[" + check + "] " + checkInfo["title_" + Locale.name] + this.templates.check_info + template_risk,
                checkbox: true,
                data: {
                    info: check
                }
            });
        }
    };
    this.removeEmptyCats = function() {
        for (var i = 0; i < this.checkCats.length; i++) {
            var for_hidden_j = true;
            for (var j = 0; j < this.checkCats[i].nodes.length; j++) {
                var for_hidden_k = true;
                for (var k = 0; k < this.checkCats[i].nodes[j].nodes.length; k++) {
                    if (this.checkCats[i].nodes[j].nodes[k].hidden === false) {
                        for_hidden_k = false;
                    }
                }
                if (for_hidden_k) {
                    this.checkCats[i].nodes[j].hidden = true;
                } else {
                    for_hidden_j = false;
                }
            }
            if (for_hidden_j) {
                this.checkCats[i].hidden = true;
            }
        }
    };
    this.loadPolicies = function() {
        var o = this;
        ERPScanAPI.query("/engine/scantemplates/list", function(result) {
            $("section.content").html(o.templates.blocks.sprintf(o.templates.block));
            o.policies = o.conversionPoliciesList.call(o, result);
            o.buildPoliciesTable();
            var checkCatsResult = o.checkCats;
            o.checkCats = [];
            o.catsTreeWalk($("tree item", checkCatsResult), o.checkCats, 1, o.checkCatsAuxiliary);
            o.catsTreeAddChecks.call(o);
            o.removeEmptyCats.call(o);
        });
    };
    this.pasteFilters = function() {
        var filters = "";
        for (var filter in this.filters.list) {
            var filter_obj = this.filters.list[filter];
            switch (type) {
                case "input":
                    filters += this.filters.controls[filter_obj.type].sprintf(filter_obj.name, Locale.ui.page["filter"][filter]);
                    break;
            }
        }
        $(".check-list").before(this.templates.filters);

    };
    this.buildCheckList = function(id) {
        //this.pasteFilters();
        this.tree = new Tree($(".check-list"), this.checkCats, {});
        this.tree.init();
        if (this.checkCatsSelected[id]) {
            for (var i = 0; i < this.checkCatsSelected[id].length; i++) {
                var check_id = this.checkCatsSelected[id][i].split("check_");
                if (check_id[1]) {
                    $(".tree-item.level-4[data-info=\"" + check_id[1] + "\"] > .tree-item-content input[type=\"checkbox\"]").click();
                } else {
                    $(".tree-item[data-info=\"" + check_id[0] + "\"] > .tree-item-content input[type=\"checkbox\"]").click();
                }
            }
        }
    };
    this.selectPolicy = function($this) {
        if ($this.hasClass("tablesorter-headerRow") || $this.hasClass("tablesorter-filter-row")) {
            return false;
        }
        if (!$this.hasClass("active")) {
            var number = $this.data("number");
            var id = this.policies[number].id;
            var name = this.policies[number].name;
            this.buildCheckList(id);
            if ($(".blocks .block .save-button").length == 0) {
                $(".blocks .block h3").before(this.templates.actions);
            }
            $(".blocks .block h3").html(name);
            $(".blocks .block").data("id", id);
        } else {
            $(".blocks .block").html(this.templates.block);
        }
    };
    this.creatingPolicy = function($button) {
        if ($button.hasClass("saving")) {
            return false;
        }
        $button.html(Locale.ui.page["new_policy"]["saving"]).addClass("saving");
        var name = $(".popup-new-policy input[name=\"policy_name\"]").val();
        if (!name) {
            return false;
        }
        var o = this;
        this.createPolicy(name, this.projectTypes[this.tab].name, function(result) {
            var $info = $("createscantemplate scantemplate", result);
            var name = '<span class="name">' + $info.find("name").text().encodeHTML() + '</span>' + o.templates.policy_remove + o.templates.policy_rename;
            var author = o.users[$info.find("authorid").text()].login;
            var id = $info.find("id").text();
            var update = new Date($info.find("lastupdated").text() * 1).toDateString();
            var create_date = new Date($info.find("created").text() * 1).toDateString();
            var new_number = o.policies.length;
            var row = '<tr data-number="' + new_number + '"><td data-order="1" class="toggle-info"><a href="#"></a></td><td>' + name + '</td><td>' + author + '</td></tr>';
            o.policies.push({
                __addition: '<a href="#"></a>',
                'id': id,
                'name': name,
                'author': author,
                'updated': update,
                'created': create_date,
                'number_checks': 0,
                'number_projects': 0
            });
            $(".blocks .table table tbody").append(row);
            $('.blocks .table table').trigger('update');
            $(".blocks .table table tr[data-number=\"" + new_number + "\"]").click();
            Popup.close();
        });
    };
    this.renamePolicy = function(id, new_name, callback) {
        ERPScanAPI.query("/engine/scantemplates/update/" + id, function(result) {
            if (callback) {
                callback(result);
            }
        }, {
            name: new_name
        });
    };
    this.handlers = function() {
        var o = this;
        $(document.body).on("click", ".blocks table.tablesorter tbody tr", function() {
            var $this = $(this);
            o.selectPolicy($this);
        });
        $(document.body).on("click", ".check-list .tree .tree-item .tree-item-content .text .check-info", function() {
            var check_id = $(this).parents(".tree-item").data("info");
            var check_info = Locale.ui.page["check_info"];
            o.checks[check_id].data.prototype = o.checks[check_id].prototype;
            var content_1 = "",
                content_2 = "";
            if (check_info["list-1"]["title"]) {
                check_info["list-1"]["title_" + Locale.name] = check_info["list-1"]["title"];
                delete check_info["list-1"]["title"];
            }
            if (check_info["list-2"]["description"]) {
                check_info["list-2"]["description_" + Locale.name] = check_info["list-2"]["description"];
                delete check_info["list-2"]["description"];
            }
            for (var field in check_info["list-1"]) {
                content_1 += o.templates.check_info_popup.field.sprintf(check_info["list-1"][field], o.checks[check_id].data[field]);
            }
            for (var field in check_info["list-2"]) {
                content_2 += o.templates.check_info_popup.field.sprintf(check_info["list-2"][field], o.checks[check_id].data[field]);
            }
            Popup.new({
                class: "popup-check-info",
                title: Locale.ui.page["check_info"]["title"],
                content: o.templates.check_info_popup.wrap.sprintf(content_1, content_2),
                width: 850,
                open: function() {

                },
                close: function() {

                }
            });
            return false;
        });
        $(document.body).on("click", ".check-list .tree .tree-item .tree-item-content .text .template-risk", function() {
            var check_name = $(this).parent(".text").text();
            var check_id = $(this).parents(".tree-item").data("info");
            var policy_id = $(".blocks .block").data("id");
            var risks = "";
            for (var item in Locale.ui.page["check_settings"]["risks"]) {
                risks += o.templates.template_risk_popup.risk.sprintf(item, Locale.ui.page["check_settings"]["risks"][item]);
            }
            Popup.new({
                class: "popup-template-risk",
                title: Locale.ui.page["check_settings"]["title"],
                content: o.templates.template_risk_popup.wrap.sprintf(check_name, Locale.ui.page["check_settings"]["risk"], risks, Locale.ui.page["check_settings"]["save"]),
                width: 350,
                open: function() {
                    if (o.checks[check_id].templates && o.checks[check_id].templates[policy_id]) {
                        var risk = o.template_risks[o.checks[check_id].templates[policy_id]];
                        $(".popup-template-risk .input select option[value=\"" + risk + "\"]")[0].selected = true;
                    }
                },
                close: function() {

                }
            });
            return false;
        });
        $(document.body).on("click", ".blocks .table .create-button", function() {
            Popup.new({
                class: "popup-new-policy",
                title: Locale.ui.page["new_policy"]["title"],
                content: o.templates.new_policy_popup.wrap.sprintf(Locale.ui.page["new_policy"]["name"], Locale.ui.page["new_policy"]["save"]),
                width: 350,
                height: 100,
                open: function() {
                    $(".popup-new-policy input[name=\"policy_name\"]").focus();
                },
                close: function() {

                }
            });
            return false;
        });
        $(document.body).on("click", ".blocks .table .policy_rename", function() {
            var $td = $(this).parents("td");
            var $tr = $(this).parents("tr");
            var index = $tr.data("number");
            var id = o.policies[index].id;
            var name = o.policies[index].name;
            Popup.new({
                class: "popup-policy-rename",
                title: Locale.ui.page["policy_rename"]["title"],
                content: o.templates.policy_rename_popup.wrap.sprintf(Locale.ui.page["policy_rename"]["name"], Locale.ui.page["policy_rename"]["save"]),
                width: 350,
                height: 100,
                open: function() {
                    $(".popup-policy-rename input[name=\"policy_name\"]").data("id", id).data("td", $td).val($("<div />").html(name).text()).focus();
                },
                close: function() {

                }
            });
            return false;
        });
        $(document.body).on("click", ".popup-new-policy .save", function() {
            var $this = $(this);
            o.creatingPolicy.call(o, $this);
            return false;
        });
        $(document.body).on("click", ".popup-policy-rename .save", function() {
            var $this = $(this);
            if ($this.hasClass("saving")) {
                return false;
            }
            var $input = $(".popup-policy-rename input[name=\"policy_name\"]");
            var new_name = $input.val();
            if (!new_name) {
                return false;
            }
            $this.html(Locale.ui.page["policy_rename"]["saving"]).addClass("saving");
            var id = $input.data("id");
            var $td = $input.data("td");
            var number = $td.parent("tr").data("number");
            o.renamePolicy(id, new_name, function() {
                $td.find(".name").html(new_name.encodeHTML());
                $('.blocks .table table').trigger('update');
                Popup.close();
                o.policies[number].name = new_name.encodeHTML();
            });
            return false;
        });
        $(document.body).on("keyup", ".popup-new-policy input[name=\"policy_name\"]", function(event) {
            if (event.keyCode != 13) {
                return false;
            }
            o.creatingPolicy.call(o, $(".popup-new-policy .save"));
            return false;
        });
        $(document.body).on("click", "section.content .block .expand-all", function() {
            var $this = $(this);
            $this.addClass("collapse-all").removeClass("expand-all").html(Locale.ui.page["buttons"]["collapse_all"]);
            o.tree.expandAll();
            return false;
        });
        $(document.body).on("click", "section.content .block .collapse-all", function() {
            var $this = $(this);
            $this.addClass("expand-all").removeClass("collapse-all").html(Locale.ui.page["buttons"]["expand_all"]);
            o.tree.collapseAll();
            return false;
        });
        $(document.body).on("click", ".blocks .table .policy_remove", function(event) {
            var $this = $(this);
            if ($this.hasClass("removing")) {
                return false;
            }
            if (confirm(Locale.ui.page["remove_policy"])) {
                $this.addClass("removing");
                var $tr = $this.parents("tr");
                var index = $tr.data("number");
                o.removePolicy(o.policies[index].id, function() {
                    $tr.remove();
                    $(".blocks .table table").trigger('update');
                    $(".blocks .block").html(o.templates.block);
                    Popup.close();
                });
            }
            event.preventDefault();
            return false;
        });
    };
    this.removePolicy = function(id, callback) {
        ERPScanAPI.query("/engine/scantemplates/remove/" + id, function(result) {
            if (callback) {
                callback(result);
            }
        });
    };
    this.createPolicy = function(name, projectType, callback) {
        ERPScanAPI.query("/engine/scantemplates/create", function(result) {
            if (callback) {
                callback(result);
            }
        }, {
            "data": '{"cats":""}',
            projectType: projectType,
            name: name
        });
    };
    this.preLoad = function(callback) {
        var o = this,
            counter = 0,
            total_queries = 3;
        ERPScanAPI.query("/engine/dictionary/users", function(result) {
            $("listusers user", result).each(function() {
                var $this = $(this),
                    userID = $this.find("id").text(),
                    user = {
                        login: $this.find("login").text()
                    };
                o.users[userID] = user;
            });
            counter++;
            if (counter == total_queries) {
                callback.call(o);
            }
        });
        ERPScanAPI.query("/engine/dictionary/checkobjects", function(result) {
            $("listobjects prototypecheck", result).each(function() {
                var $this = $(this),
                    id = $this.find("id").text();
                o.checks[id] = {
                    prototype: $this.find("prototypename").text(),
                    data: JSON.parse($this.find("data").text())
                };
            });
            counter++;
            if (counter == total_queries) {
                callback.call(o);
            }
        });
        $.ajax({
            url: "/data/checkCats.xml",
            method: "GET",
            dataType: "XML",
            success: function(result) {
                o.checkCats = result;
                counter++;
                if (counter == total_queries) {
                    callback.call(o);
                }
            }
        });
    };
    this.init = function() {
        $("section.content").html(Header.templates.tabs.loading);
        this.preLoad(this.loadPolicies);
        this.handlers();
    }
}

Page.Render = {
    init: function() {
        var page = ['assess', 'policies', "vm"];
        Locale.set("en", { fields: ["policies"] });
        Locale.loadPage(page);
        Header.load(page, { tabs: true, type: "landscape" });
        new Policies("audit").init();
    }
};