Jobs.SAPNotes = function(obj) {
    this.parentObj = obj;
    this.locale = null;
    this.path = ['assess', 'projects', 'sap_notes'];
    this.results = null;
    this.table = null;
    this.templates = {
        no_entry: "<p>" + Locale.ui.page.no_entry + "</p>"
    };
    this.tableLoad = function() {
        var params = {
            title: "SAP Notes",
            data: this.parentObj.scanInfo.SAPNotes.data,
            option: {
                fields: "jobs_sap_notes",
                ticks: this.parentObj.scanInfo.SAPNotes.ticks,
                sorting: {
                    0: false,
                    3: "data-ts"
                },
                filters: {
                    "RELEASE_DATE": "datetime",
                    "SAP_NOTE": "input"
                },
                sort_default: { column: 1, order: "asc" },
                count_one_page: 50
            }
        };
        this.table = new Table(params);
        var html = this.table.getHTML();
        $("section.content.tab-sap_notes").html(html);
        if (this.parentObj.scanInfo.SAPNotes.data.length == 0) {
            $("section.content.tab-sap_notes .table table.tablesorter").after(this.templates.no_entry);
            $("section.content.tab-sap_notes .table table.tablesorter, section.content.tab-sap_notes .table .pager").remove();
            return;
        }
        this.table.build(params.data, params.option);
    };
    this.clear = function() {
        $(document.body).off("click", "section.content.tab-sap_notes table.tablesorter tr");
        $("section.content.tab-sap_notes").empty();
    };
    this.handlers = function() {

    };
    this.init = function() {
        $("section.content.tab-sap_notes").empty();
        if (!this.locale) {
            this.locale = Locale.loadPage(this.path, true);
        }
        this.tableLoad();
        this.handlers();
    }
};