Page.Render = {
    Filters: {
        addDatas: function() {
            Filters.addData("date_from", Locale.ui.common.filters.field.sprintf(Locale.ui.common.filters.from), []);
            Filters.addData("date_to", Locale.ui.common.filters.field.sprintf(Locale.ui.common.filters.to), []);
            Filters.addData("smssapssid", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smssapssid"]), [["SM01"], ["SM02"], ["SM03"], ["SM04"], ["SM05"], ["SM06"], ["SM07"], ["SM08"], ["SM09"]]);
            Filters.addData("smssapip", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smssapip"]), [["172.16.0.62"], ["172.16.0.91"], ["172.16.30.1"], ["172.16.30.5"], ["172.16.30.63"], ["172.16.30.78"], ["172.16.30.80"]]);
            Filters.addData("smsrisktype", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smsrisktype"]), [["Access Control"], ["Misconfigurations"], ["SAP Security Notes"], ["Source Code"], ["Vulnerabilities"]]);
            Filters.addData("smscriticality", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smscriticality"]), [["Information"], ["Low"], ["Medium"], ["High"], ["Critical"]]);
            Filters.addData("smsprojectname", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smsprojectname"]), [["Full ABAP"], ["Finance center scaning"], ["Chicago center scaning"], ["Development"]]);
            Filters.addData("smsappserver", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smsappserver"]), [["SAP NetWeaver ABAP"], ["SAP HTTP"], ["SAP HANA"]]);
            Filters.addData("smssapport", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smssapport"]), [[3301], [3300], [3030], [3800]]);
            Filters.addData("smssaphost", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smssaphost"]), [["sapserver"], ["sapserver_dev"], ["sapserver_test"]]);
            Filters.addData("smssapinstance", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smssapinstance"]), [[1],[2],[3],[4],[5]]);
            Filters.addData("smssapclient", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smssapclient"]), [["000"], ["001"], ["002"], ["003"], ["004"]]);
            Filters.addData("smsservice", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smsservice"]), [["Gateway"], ["Other"]]);
            Filters.addData("smscategory", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smscategory"]), [["4.2.9"], ["4.1.0"], ["3.6.7"]]);
            Filters.addData("smseventtype", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smseventtype"]), [["CheckCode"], ["Other"]]);
            Filters.addData("smsdirection", Locale.ui.common.filters.field.sprintf(Locale.fields["erpscan"]["logs"]["smsdirection"]), [["Internal"], ["External"]]);
        },
        setDefault: function() {
            Filters.add('date_from', { type: "datetime" });
            Filters.add('date_to', { type: "datetime" });
            Filters.add('smssapssid');
            Filters.add('smssapip');
            Filters.add('smsrisktype');
            Filters.add('smscriticality');
        }
    },
    Charts: {
        add: function() {
            var actions = { };
            actions[Locale.ui.common.events_table.actions.export.self] = [ Locale.ui.common.events_table.actions.export.IDS ];
            actions[Locale.ui.common.events_table.actions.manage_risk.self] = [ Locale.ui.common.events_table.actions.manage_risk.accept, Locale.ui.common.events_table.actions.manage_risk.critical, Locale.ui.common.events_table.actions.manage_risk.high, Locale.ui.common.events_table.actions.manage_risk.medium, Locale.ui.common.events_table.actions.manage_risk.low ];
            actions[Locale.ui.common.events_table.actions.mark_as.self] = [ Locale.ui.common.events_table.actions.mark_as.failed, Locale.ui.common.events_table.actions.mark_as.false_positive ];
            actions[Locale.ui.common.events_table.actions.designate.self] = [ Locale.ui.common.events_table.actions.designate.e_mail ];
            Chart.generate([
                {
                    type: "Pie",
                    title: Locale.ui.page.blocks.risks,
                    field: "smscriticality",
                    columns: 2,
                    data: GenerateData.Pie(GenerateData.Presets.risks)
                },
                {
                    type: "Pie",
                    title: Locale.ui.page.blocks.issues,
                    field: "smsrisktype",
                    columns: 2,
                    data: GenerateData.Pie(GenerateData.Presets.types)
                },
                {
                    type: "Pie",
                    title: Locale.ui.page.blocks.tagged_risks,
                    columns: 2,
                    field: "smssapip",
                    data: GenerateData.Pie({
                        "172.16.0.62": { },
                        "172.16.0.91": { },
                        "172.16.30.1": { },
                        "172.16.30.5": { },
                        "172.16.30.63": { },
                        "172.16.30.78": { },
                        "172.16.30.80": { }
                    })
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.tagged_issues_types,
                    field: "smscriticality",
                    columns: 2,
                    option: {
                        ticks: [[1,"Center"], [2,"Development"], [3,"Finance"], [4,"USA"], [5,"Netherlands"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.risks, 5)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.scope,
                    field: "smsrisktype",
                    columns: 1,
                    option: {
                        ticks: [[1,"Center"], [2,"Development"], [3,"Finance"], [4,"USA"], [5,"Netherlands"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.types, 5)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.landscapes_issue_risks,
                    columns: 1,
                    field: "smscriticality",
                    option: {
                        ticks: [[1,"Palo Alto"], [2,"Amsterdam"], [3,"Chicago"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.risks, 3)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.landscapes_issue_types,
                    field: "smsrisktype",
                    columns: 1,
                    option: {
                        ticks: [[1,"Palo Alto"], [2,"Amsterdam"], [3,"Chicago"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.types, 3)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.issue_by_risk,
                    field: "smscriticality",
                    columns: 1,
                    option: {
                        ticks: [[1,"Access Control"], [2,"Misconfigurations"], [3,"SAP Security Notes"], [4,"Source Code"], [5,"Vulnerabilities"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.risks, 5)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.top_system_by_risk,
                    columns: 1,
                    field: "smscriticality",
                    option: {
                        ticks: [[1,"172.16.0.62"], [2,"172.16.0.91"], [3,"172.16.30.1"], [4,"172.16.30.5"], [5,"172.16.30.63"], [6,"172.16.30.78"], [7,"172.16.30.80"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.risks, 7)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.top_system_by_issues,
                    field: "smsrisktype",
                    columns: 1,
                    option: {
                        ticks: [[1,"172.16.0.62"], [2,"172.16.0.91"], [3,"172.16.30.1"], [4,"172.16.30.5"], [5,"172.16.30.63"], [6,"172.16.30.78"], [7,"172.16.30.80"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.types, 7)
                }
            ], {
                type: "Table",
                ticks: {"__check": true, "__addition": true},
                title: Locale.ui.page.blocks.events,
                data: GenerateData.Table(196),
                actions: actions,
                option: {
                    namespace: "erpscan",
                    type: "logs",
                    sort_default: { column: 2, order: "asc" }
                }
            })
        },
        Colors: {
            Risks: {
                critical: "#e24d42",
                high: "#f9934e",
                medium: "#eab839",
                low: "#f3d597",
                information: "#5195ce"
            }
        }
    },
    init: function() {
        var page = ['monitor', 'issues', 'main'],
            fields = ["erpscan"];
        Locale.set("en", { fields: fields });
        Locale.loadPage(page);
        Page.loadFieldsConfig(fields);
        Header.load(page, { filters: true, disposition: true });
        Page.Render.Filters.addDatas();
        Filters.fieldList.generate();
        Filters.handlers();
        Page.Render.Filters.setDefault();
        Page.Render.Charts.add();
        Chart.handlers();
    }
};

function Issues() {
    this.init = function() {
        var filter_obj = new Filter(filter, {
            fields: "inventory",
            variants: filters[filter],
            callback: function(filter) {
                return function(values) {
                    o.treeObj.filtering(filter, values);
                }
            }(filter)
        });
        $(".block.services-tree .filters").append(filter_obj.getHTML());
        filter_obj.build();
    };
}

var GenerateData = {
    Presets: {
        risks: {
            Critical: { color: Page.Render.Charts.Colors.Risks.critical },
            High: { color: Page.Render.Charts.Colors.Risks.high },
            Medium: { color: Page.Render.Charts.Colors.Risks.medium },
            Low: { color: Page.Render.Charts.Colors.Risks.low },
            Information: { color: Page.Render.Charts.Colors.Risks.information }
        },
        types: {
            "Access Control": { },
            "Misconfigurations": { },
            "SAP Security Notes": { },
            "Source Code": { },
            "Vulnerabilities": { }
        },
        randomValueChoice: function(array) {
            var number = Helpers.randomNumber({ min: 0, max: array.length - 1 });
            return array[number];
        },
        fields: {
            '__check': function() {
                return '<input type="checkbox" />';
            },
            '__addition': function() {
                return '<a href="#"></a>';
            },
            time: function() {
                var date = new Date(Helpers.randomNumber({ min: 1432131085382, max: 1437737085382 }));
                return { value: date.format("M d Y H:i:s"), attr: { name: 'ts', value:  date.getTime() } }
            },
            smssapssid: function() {
                return GenerateData.Presets.randomValueChoice(["SM01", "SM02", "SM03", "SM04", "SM05", "SM06", "SM07", "SM08", "SM09"]);
            },
            smssapip: function() {
                return GenerateData.Presets.randomValueChoice(["172.16.0.62", "172.16.0.91", "172.16.30.1", "172.16.30.5", "172.16.30.63", "172.16.30.78", "172.16.30.80"]);
            },
            smsrisktype: function() {
                return GenerateData.Presets.randomValueChoice(["Access Control", "Misconfigurations", "SAP Security Notes", "Source Code", "Vulnerabilities"]);
            },
            smscriticality: function() {
                var variants = ["Information", "Low", "Medium", "High", "Critical"];
                var value = GenerateData.Presets.randomValueChoice(variants);
                return { value: value, attr: { name: 'order', value: variants.indexOf(value) } };
            },
            smsprojectname: function() {
                return GenerateData.Presets.randomValueChoice(["Full ABAP", "Finance center scaning", "Chicago center scaning", "Development"]);
            },
            smsappserver: function() {
                return GenerateData.Presets.randomValueChoice(["SAP NetWeaver ABAP", "SAP HTTP", "SAP HANA"]);
            },
            smssapport: function() {
                return GenerateData.Presets.randomValueChoice([3301, 3300, 3030, 3800]);
            },
            smssaphost: function() {
                return GenerateData.Presets.randomValueChoice(["sapserver", "sapserver_dev", "sapserver_test"]);
            },
            smssapinstance: function() {
                return GenerateData.Presets.randomValueChoice([1, 2, 3, 4, 5]);
            },
            smssapclient: function() {
                return GenerateData.Presets.randomValueChoice(["000", "001", "002", "003", "004"]);
            },
            smsservice: function() {
                return GenerateData.Presets.randomValueChoice(["Gateway", "Other"]);
            },
            smscategory: function() {
                return GenerateData.Presets.randomValueChoice(["4.2.9", "4.1.0", "3.6.7"]);
            },
            smseventtype: function() {
                return GenerateData.Presets.randomValueChoice(["CheckCode", "Other"]);
            },
            smsdirection: function() {
                return GenerateData.Presets.randomValueChoice(["Internal", "External"]);
            }
        }
    },
    Table: function(count) {
        var rows = [];
        for (var i = 0; i < count; i++) {
            var row = { };
            for (var field in GenerateData.Presets.fields) {
                row[field] = GenerateData.Presets.fields[field]();
            }
            rows.push(row);
        }
        return rows;
    },
    Bar: function(labels, parts_count) {
        var data = [ ];
        for (var label in labels) {
            var min = labels[label].min ? labels[label].min : 0;
            var max = labels[label].max ? labels[label].max : 100;
            var values = [ ];
            for (var i = 1; i <= parts_count; i++)
                values.push([i, Math.floor(Math.random() * max) + min + 1]);
            var segment = {
                label: label,
                data: values,
                bars: {
                    show: true,
                    barWidth: 0.15,
                    fill: true,
                    lineWidth: 0,
                    order: 1
                }
            };
            if (labels[label].color)
                segment.color = labels[label].color;
            data.push(segment);
        }
        return data;
    },
    Pie: function(labels) {
        var data = [ ];
        for (var label in labels) {
            var min = labels[label].min ? labels[label].min : 0;
            var max = labels[label].max ? labels[label].max : 100;
            var segment = {
                label: label,
                data: Math.floor(Math.random() * max) + min + 1
            };
            if (labels[label].color)
                segment.color = labels[label].color;
            data.push(segment);
        }
        return data;
    }
};



/*function Issues() {
    this.templates = {
        wrap: '<div class="blocks">{content}</div>',
        block: '<div class="block table col-2"><h3>{title}</h3><div class="block-content">{content}</div></div>',
        loading: "<div class='loading'></div>"
    };
    this.conversionFieldRules = {
        "customQuery1": {
            "__addition": function(fields, name) {
                return "<a href=''></a>";
            }
        },
        "customQuery2": {
            "__addition": function(fields, name) {
                return "<a href=''></a>";
            }
        },
        "customQuery3": {
            "__addition": function(fields, name) {
                return "<a href=''></a>";
            }
        },
        "customQuery4": {
            "__addition": function(fields, name) {
                return "<a href=''></a>";
            }
        },
        "customQuery5": {
            "__addition": function(fields, name) {
                return "<a href=''></a>";
            }
        }
    };
    this.queries = [
        {
            title: "Users with critical access and simple password",
            id: "customQuery1",
            queryObj: {
                "from": [
                    {
                        entity: "Issue",
                        alias: "i1"
                    },
                    {
                        entity: "Issue",
                        alias: "i2"
                    }
                ],
                "query": "i1.userName = i2.userName AND i1.issueType = :type1 AND i2.issueType = :type2",
                "fields": [
                    "i1.userName",
                    "i1.transactionName",
                    "i1.table",
                    "i1.programName",
                    "i1.RFCName",
                    "i2.password",
                    "i1.ANAME",
                    "i1.USTYPE",
                    "i1.CLASS",
                    "i1.LOCNT",
                    "i1.UFLAG",
                    "i1.TRDAT",
                    "i1.BCDA2",
                    "i1.BCODE"
                ],
                "parameters": [
                    {
                        name: "type1",
                        value: "simplePassword"
                    },
                    {
                        name: "type2",
                        value: "criticalUser"
                    }
                ]
            }
        },
        {
            title: "Program with vulnerabilities, which the author has a simple password",
            id: "customQuery2",
            queryObj: {
                "from": [
                    {
                        entity: "Issue",
                        alias: "i1"
                    },
                    {
                        entity: "Issue",
                        alias: "i2"
                    }
                ],
                "query": "i1.abapProgram.author = i2.user.userName AND i1.issueType = :type1 i2.issueType = :type2",
                "fields": [
                    "i2.userName",
                    "i2.password",
                    "i1.abapProgram.programName"
                ],
                "parameters": [
                    {
                        name: "type1",
                        value: "abapProgramIssue"
                    },
                    {
                        name: "type2",
                        value: "simplePassword"
                    }
                ]
            }
        }, {
            title: "Connections in which the user is involved, which can run transaction SE16 or SE38",
            id: "customQuery3",
            queryObj: {
                "from": [
                    {
                        entity: "Object",
                        alias: "o1"
                    },
                    {
                        entity: "ObjectRelations",
                        alias: "or1"
                    },
                    {
                        entity: "Object",
                        alias: "o2"
                    },
                    {
                        entity: "ObjectRelations",
                        alias: "or2"
                    },
                    {
                        entity: "Object",
                        alias: "o3"
                    },
                    {
                        entity: "ObjectRelations",
                        alias: "or3"
                    },
                    {
                        entity: "Object",
                        alias: "o4"
                    },
                    {
                        entity: "ObjectRelations",
                        alias: "or4"
                    },
                    {
                        entity: "ObjectRelations",
                        alias: "or5"
                    }
                ],
                "query": "o1.objectType = 'authObj' AND (o1.fields.transactionName = 'SE16' OR o1.fields.transactionName = 'SE38') AND " +
                    "o2.objectType = 'profile' AND o3.objectType = 'role' AND o4.objectType = 'user' AND " +
                    "or1.type = 'ProfileHasAuthObj' AND or1.primaryObject = o2.id AND or1.secondaryObject = o1.id" +
                    "or2.type = 'RoleHasProfile' AND or2.primaryObject = o3.id AND or2.secondaryObject = o2.id" +
                    "or3.type = 'UserHashAuthObj' AND or3.primaryObject = o4.id AND or3.secondaryObject = o1.id" +
                    "or4.type = 'UserHasProfile' AND or4.primaryObject = o4.id AND or4.secondaryObject = o2.id" +
                    "or5.type = 'UserHasRole' AND or5.primaryObject = o4.id AND or5.secondaryObject = o3.id",
                "fields": [

                ],
                "parameters": [
                    {
                        name: "type1",
                        value: "criticalConnection"
                    },
                    {
                        name: "type2",
                        value: "criticalUser"
                    }
                ]
            }
        },
        {
            title: "IP addresses that have in the application server SAP ABAP there is vulnerability SAPNote with number 1999999",
            id: "customQuery4",
            queryObj: {
                "from": [
                    {
                        entity: "Result",
                        alias: "i1"
                    },
                    {
                        entity: "Issue",
                        alias: "i2"
                    }
                ],
                "query": "i1.id = i2.resultId AND i1.credential.appServer = :appserver AND i2.issueType = :type AND i2.sapNoteNumber = :sapnotenumber",
                "fields": [
                    "i1.credential.host",
                    "i1.credential.port",
                    "i1.credential.sid",
                    "i2.checks",
                    "i2.criticality",
                    "i2.probability",
                    "i2.exploitability",
                    "i2.vulnType",
                    "i2.neverLogin60",
                    "i2.status",
                    "i2.exploitCheck",
                    "i2.applicationArea"
                ],
                "parameters": [
                    {
                        name: "type",
                        value: "sapnote"
                    },
                    {
                        name: "type2",
                        value: "userProperty"
                    },
                    {
                        name: "appserver",
                        value: "f0c903f4-0c77-11e6-a148-3e1d05defe78"
                    },
                    {
                        name: "sapnotenumber",
                        value: 1999999
                    }
                ]
            }
        },
        {
            title: "Property of users with critical access SAP_ALL",
            id: "customQuery5",
            queryObj: {
                "from": [
                    {
                        entity: "Issue",
                        alias: "i1"
                    },
                    {
                        entity: "Issue",
                        alias: "i2"
                    }
                ],
                "query": "i1.$user = i2.userName AND i1.issueType = :type1 AND i2.issueType = :type2 AND i1.$profile = :profile",
                "fields": [
                    "i1.table",
                    "i1.programName",
                    "i1.RFCName",
                    "i2.status",
                    "i2.userName",
                    "i2.isBlockedbyLogin",
                    "i2.isDeleted",
                    "i2.neverLogin",
                    "i2.neverLogin60",
                    "i2.status"
                ],
                "parameters": [
                    {
                        name: "type1",
                        value: "criticalProfile"
                    },
                    {
                        name: "type2",
                        value: "userProperty"
                    },
                    {
                        name: "profile",
                        value: "SAP_ALL"
                    }
                ]
            }
        }
    ];
    this.buildView = function() {
        var blocks = [],
            blocksHTML = "",
            row = 0, i;
        for (i = 0; i < this.queries.length; i++) {
            if (typeof blocks[row] == "undefined") {
                blocks[row] = "";
            }
            blocks[row] += this.templates.block.format({
                title: this.queries[i].title,
                content: this.templates.loading
            });
            if ((i + 1) % 3 == 0 || i == this.queries.length - 1) {
                blocks[row] = this.templates.wrap.format({
                    content: blocks[row]
                });
                row++;
            }
        }
        for (i = 0; i < row; i++) {
            blocksHTML += blocks[i];
        }
        $("section.content").html(blocksHTML);
    };
    this.buildTable = function(data, number) {
        var params = {
            title: "",
            ticks: {"__addition": true},
            data: data,
            option: {
                expandable: true,
                namespace: "queries",
                type: this.queries[number].id,
                count_one_page: 20,
                sort_default: { column: 1, order: "asc" }
            }
        },
        table = new Table(params),
        html = table.getHTML(),
        $table = $(html),
        $block = $("section.content .blocks .block .block-content").eq(number);
        $block.attr("id", $table.attr("id")).html($table.find(".actions-bar").changeSelector(function() {}) + $table.find(".table-wrapper").changeSelector(function() {}));
        table.build();
    };
    this.conversionFields = function(result, rules) {
        var data = [];
        for (var i = 0; i < result.length; i++) {
            var index = data.push({}) - 1;
            for (var field in rules) {
                if (typeof result[i][field] == "undefined") {
                    data[index][field] = rules[field].call(this, result[i], field, i);
                }
            }
            for (var field in result[i]) {
                var isset = typeof rules[field] != "undefined",
                    skip = isset && rules[field] == null;
                if (skip) {
                    continue;
                }
                data[index][field] = isset ? rules[field].call(this, result[i], field, i) : result[i][field];
            }
        }
        return data;
    };
    this.runQueries = function () {
        var o = this;
        for (var i = 0; i < this.queries.length; i++) {
            ERPScan.API.query("queries", "query" + (i + 1), {
                params: {
                    query: JSON.stringify(this.queries[i].queryObj)
                },
                type: "POST",
                callback: function(i) {
                    return function(result) {
                        var data = o.conversionFields(result["data"]["result"], o.conversionFieldRules[o.queries[i].id]);
                        o.buildTable(data, i);
                    }
                }(i)
            });
        }
    };
    this.init = function() {
        this.buildView();
        this.runQueries();
    };
}

Page.Render = {
    Filters: {
        addDatas: function() {
            Filters.addData("date_from", Locale.ui.common.filters.field.sprintf(Locale.ui.common.filters.from), []);
            Filters.addData("date_to", Locale.ui.common.filters.field.sprintf(Locale.ui.common.filters.to), []);
            Filters.addData("smssapssid", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smssapssid"]), [["SM01"], ["SM02"], ["SM03"], ["SM04"], ["SM05"], ["SM06"], ["SM07"], ["SM08"], ["SM09"]]);
            Filters.addData("smssapip", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smssapip"]), [["172.16.0.62"], ["172.16.0.91"], ["172.16.30.1"], ["172.16.30.5"], ["172.16.30.63"], ["172.16.30.78"], ["172.16.30.80"]]);
            Filters.addData("smsrisktype", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smsrisktype"]), [["Access Control"], ["Misconfigurations"], ["SAP Security Notes"], ["Source Code"], ["Vulnerabilities"]]);
            Filters.addData("smscriticality", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smscriticality"]), [["Information"], ["Low"], ["Medium"], ["High"], ["Critical"]]);
            Filters.addData("smsprojectname", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smsprojectname"]), [["Full ABAP"], ["Finance center scaning"], ["Chicago center scaning"], ["Development"]]);
            Filters.addData("smsappserver", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smsappserver"]), [["SAP NetWeaver ABAP"], ["SAP HTTP"], ["SAP HANA"]]);
            Filters.addData("smssapport", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smssapport"]), [[3301], [3300], [3030], [3800]]);
            Filters.addData("smssaphost", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smssaphost"]), [["sapserver"], ["sapserver_dev"], ["sapserver_test"]]);
            Filters.addData("smssapinstance", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smssapinstance"]), [[1],[2],[3],[4],[5]]);
            Filters.addData("smssapclient", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smssapclient"]), [["000"], ["001"], ["002"], ["003"], ["004"]]);
            Filters.addData("smsservice", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smsservice"]), [["Gateway"], ["Other"]]);
            Filters.addData("smscategory", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smscategory"]), [["4.2.9"], ["4.1.0"], ["3.6.7"]]);
            Filters.addData("smseventtype", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smseventtype"]), [["CheckCode"], ["Other"]]);
            Filters.addData("smsdirection", Locale.ui.common.filters.field.sprintf(Locale.fields["issues"]["issue"]["smsdirection"]), [["Internal"], ["External"]]);
        },
        setDefault: function() {
            Filters.add('date_from', { type: "datetime" });
            Filters.add('date_to', { type: "datetime" });
            Filters.add('smssapssid');
            Filters.add('smssapip');
            Filters.add('smsrisktype');
            Filters.add('smscriticality');
        }
    },
    Charts: {
        add: function() {
            var actions = { };
            actions[Locale.ui.common.events_table.actions.export.self] = [ Locale.ui.common.events_table.actions.export.IDS ];
            actions[Locale.ui.common.events_table.actions.manage_risk.self] = [ Locale.ui.common.events_table.actions.manage_risk.accept, Locale.ui.common.events_table.actions.manage_risk.critical, Locale.ui.common.events_table.actions.manage_risk.high, Locale.ui.common.events_table.actions.manage_risk.medium, Locale.ui.common.events_table.actions.manage_risk.low ];
            actions[Locale.ui.common.events_table.actions.mark_as.self] = [ Locale.ui.common.events_table.actions.mark_as.failed, Locale.ui.common.events_table.actions.mark_as.false_positive ];
            actions[Locale.ui.common.events_table.actions.designate.self] = [ Locale.ui.common.events_table.actions.designate.e_mail ];
            Chart.generate([
                {
                    type: "Pie",
                    title: Locale.ui.page.blocks.risks,
                    field: "smscriticality",
                    columns: 2,
                    data: GenerateData.Pie(GenerateData.Presets.risks)
                },
                {
                    type: "Pie",
                    title: Locale.ui.page.blocks.issues,
                    field: "smsrisktype",
                    columns: 2,
                    data: GenerateData.Pie(GenerateData.Presets.types)
                },
                {
                    type: "Pie",
                    title: Locale.ui.page.blocks.tagged_risks,
                    columns: 2,
                    field: "smssapip",
                    data: GenerateData.Pie({
                        "172.16.0.62": { },
                        "172.16.0.91": { },
                        "172.16.30.1": { },
                        "172.16.30.5": { },
                        "172.16.30.63": { },
                        "172.16.30.78": { },
                        "172.16.30.80": { }
                    })
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.tagged_issues_types,
                    field: "smscriticality",
                    columns: 2,
                    option: {
                        ticks: [[1,"Center"], [2,"Development"], [3,"Finance"], [4,"USA"], [5,"Netherlands"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.risks, 5)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.scope,
                    field: "smsrisktype",
                    columns: 1,
                    option: {
                        ticks: [[1,"Center"], [2,"Development"], [3,"Finance"], [4,"USA"], [5,"Netherlands"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.types, 5)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.landscapes_issue_risks,
                    columns: 1,
                    field: "smscriticality",
                    option: {
                        ticks: [[1,"Palo Alto"], [2,"Amsterdam"], [3,"Chicago"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.risks, 3)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.landscapes_issue_types,
                    field: "smsrisktype",
                    columns: 1,
                    option: {
                        ticks: [[1,"Palo Alto"], [2,"Amsterdam"], [3,"Chicago"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.types, 3)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.issue_by_risk,
                    field: "smscriticality",
                    columns: 1,
                    option: {
                        ticks: [[1,"Access Control"], [2,"Misconfigurations"], [3,"SAP Security Notes"], [4,"Source Code"], [5,"Vulnerabilities"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.risks, 5)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.top_system_by_risk,
                    columns: 1,
                    field: "smscriticality",
                    option: {
                        ticks: [[1,"172.16.0.62"], [2,"172.16.0.91"], [3,"172.16.30.1"], [4,"172.16.30.5"], [5,"172.16.30.63"], [6,"172.16.30.78"], [7,"172.16.30.80"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.risks, 7)
                },
                {
                    type: "Bar",
                    title: Locale.ui.page.blocks.top_system_by_issues,
                    field: "smsrisktype",
                    columns: 1,
                    option: {
                        ticks: [[1,"172.16.0.62"], [2,"172.16.0.91"], [3,"172.16.30.1"], [4,"172.16.30.5"], [5,"172.16.30.63"], [6,"172.16.30.78"], [7,"172.16.30.80"]]
                    },
                    data: GenerateData.Bar(GenerateData.Presets.types, 7)
                }
            ], {
                type: "Table",
                title: Locale.ui.page.blocks.events,
                data: GenerateData.Table(196),
                actions: actions,
                option: {
                    namespace: "issues",
                    type: "issue",
                    sort_default: { column: 2, order: "asc" }
                }
            })
        },
        Colors: {
            Risks: {
                critical: "#e24d42",
                high: "#f9934e",
                medium: "#eab839",
                low: "#f3d597",
                information: "#5195ce"
            }
        }
    },
    init: function() {
        var page = ['monitor', 'issues', 'main'],
            fields = ["queries"];
        Locale.set("en", { fields: fields });
        Page.loadFieldsConfig(fields);
        Locale.loadPage(page);
        Header.load(page);
        //Page.Render.Filters.addDatas();
        //Filters.fieldList.generate();
        //Filters.handlers();
        //Page.Render.Filters.setDefault();
        //Page.Render.Charts.add();
        //Chart.handlers();
        new Issues().init();
    }
};
 */

var Generate = {
    info: {},
    Presets: {
        randomValueChoice: function(array) {
            var number = Helpers.randomNumber({ min: 0, max: array.length - 1 });
            return array[number];
        },
        issues: {
            id: function() {
                return Helpers.generateUUID();
            },
            scanId: function() {
                return Helpers.generateUUID();
            },
            issueType: function() {
                return Generate.Presets.randomValueChoice(["criticalUser", "criticalConnection", "simplePassword", "abapProgramIssue", "criticalProfile", "userProperty"]);
            },
            primaryObject: function() {
                return Generate.Presets.randomValueChoice([null, {
                    "objectType": Generate.Presets.randomValueChoice(["user", "component", "connection", "profile", "role", "authObj", "hanaPrivilege", "sapNoteNumber", "abapProgram", "httpObj", "parameter", "file", "vulnCheck"]),
                    "objectId": Helpers.generateUUID(),
                    "objectName": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 }))
                }]);
            },
            secondaryObject: function() {
                return Generate.Presets.randomValueChoice([null, {
                    "objectType": Generate.Presets.randomValueChoice(["user", "component", "connection", "profile", "role", "authObj", "hanaPrivilege", "sapNoteNumber", "abapProgram", "httpObj", "parameter", "file", "vulnCheck"]),
                    "objectId": Helpers.generateUUID(),
                    "objectName": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 }))
                }]);
            },
            tertiaryObject: function() {
                return Generate.Presets.randomValueChoice([null, {
                    "objectType": Generate.Presets.randomValueChoice(["user", "component", "connection", "profile", "role", "authObj", "hanaPrivilege", "sapNoteNumber", "abapProgram", "httpObj", "parameter", "file", "vulnCheck"]),
                    "objectId": Helpers.generateUUID(),
                    "objectName": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 }))
                }]);
            },
            comments: function() {
                var comments = null,
                    number = Helpers.randomNumber({ min: 0, max: 4});
                if (number > 0) {
                    comments = [];
                }
                for (var i = 0; i < number; i++) {
                    var date = new Date(Helpers.randomNumber({ min: 1432131085382, max: 1437737085382 }));
                    comments.push({
                        "authorId"  : Helpers.generateUUID(),
                        "dateTime"  : date.getTime(),
                        "text"      : Helpers.randomString(Helpers.randomNumber({ min: 5, max: 255 }))
                    });
                }
                return comments;
            },
            fields: function(issueType) {
                switch (issueType) {
                    case "criticalUser":
                        var trdate = new Date(Helpers.randomNumber({ min: 1432131085382, max: 1437737085382 })),
                            bcdadate = new Date(Helpers.randomNumber({ min: 1432131085382, max: 1437737085382 }));
                        return {
                            "user.userName": Generate.Presets.randomValueChoice(["NET200USER", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]),
                            "transactionName": Generate.Presets.randomValueChoice(["SE16", "SE31", "SE38", "SE11", "SE41", "SE14"]),
                            "table": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 16 })),
                            "authValues": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 100 })),
                            "status": Generate.Presets.randomValueChoice(["Success", "Fail", "Unknown", "Info", "Accepted"]),
                            "programName": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "RFCName": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "user.ANAME": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "user.USTYPE": Helpers.randomString(1),
                            "user.CLASS": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "user.LOCNT": Helpers.randomString(2),
                            "user.UFLAG": Helpers.randomString(1),
                            "user.TRDAT": trdate.getTime(),
                            "user.BCDA2": bcdadate.getTime(),
                            "user.BCODE": Helpers.randomString(32, "0123456789abcdef")
                        };
                        break;
                    case "criticalConnection":
                        return {
                            "connection.connName": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.status": Generate.Presets.randomValueChoice(["Success", "Fail", "Unknown", "Info", "Accepted"]),
                            "connection.risk": Generate.Presets.randomValueChoice(["No", "Low", "Medium", "High", "Critical"]),
                            "connection.sidSource": Generate.Presets.randomValueChoice(["SM01", "SM02", "SM03", "SM04", "SM05", "SM06", "SM07", "SM08", "SM09"]),
                            "connection.hostSource": Generate.Presets.randomValueChoice(["172.16.0.62", "172.16.0.91", "172.16.30.1", "172.16.30.5", "172.16.30.63", "172.16.30.78", "172.16.30.80"]),
                            "connection.servTypeSource": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.sidDest": Generate.Presets.randomValueChoice(["SM01", "SM02", "SM03", "SM04", "SM05", "SM06", "SM07", "SM08", "SM09"]),
                            "connection.hostDest": Generate.Presets.randomValueChoice(["172.16.0.62", "172.16.0.91", "172.16.30.1", "172.16.30.5", "172.16.30.63", "172.16.30.78", "172.16.30.80"]),
                            "connection.destPort": Helpers.randomNumber({ min: 10, max: 10000 }),
                            "connection.connType": Generate.Presets.randomValueChoice(["RFC", "HTTP"]),
                            "connection.usrName": Generate.Presets.randomValueChoice(["NET200USER", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]),
                            "connection.psswd": Generate.Presets.randomValueChoice(["Y", "N"]),
                            "connection.usrRight": Generate.Presets.randomValueChoice(["Y", "N"]),
                            "connection.trstConn": Generate.Presets.randomValueChoice(["Y", "N"]),
                            "connection.encrpt": Generate.Presets.randomValueChoice(["Y", "N"]),
                            "connection.encrptType": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.proxyHost": Generate.Presets.randomValueChoice(["172.16.0.62", "172.16.0.91", "172.16.30.1", "172.16.30.5", "172.16.30.63", "172.16.30.78", "172.16.30.80"]),
                            "connection.proxyPort": Helpers.randomNumber({ min: 10, max: 10000 }),
                            "connection.proxyUser": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.proxyPasswd": Generate.Presets.randomValueChoice(["Y", "N"]),
                            "connection.proxySett": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.conSettings": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.destService": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.client": Helpers.randomNumber({ min: 10, max: 4 }),
                            "connection.authMethod": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.owner": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.created": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.dbOwner": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.thrtType": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "connection.connWeight": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 }))
                        };
                        break;
                    case "simplePassword":
                        return {
                            "user.userName": Generate.Presets.randomValueChoice(["NET200USER", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]),
                            "password": Generate.Presets.randomValueChoice(["qwerty", "1234567890", "123456", "qwerty123456", "zaqwsxcde", "0987654321", "123qwe"]),
                            "status": Generate.Presets.randomValueChoice(["Success", "Fail", "Unknown", "Info", "Accepted"])
                        };
                        break;
                    case "abapProgramIssue":
                        return {
                            "$programName": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 16 })),
                            "issueUniquwId": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 6 })),
                            "codeSample": Helpers.randomString(Helpers.randomNumber({ min: 100, max: 1000 })),
                            "traceGraph": Helpers.randomString(Helpers.randomNumber({ min: 100, max: 1000 })),
                            "precision": Helpers.randomString(5),
                            "author": Generate.Presets.randomValueChoice(["NET200USER", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"])
                        };
                        break;
                    case "criticalProfile":
                        return {
                            "status": Generate.Presets.randomValueChoice(["Success", "Fail", "Unknown", "Info", "Accepted"]),
                            "$profile": Generate.Presets.randomValueChoice(["SAP_ALL", "SAP_MVF", "SAP_DEV", "SAP_MGR", "SAP_ADM"]),
                            "$user": Generate.Presets.randomValueChoice(["NET200USER", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]),
                            "table": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "transactionName": Generate.Presets.randomValueChoice(["SE16", "SE31", "SE38", "SE11", "SE41", "SE14"]),
                            "authValues": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "programName": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 })),
                            "RFCName": Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 }))
                        };
                        break;
                    case "userProperty":
                        return {
                            "status": Generate.Presets.randomValueChoice(["Success", "Fail", "Unknown", "Info", "Accepted"]),
                            "userName": Generate.Presets.randomValueChoice(["NET200USER", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]),
                            "isBlockedbyLogin": Generate.Presets.randomValueChoice(["Y", "N"]),
                            "isDeleted": Generate.Presets.randomValueChoice(["Y", "N"]),
                            "neverLogin": Generate.Presets.randomValueChoice(["Y", "N"]),
                            "neverLogin60": Generate.Presets.randomValueChoice(["Y", "N"])
                        };
                        break;
                }
            }
        },
        assets: {
            id: function() {
                return Helpers.generateUUID();
            },
            sid: function() {
                return "DM0";//Helpers.randomString(3, "QWERTYUIOPASDFGHJKLZXCVBNM");
            },
            description: function() {
                return Helpers.randomString(Helpers.randomNumber({ min: 16, max: 255 }));
            },
            severity: function() {
                return Helpers.randomNumber({ min: 0, max: 100 });
            },
            type: function() {
                return Generate.Presets.randomValueChoice(["DEV", "TST", "QAS", "PRD"]);
            },
            class: function() {
                return Generate.Presets.randomValueChoice(["BASIS", "PI", "ERP", "Solution Manager", "CRM", "IS Oil & Gas", "Banking services", "FI", "HR", "Retail", "Material Management", "Sales & Distribution", "Controlling", "Logistics"]);
            },
            owner: function() {
                return Generate.Presets.randomValueChoice(["Evgeny", "Kseniya", "Vasiliy", "Alexander", "Ilya"]);
            },
            rps: function() {
                return Helpers.randomNumber({ min: 0, max: 100000 });
            },
            bussinessModules: function() {
                return Generate.Presets.randomValueChoice(["PI", "ERP", "Solution Manager", "CRM", "IS Oil & Gas", "Banking services", "FI", "HR", "Retail", "Material Management", "Sales & Distribution", "Controlling", "Logistics"]);
            },
            structure: function() {
                var structures = [];
                for (var i = 0; i < 1/*Helpers.randomNumber({ min: 0, max: 20 })*/; i++) {
                    var appserver = "9d68e383-8ee0-425a-b2f2-9affd9bab7c9", //appserver = Helpers.randomProperty(Generate.info.appservers),
                        appserverVersion = { id: "7d20c350-36d5-11e6-9599-bcee7b4785f2" }, //Generate.Presets.randomValueChoice(Generate.info.appservers[appserver].versions),
                        service = "c3586403-f415-47cb-b681-c905f35388f0",//Generate.Presets.randomValueChoice([null, Helpers.randomProperty(Generate.info.appservers[appserver].services)]),
                        appServerProperty = "f4978f48-1cfb-11e6-b6ba-3e1d05defe78",
                        appServerPropertyValue = "01";
                    /*
                    if (service == null
                        && typeof Generate.info.appservers[appserver]["properties"] != "undefined"
                        && Generate.info.appservers[appserver]["properties"] != null
                        && Generate.info.appservers[appserver]["properties"].length != 0
                        && (Generate.info.appservers[appserver]["properties"].length != 1 || Generate.info.appservers[appserver]["properties"].indexOf("f4978f48-1cfb-11e6-b6ba-3e1d05defe78") == -1)) {
                        appServerProperty = Generate.Presets.randomValueChoice(Generate.info.appservers[appserver]["properties"]);
                        appServerPropertyValue = Helpers.randomString(Helpers.randomNumber({ min: 3, max: 16 }));
                    } else if (typeof Generate.info.appservers[appserver]["properties"] == "undefined" || Generate.info.appservers[appserver]["properties"] == null || Generate.info.appservers[appserver]["properties"].length == 0) {
                        service = Helpers.randomProperty(Generate.info.appservers[appserver].services);
                    }
                    */
                    if (service == null && appServerProperty == null) {
                        service = Helpers.randomProperty(Generate.info.appservers[appserver].services);
                    }
                    structures.push({
                        "host"                   : "172.16.30.63",//Generate.Presets.randomValueChoice(["172.16.0.62", "172.16.0.91", "172.16.30.1", "172.16.30.5", "172.16.30.63", "172.16.30.78", "172.16.30.80"]),
                        "os"                     : Generate.Presets.randomValueChoice(["Windows NT", "Debian", "CentOS", "Ubuntu"]),
                        "port"                   : 50100,//Helpers.randomNumber({ min: 10, max: 10000 }),
                        "appServer"              : appserver,
                        "appServerVersion"       : appserverVersion.id,
                        "service"                : service,
                        "appServerProperty"      : appServerProperty,
                        "appServerPropertyValue" : appServerPropertyValue
                    });
                }
                return structures;
            },
            connections: function() {
                var connections = [];
                for (var i = 0; i < 1/*Helpers.randomNumber({ min: 0, max: 20 })*/; i++) {
                    var target = "9d68e383-8ee0-425a-b2f2-9affd9bab7c9";//Helpers.randomProperty(Generate.info.appservers);
                    var targetVersion = { id: "7d20c350-36d5-11e6-9599-bcee7b4785f2" };//Generate.Presets.randomValueChoice(Generate.info.appservers[target]["versions"]);
                    targetVersion = targetVersion["id"];
                    var connectionMethod = "d0e6932f-ca88-402a-8b52-9656887b7081",//Generate.Presets.randomValueChoice(Generate.info.appservers[target]["connectionMethodIds"]),
                        appServerParams = [],
                        connectorParams = [],
                        connectionMethodObj = Generate.info.connectionmethods[connectionMethod],
                        j;
                    appServerParams.push({
                        id: "f4978f48-1cfb-11e6-b6ba-3e1d05defe78",
                        value: "01"
                    });
                    appServerParams.push({
                        id: "825f4a36-8ad8-4ae6-8209-cf83f02c1fe2",
                        value: "1000"
                    });
                    connectorParams.push({
                        id: "872bba0c-1cff-11e6-b6ba-3e1d05defe78",
                        name: "host",
                        value: "172.16.30.63"
                    });
                    connectorParams.push({
                        id: "9ead69dc-1cff-11e6-b6ba-3e1d05defe78",
                        name: "port",
                        value: 50100
                    });
                    connectorParams.push({
                        id: "a380d016-1cff-11e6-b6ba-3e1d05defe78",
                        name: "user",
                        value: "j2ee_admin"
                    });
                    connectorParams.push({
                        id: "a380d016-1cff-11e6-b6ba-3e1d05defe78",
                        name: "password",
                        value: "india123"
                    });
                    /*
                    if (connectionMethodObj["appServersProperties"] != null) {
                        for (j = 0; j < connectionMethodObj["appServersProperties"].length; j++) {
                            appServerParams.push({
                                id: connectionMethodObj["appServersProperties"][j],
                                value: Helpers.randomString(Helpers.randomNumber({min: 3, max: 16}))
                            });
                        }
                    } else {
                        appServerParams = null;
                    }
                    for (j = 0; j < connectionMethodObj["connectorProperties"].length; j++) {
                        connectorParams.push({
                            id: connectionMethodObj["connectorProperties"][j]["id"],
                            name: connectionMethodObj["connectorProperties"][j]["name"],
                            value: Helpers.randomString(Helpers.randomNumber({ min: 3, max: 16 }))
                        });
                    }
                    */
                    connections.push({
                        "target": target,
                        "targetVersion": targetVersion,
                        "connectionMethod": connectionMethod,
                        "appServerParams": appServerParams,
                        "connectorParams": connectorParams
                    });
                }
                return connections;
            }
        },
        query1: {
            "username": function() {
                return Generate.Presets.randomValueChoice(["NET200USER", "RENDES", "TCSADM", "JOSWIGT", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]);
            },
            "password": function() {
                return Generate.Presets.randomValueChoice(["qwerty", "1234567890", "123456", "qwerty123456", "zaqwsxcde", "0987654321", "123qwe"]);
            },
            "authValues": function() {
                return Generate.Presets.randomValueChoice(["[[(S_TABU_DIS(ACTVT(02)))&(S_TABU_DIS(DICBERCLS(SS)))&[(S_TABU_DIS(ACTVT(03)))|(S_TABU_DIS(ACTVT(02)))]&[(S_TABU_DIS(DICBERCLS(SS)))&(S_TABU_DIS(DICBERCLS(SS)))]]|[(S_TABU_DIS(ACTVT(03)))&(S_TABU_DIS(DICBERCLS(SS)))]]", "S_TABU_DIS:ACTVT=02", ""]);
            },
            "role": function() {
                return Generate.Presets.randomValueChoice(["LCT_CONVERSION", "Z_ENTWICKLER_BC3", "SAP_BW_DEVELOPER", "SAP_WFD_IC_MANAGER", "SAP_XI_CONFIGURATOR", ""]);
            },
            "profile": function() {
                return Generate.Presets.randomValueChoice(["SAP_ALL", ""]);
            }
        },
        query2: {
            "username": function() {
                return Generate.Presets.randomValueChoice(["NET200USER", "RENDES", "TCSADM", "JOSWIGT", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]);
            },
            "password": function() {
                return Generate.Presets.randomValueChoice(["qwerty", "1234567890", "123456", "qwerty123456", "zaqwsxcde", "0987654321", "123qwe"]);
            },
            "programName": function() {
                return Generate.Presets.randomValueChoice(["CHANGEDOCU_DEL", "CATT_KONV_TABLES_IN_UNICODE", "COM_TABLE_ENTRIES_RFC", "CRM_PRDXI_PRODREL_SEND", "CD_CHECK_OBJECT_F01", "COM_GTADIR", "CCUEVAL", "CLU_REPAIR", "CCUEVAL"]);
            }
        },
        query3: {
            "username": function() {
                return Generate.Presets.randomValueChoice(["NET200USER", "RENDES", "TCSADM", "JOSWIGT", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]);
            },
            "transactionName": function() {
                return Generate.Presets.randomValueChoice(["SE16", "SE38"]);
            },
            "connName": function() {
                return Generate.Presets.randomValueChoice(["CWBADM_L9C_000", "CWBADM_ALN_000", "L9C", "TRUSTING_SYSTEM@DT1", "CWBADM_ALN_000", "++DBO++0050", "SAPOCS", "SAPCSP", "SWBADM_CS"]);
            }
        },
        query4: {
            "ip": function() {
                return Generate.Presets.randomValueChoice(["172.16.0.62", "172.16.0.91", "172.16.30.1", "172.16.30.5", "172.16.30.63", "172.16.30.78", "172.16.30.80"]);
            },
            "exploitCheck": function() {
                return Generate.Presets.randomValueChoice(["SSEJ_2238375", "SSEJ_2255990", "SSEJ_2234971", ""]);
            },
            "priority": function() {
                return Generate.Presets.randomValueChoice(["Hot news", "High", "Medium", "Low"]);
            },
            "criticality": function() {
                return Generate.Presets.randomValueChoice(["No criticality", "Low", "Medium", "High", "Criticality"]);
            },
            "probability": function() {
                return Generate.Presets.randomValueChoice(["No probability", "Low", "Medium", "High", "Criticality"]);
            },
            "exploitability": function() {
                return Generate.Presets.randomValueChoice(["Public exploit", "Public advisory", "Details not public"]);
            },
            "vulnType": function() {
                return Generate.Presets.randomValueChoice(["Cross-site scripting","Information disclosure","Missing authorization check","Denial of service","Directory traversal","Local command execution","Remote command execution","OS command execution","SMB relay","SQL-injection","Cross-site request forgery","HTTP response splitting","Session fixation","Open redirect","Buffer overflow","Authentication bypass","Verb tampering","XML external entity","Hardcoded Credentials","ABAP code injection","Implementation flaw","Clickjacking","Code injection"]);
            }
        },
        query5: {
            "username": function() {
                return Generate.Presets.randomValueChoice(["NET200USER", "RENDES", "TCSADM", "JOSWIGT", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]);
            },
            "author": function() {
                return Generate.Presets.randomValueChoice(["NET200USER", "RENDES", "TCSADM", "JOSWIGT", "A-CRM", "AAKOLK", "AAMANAGER", "ABBOTTJ", "ABSORBENT", "BERETTONI", "MEDAILLE", "MED_CAMPMGR"]);
            },
            "password": function() {
                return Generate.Presets.randomValueChoice(["qwerty", "1234567890", "123456", "qwerty123456", "zaqwsxcde", "0987654321", "123qwe"]);
            },
            "USTYP": function() {
                return Helpers.randomString(1);
            },
            "CLASS": function() {
                return Helpers.randomString(Helpers.randomNumber({ min: 3, max: 24 }));
            },
            "LOCNT": function() {
                return Helpers.randomString(2);
            },
            "UFLAG": function() {
                return Helpers.randomString(1);
            },
            "TRDAT": function() {
                var trdate = new Date(Helpers.randomNumber({ min: 1432131085382, max: 1437737085382 }));
                return trdate.getTime();
            },
            "BCDA2": function() {
                var bcdadate = new Date(Helpers.randomNumber({ min: 1432131085382, max: 1437737085382 }));
                return bcdadate.getTime();
            },
            "BCODE": function() {
                return Helpers.randomString(32, "0123456789abcdef")
            }
        }
    },
    Table: function(count) {
        var rows = [];
        for (var i = 0; i < count; i++) {
            var row = { };
            for (var field in Generate.Presets.fields) {
                row[field] = Generate.Presets.fields[field]();
            }
            rows.push(row);
        }
        return rows;
    },
    Issue: function(count) {
        var objects = [];
        for (var i = 0; i < count; i++) {
            var row = { };
            for (var field in Generate.Presets.issues) {
                if (field == "fields") {
                    row[field] = Generate.Presets.issues[field](row["issueType"]);
                } else {
                    row[field] = Generate.Presets.issues[field]();
                }
            }
            objects.push(row);
        }
        return objects;
    },
    Query1: function(count) {
        var objects = [];
        for (var i = 0; i < count; i++) {
            var row = { };
            for (var field in Generate.Presets.query1) {
                if (field == "fields") {
                    row[field] = Generate.Presets.query1[field](row["issueType"]);
                } else {
                    row[field] = Generate.Presets.query1[field]();
                }
            }
            objects.push(row);
        }
        return objects;
    },
    Query2: function(count) {
        var objects = [];
        for (var i = 0; i < count; i++) {
            var row = { };
            for (var field in Generate.Presets.query2) {
                if (field == "fields") {
                    row[field] = Generate.Presets.query2[field](row["issueType"]);
                } else {
                    row[field] = Generate.Presets.query2[field]();
                }
            }
            objects.push(row);
        }
        return objects;
    },
    Query3: function(count) {
        var objects = [];
        for (var i = 0; i < count; i++) {
            var row = { };
            for (var field in Generate.Presets.query3) {
                if (field == "fields") {
                    row[field] = Generate.Presets.query3[field](row["issueType"]);
                } else {
                    row[field] = Generate.Presets.query3[field]();
                }
            }
            objects.push(row);
        }
        return objects;
    },
    Query4: function(count) {
        var objects = [];
        for (var i = 0; i < count; i++) {
            var row = { };
            for (var field in Generate.Presets.query4) {
                if (field == "fields") {
                    row[field] = Generate.Presets.query4[field](row["issueType"]);
                } else {
                    row[field] = Generate.Presets.query4[field]();
                }
            }
            objects.push(row);
        }
        return objects;
    },
    Query5: function(count) {
        var objects = [];
        for (var i = 0; i < count; i++) {
            var row = { };
            for (var field in Generate.Presets.query5) {
                if (field == "fields") {
                    row[field] = Generate.Presets.query5[field](row["issueType"]);
                } else {
                    row[field] = Generate.Presets.query5[field]();
                }
            }
            objects.push(row);
        }
        return objects;
    },
    Asset: function(count) {
        var result1Query = Helpers.loadJSON("/api/appservers/map"),
            result2Query = Helpers.loadJSON("/api/connectionmethods/map");
        Generate.info.appservers = result1Query["data"]["result"];
        Generate.info.connectionmethods = result2Query["data"]["result"];
        var objects = [];
        for (var i = 0; i < count; i++) {
            var row = { };
            for (var field in Generate.Presets.assets) {
                row[field] = Generate.Presets.assets[field]();
            }
            objects.push(row);
        }
        return objects;
    },

    CollectMetrics1D: function (data) {
        var statistic = {};
        for (var i = 0; i < data.length; i++) {
            for (var field in data[i]) {
                if (typeof statistic[field] == "undefined") {
                    statistic[field] = {};
                }
                if (typeof statistic[field][data[i][field]] == "undefined") {
                    statistic[field][data[i][field]] = 0;
                }
                statistic[field][data[i][field]]++;
            }
        }
        return statistic;
    },
    CollectMetrics2D: function (data) {
        var statistic = Generate.CollectMetrics1D(data),
            statistic2D = {};
        for (var i = 0; i < data.length; i++) {
            for (var statField in statistic) {
                for (var value in statistic[statField]) {
                    for (var field in data[i]) {
                        if (field != statField) {
                            if (typeof statistic2D[field + "_" + statField] == "undefined") {
                                statistic2D[field + "_" + statField] = {
                                    metricX: field,
                                    metricY: statField,
                                    data: {}
                                };
                            }
                            if (typeof statistic2D[field + "_" + statField].data[data[i][field]] == "undefined") {
                                statistic2D[field + "_" + statField].data[data[i][field]] = {};
                            }
                            if (typeof statistic2D[field + "_" + statField].data[data[i][field]][data[i][statField]] == "undefined") {
                                statistic2D[field + "_" + statField].data[data[i][field]][data[i][statField]] = 0;
                            }
                            statistic2D[field + "_" + statField].data[data[i][field]][data[i][statField]]++;
                        }
                    }
                }
            }
        }
        return statistic2D;
    }
};