Page.Render = {
    init: function() {
        var fields = ["queries"],
            locale = "en";
        Locale.set(locale, { fields: fields });
        Locale.loadPage([Page.path.module, Page.path.page, Page.path.tab]);
        Header.load([Page.path.module, Page.path.page, Page.path.tab], { tabs: true });
        new QueryView().init();
    }
};

function QueryView() {
    this.init = function() {
        $(Page.section).html(Header.templates.tabs.loading);
        var o = this;
        this.preLoad({
            loadedCallback: function () {
                o.buildView();
                o.objects.list = new QueryView.List(o);
                o.objects.list.load();
            }
        });
    }
    this.buildView = function() {
        $(this.section).html(this.data.templates.general.wrap);
    };
}

QueryView.prototype = Object.create(AbstractPage.prototype);
QueryView.prototype.constructor = QueryView;

QueryView.List = function(__parent) {
    this.__parent = __parent;
    this.objects = {};
    this.conversionFieldRules = {
        "__addition": function(fields, name) {
            return "<a href=''></a>";
        },
        "name": function(fields, name)  {
            return fields[name]["en_US"];
        },
        "author":  function(fields, name) {
            return fields[name];
        },
        "created":  function(fields, name) {
            return fields[name];
        }
    };
    this.show = function(data) {
        console.log(data);
        var params = {
            title: "",
            data: data,
            option: {
                namespace: "queries",
                type: "list",
                sort_default: { column: 0, order: "asc" },
                expandable: false
            }
        };
        this.objects.table = new Table(params);
        var html = this.objects.table.getHTML(),
            $table = $(html),
            $block = $("section.content .blocks .block.table .block-content");
        $block.attr("id", $table.attr("id")).html($table.find(".actions-bar").getWrap() + $table.find(".tablesorter").getWrap());
        this.objects.table.build();
        this.handlers();
        Helpers.setBlockHeight($(Page.section));
    };
    this.load = function() {
        var o = this;
        ERPScan.API.query("queries", "list", {
            callback: function(result) {
                result = o.conversionFields.call(o, result["data"]["result"], o.conversionFieldRules);
                o.show.call(o, result);
            }
        });
    };
    this.selectItem = function() {
        $(".block.queries-list").parent(".blocks").width("calc(50% - 20px)").animate({width: "20%"}, 500);
        $(".block.editor").parent(".blocks").animate({width: "80%"}, 500);
    }
    this.handlers = function() {
        var o = this;
        this.__parent.addHandlers({
            "QueryView.List.selectItem": {
                action: "click",
                selector: ".block.queries-list table.tablesorter tbody tr",
                callback: function () {
                    o.selectItem.call(this, o);
                }
            }
        })
    }
}

QueryView.List.prototype = Object.create(AbstractList.prototype);
QueryView.List.prototype.constructor = QueryView.List;