Page.Render = {
    init: function() {
        var page = ['monitor', 'searchdev'],
            fields = ["queries"];
        Locale.set("en", { fields: fields });
        Page.loadFieldsConfig(fields);
        Locale.loadPage(page);
        Header.load(page, { tabs: false, type: "search" });
        new SearchDev().init();
    }
};

function SearchDev() {
    this.templates = {
        wrap: "<div class='search'><div class='block'><h3>Search form</h3><form id='queryExecute' method='post'><div class='field'><div class='name'>Query string:</div><div class='value'><textarea name='query' id='searchQuery'></textarea></div></div><div class='field'><div class='name'>Size:</div><div class='value'><input type='number' name='size' /></div></div><div class='field'><div class='name'>Offset:</div><div class='value'><input type='number' name='offset' /></div></div><div class='field'><button type='submit'>Submit</button></div></form></div><div class='block result'><h3>Search result</h3><textarea id='searchResult' disabled='disabled' readonly='readonly'></textarea></div></div>"
    };
    this.init = function() {
        $("section.content").append(this.templates.wrap);

        var myCodeMirror1 = CodeMirror.fromTextArea(document.getElementById('searchQuery'), {
            lineNumbers: true,
            mode: "text/x-pgsql",
            matchBrackets: true,
            theme: "mdn-like"
        });
        var myCodeMirror2 = CodeMirror.fromTextArea(document.getElementById('searchResult'), {
            lineNumbers: true,
            mode: "javascript",
            matchBrackets: true,
            theme: "mdn-like"
        });
        $("#queryExecute button[type=\"submit\"]").on("click", function() {
            var $this = $(this);
            $("#numberResult").remove();
            $this.after("<span style='margin-left: 10px;font-weight: bold;' id='executingText'>Exeuting...</span>");
            var params = {
                query: myCodeMirror1.getValue()
            };
            var size = $("#queryExecute input[name=\"size\"]").val(),
                offset = $("#queryExecute input[name=\"offset\"]").val();
            if (size) {
                params.size = size;
            }
            if (offset) {
                params.size = offset;
            }
            ERPScan.API.query("queries", "execute", {
                params: params,
                callback: function(response) {
                    myCodeMirror2.clearHistory();
                    myCodeMirror2.setValue(JSON.stringify(response, "", 4));
                    $("#executingText").remove();
                    if (response.length != null) {
                        $this.after("<span style='margin-left: 10px;' id='numberResult'>Number of result: <b>" + response.length + "</b></span>");
                    }
                },
                type: "GET"
            });
            return false;
        })
    };
}